////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// TCalendarEx, TDateTimePickEx \[Xt@C Ver.2.0                        //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
{
  TCalendarEx̓ȃvpeB
    CalendarType  : J_[\`iETEEOENENj
    FormatTitle   : ^Cg\`iDateTimeToStringExQƁj
    FormatMonth   : \`iDateTimeToStringExQƁj
    FormatDayName : j\`iDateTimeToStringExQƁj
    FormatDate    : \`iDateTimeToStringExQƁj
    MonthRows     : \siN\EN\̂ݗLj
    MonthCols     : \񐔁iN\EN\̂ݗLj
    TrailJump     : OEւ̈ړ̗Li\EN\EN\̂ݗLj
    TrailColor    : OE̓t̐Fi\EN\EN\̂ݗLj
    TrailMask     : OE̓t̕\@i\EN\EN\̂ݗLj
    ShowCursor    : tH[JX̂tɃJ[\\邩ۂ
    ShowDayName   : j\邩ۂ
    ShowTodayRect : iVXetjɈ݂͂\邩ۂ
    AutoRowCount  : PɊ܂܂T̐vZ邩ۂ
    Schedules     : XPW[ꗗiTScheduleshNXw肷j
    CalendarFonts : J_[ɊւtHgѐF
    CurrentDate   : tH[JX̂t
    CurrentYear   : tH[JX̂t̔N
    CurrentMonth  : tH[JX̂ť
    CurrentDay    : tH[JX̂t̓
    FirstDayOfWeek: T̊Jnj
    ShowButton    : Oړ{^̗Li^CgL̏ꍇ̂݁j
    ShowTitle     : ^Cg̗L
    SynchroDate   : XPW[LJ_[̓t𓯊邩ۂ
    OnDateChange  : tH[JX̂tύXƂɎsCxg
    OnDateSelect  : }EXœtIƂɎsCxg
    OnNextBtnClick: {^ƂɎsCxg
    OnPrevBtnClick: O{^ƂɎsCxg
}
{
  TDateTimePickEx̓ȃvpeB
    Associate     : AgJ_[iTCustomCalendarhNXw肷j
    CalAlignment  : J_[̉\ʒu
    CalendarHeight: \J_[̍
    CalendarWidth : \J_[̕
    DateMode      : {^`iR{{bNX܂͏㉺{^j
    CalendarOnForm: tH[ɃJ_[\
}
unit CalendarEx;

interface

uses
  Windows, SysUtils, Classes, ComCtrls, Graphics, CalendarBase, SpinEditEx,
  CsvTables;

type
  //J_[\`iETEEOENENj
  TCalendarType = (ctDay, ctWeek, ctMonth, ctTrailMonth, ctHalfYear, ctYear);

  //OE̕\@i\EŒEʏE}XNORE}XNANDj
  TTrailMask = (tmHidden, tmSolid, tmNormal, tmMaskOr, tmMaskAnd);

  //XPW[CSVXg
  TScheduleList = class(TSchedules)
  private
    { Private 錾 }
    FScheduleList: TStrings;
    procedure SetScheduleList(Value: TStrings);
  protected
    { Protected 錾 }
    procedure ScheduleChange(Sender: TObject);
    procedure OpenData(OpenDataSet: TCsvDataSet); reintroduce; override;
    procedure PostData(PostDataSet: TCsvDataSet); reintroduce; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property ScheduleList: TStrings read FScheduleList write SetScheduleList;
  end;

  //XPW[CSVt@C
  TScheduleFile = class(TSchedules)
  private
    { Private 錾 }
    FScheduleFile: TFileName;
    procedure SetScheduleFile(const Value: TFileName);
  protected
    { Protected 錾 }
    procedure OpenData(OpenDataSet: TCsvDataSet); reintroduce; override;
    procedure PostData(PostDataSet: TCsvDataSet); reintroduce; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property ScheduleFile: TFileName read FScheduleFile write SetScheduleFile;
  end;

  //XPW[iCalendar
  TScheduleICal = class(TSchedules)
  private
    { Private 錾 }
    FScheduleICal: TFileName;
    procedure SetScheduleICal(const Value: TFileName);
  protected
    { Protected 錾 }
    procedure OpenData(OpenDataSet: TCsvDataSet); reintroduce; override;
    procedure PostData(PostDataSet: TCsvDataSet); reintroduce; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property ScheduleICal: TFileName read FScheduleICal write SetScheduleICal;
  end;

  //JX^J_[
  TCustomCalendar = class(TCalendarBase)
  private
    { Private 錾 }
    FCalType: TCalendarType;
    FMonthCols: Byte;
    FFormatTitle: String;
    FFormatMonth: String;
    FFormatDayName: String;
    FFormatDate: String;
    FTrailMask: TTrailMask;
    FTrailColor: TColor;
    FTrailJump: Boolean;
    FShowCursor: Boolean;
    FShowDayName: Boolean;
    FShowTodayRect: Boolean;
    FAutoRowCount: Boolean;
    function GetMonthRows: Byte;
    function GetMonthCols: Byte;
    procedure SetCalendarType(const Value: TCalendarType);
    procedure SetFormatTitle(const Value: String);
    procedure SetFormatMonth(const Value: String);
    procedure SetFormatDayName(const Value: String);
    procedure SetFormatDate(const Value: String);
    procedure SetMonthRows(const Value: Byte);
    procedure SetMonthCols(const Value: Byte);
    procedure SetTrailJump(const Value: Boolean);
    procedure SetTrailColor(const Value: TColor);
    procedure SetTrailMask(const Value: TTrailMask);
    procedure SetShowCursor(const Value: Boolean);
    procedure SetShowDayName(const Value: Boolean);
    procedure SetShowTodayRect(const Value: Boolean);
    procedure SetAutoRowCount(const Value: Boolean);
  protected
    { Protected 錾 }
    function GetTopLeftMonth: Word;
    function GetTopLeftDate(const AMonth: Word): LongInt;
    function GetRowCount(const AMonth: Word): Integer;
    procedure CalcMonthRowCol(FixNum: Byte; out Temp1, Temp2: Byte);
    function GetMousePointDate(X, Y: Integer; out NewValue: LongInt): Boolean; override;
    procedure JumpToNextButton;
    procedure JumpToPrevButton;
    procedure JumpToWheelDown(AShift: Boolean);
    procedure JumpToWheelUp(AShift: Boolean);
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    procedure DoNextBtnClick; override;
    procedure DoPrevBtnClick; override;
    procedure DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect); override;
    procedure DrawYear(ACanvas: TCanvas; ARect: TRect);
    procedure DrawTrailMonth(ACanvas: TCanvas; ARect: TRect);
    procedure DrawMonth(AMonth: Integer; ACanvas: TCanvas; ARect: TRect);
    procedure DrawWeek(ACanvas: TCanvas; ARect: TRect);
    procedure DrawDayName(JD: Longint; ACanvas: TCanvas; ARect: TRect);
    procedure DrawMonthDate(JD: Longint; AMonth: Integer; ACanvas: TCanvas; ARect: TRect); overload;
    procedure DrawWeekDate(JD: Longint; ACanvas: TCanvas; ARect: TRect); overload;
    procedure DrawDate(ACanvas: TCanvas; ARect: TRect); overload;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    procedure MouseToBox(X, Y: Integer; var Mon, Col, Row: Integer); overload;
    procedure MouseToBox(X, Y: Integer; var Col, Row: Integer); overload;
    procedure MouseToBox(Y: Integer; var Row: Integer); overload;

    property CalendarType: TCalendarType read FCalType write SetCalendarType default ctMonth;
    property FormatTitle: String read FFormatTitle write SetFormatTitle;
    property FormatMonth: String read FFormatMonth write SetFormatMonth;
    property FormatDayName: String read FFormatDayName write SetFormatDayName;
    property FormatDate: String read FFormatDate write SetFormatDate;
    property MonthRows: Byte read GetMonthRows write SetMonthRows stored False;
    property MonthCols: Byte read GetMonthCols write SetMonthCols default 1;
    property TrailJump: Boolean read FTrailJump write SetTrailJump default True;
    property TrailColor: TColor read FTrailColor write SetTrailColor default clSilver;
    property TrailMask: TTrailMask read FTrailMask write SetTrailMask default tmSolid;
    property ShowCursor: Boolean read FShowCursor write SetShowCursor default True;
    property ShowDayName: Boolean read FShowDayName write SetShowDayName default True;
    property ShowTodayRect: Boolean read FShowTodayRect write SetShowTodayRect default True;
    property AutoRowCount: Boolean read FAutoRowCount write SetAutoRowCount default False;
  published
    { Published 錾 }
  end;

  //J_[dw
  TCalendarEx = class(TCustomCalendar)
  published
    { Published 錾 }
    property CalendarType;
    property FormatTitle;
    property FormatMonth;
    property FormatDayName;
    property FormatDate;
    property MonthRows;
    property MonthCols;
    property TrailJump;
    property TrailColor;
    property TrailMask;
    property ShowCursor;
    property ShowDayName;
    property ShowTodayRect;
    property AutoRowCount;

    property CalendarFonts;
    property CurrentDate;
    property CurrentYear;
    property CurrentMonth;
    property CurrentDay;
    property FirstDayOfWeek;
    //property JulianDate;
    property Schedules;
    property ShowButton;
    property ShowTitle;
    property SynchroDate;
    property OnDateChange;
    property OnDateSelect;
    property OnNextBtnClick;
    property OnPrevBtnClick;

    property Align;
    property Anchors;
    //property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind;
    property BorderStyle;
    //property Color;
    property Constraints;
    property Ctl3D;
    property Cursor;
    property Enabled;
    //property Font;
    property ParentCtl3D;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnConstrainedResize;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
    property OnResize;
    property OnStartDrag;
  end;

  TDateTimePickEx = class(TDateTimeSpin)
  private
    { Private 錾 }
    FAssociate: TCustomCalendar;
    FCalAlign: TDTCalAlignment;
    FCalendarOnForm: Boolean;
    FCalHeight: Integer;
    FCalWidth: Integer;
    FDateMode: TDTDateMode;
    FDropDown: Boolean;
    procedure SetAssociate(Value: TCustomCalendar);
    procedure SetDateMode(Value: TDTDateMode);
    procedure SetCalendarOnForm(Value: Boolean);
    procedure SetDropDown(Value: Boolean);
  protected
    { Protected 錾 }
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetEnabled(Value: Boolean); override;
    procedure SetKind(Value: TDateTimeKind); override;
    procedure DoUpClick(Sender: TObject); override;
    procedure DoDownClick(Sender: TObject); override;
    procedure CalcBtnHeight(var BtnTop, BtnHeight: Integer); override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure CalendarChange(Sender: TObject);
    procedure CalendarSelect(Sender: TObject);
    procedure CalendarLostFocus(Sender: TObject);
    property DroppedDown: Boolean read FDropDown write SetDropDown;
  published
    { Published 錾 }
    property Associate: TCustomCalendar read FAssociate write SetAssociate;
    property CalAlignment: TDTCalAlignment read FCalAlign write FCalAlign default dtaLeft;
    property CalendarOnForm: Boolean read FCalendarOnForm write SetCalendarOnForm default False;
    property CalendarHeight: Integer read FCalHeight write FCalHeight default 185;
    property CalendarWidth: Integer read FCalWidth write FCalWidth default 185;
    property DateMode: TDTDateMode read FDateMode write SetDateMode default dmComboBox;
  end;


implementation

uses DateUtils, Forms, JulianUtils, DateUtilsEx;

const
  YEAR_TITLE_FORMAT = 'YYYY"N"';
  MONTH_TITLE_FORMAT = YEAR_TITLE_FORMAT + 'MM""';
  WEEKLY_DATE_FORMAT = 'MM/DD';


////////////////////////////////////////////////////////////////////////////////
// TScheduleList                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TScheduleList.Create(AOwner: TComponent);
begin
  inherited;
  FScheduleList := TStringList.Create;
  TStringList(FScheduleList).OnChange := ScheduleChange;
end;

destructor TScheduleList.Destroy;
begin
  TStringList(FScheduleList).OnChange := nil;
  FScheduleList.Clear;
  FreeAndNil(FScheduleList);
  inherited;
end;

procedure TScheduleList.ScheduleChange(Sender: TObject);
begin
  Update;
  Repaint;
end;

procedure TScheduleList.SetScheduleList(Value: TStrings);
begin
  FScheduleList.Assign(Value);
end;

procedure TScheduleList.OpenData(OpenDataSet: TCsvDataSet);
begin
  OpenDataSet.Open(FScheduleList, True);
end;

procedure TScheduleList.PostData(PostDataSet: TCsvDataSet);
begin
  PostDataSet.Post(FScheduleList, True);
end;


////////////////////////////////////////////////////////////////////////////////
// TScheduleFile                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TScheduleFile.Create(AOwner: TComponent);
begin
  inherited;
  FScheduleFile := '';
end;

procedure TScheduleFile.SetScheduleFile(const Value: TFileName);
begin
  FScheduleFile := Value;
  Update;
  Repaint;
end;

procedure TScheduleFile.OpenData(OpenDataSet: TCsvDataSet);
begin
  OpenDataSet.Open(FScheduleFile, True);
end;

procedure TScheduleFile.PostData(PostDataSet: TCsvDataSet);
begin
  PostDataSet.Post(FScheduleFile, True);
end;


////////////////////////////////////////////////////////////////////////////////
// TScheduleICal                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TScheduleICal.Create(AOwner: TComponent);
begin
  inherited;
  FScheduleICal := '';
end;

procedure TScheduleICal.SetScheduleICal(const Value: TFileName);
begin
  FScheduleICal := Value;
  Update;
  Repaint;
end;

procedure TScheduleICal.OpenData(OpenDataSet: TCsvDataSet);
var
  bBeginVC, bBeginVE: Boolean;
  nCnt, nPos, nIdx: Integer;
  sText, sField, sValue: String;
  tSL: TStringList;
begin
  OpenDataSet.Open('', False);
  if not FileExists(FScheduleICal) then Exit;
  tSL := TStringList.Create;

  bBeginVC := False;
  bBeginVE := False;
  try
    tSL.LoadFromFile(FScheduleICal);
    for nCnt := 0 to tSL.Count - 1 do
    begin
      sText := tSL.Strings[nCnt];
      if (bBeginVC) and (AnsiPos('END:VCALENDAR', AnsiUpperCase(sText)) > 0) then
      begin
        bBeginVC := False;
        bBeginVE := False;
      end
      else if AnsiPos('BEGIN:VCALENDAR', AnsiUpperCase(sText)) > 0 then
      begin
        bBeginVC := True;
        bBeginVE := False;
      end
      else if bBeginVC then
      begin
        if bBeginVE and (AnsiPos('END:VEVENT', AnsiUpperCase(sText)) > 0) then
        begin
          bBeginVE := False;
        end
        else if AnsiPos('BEGIN:VEVENT', AnsiUpperCase(sText)) > 0 then
        begin
          bBeginVE := True;
          OpenDataSet.AppendRecord;
        end
        else if bBeginVE then
        begin
          nPos := AnsiPos(':', sText);
          if nPos > 0 then
          begin
            sField := Copy(sText, 1, nPos - 1);
            sValue := Copy(sText, nPos + 1, Length(sText));
            nPos := AnsiPos(';', sField);
            if nPos > 0 then sField := Copy(sField, 1, nPos - 1);
            nIdx := OpenDataSet.GetFieldIndex(sField);
            if nIdx < 0 then
            begin
              nIdx := OpenDataSet.FieldCount;
              OpenDataSet.FieldCount := nIdx + 1;
              OpenDataSet.FieldName[nIdx] := sField;
            end;
            OpenDataSet.FieldValue[nIdx] := sValue;
          end;
        end;
      end;
    end;
  finally
    FreeAndNil(tSL);
  end;
end;

procedure TScheduleICal.PostData(PostDataSet: TCsvDataSet);
var
  nCol: Integer;
  tSL: TStringList;
begin
  tSL := TStringList.Create;
  try
    tSL.Add('BEGIN:VCALENDAR');
    PostDataSet.First;
    while not PostDataSet.Eof do
    begin
      tSL.Add('BEGIN:VEVENT');
      for nCol := 0 to PostDataSet.FieldCount - 1 do
      begin
        if PostDataSet.FieldValue[nCol] <> '' then
          tSL.Add(PostDataSet.FieldName[nCol] + ':' + PostDataSet.FieldValue[nCol]);
      end;
      tSL.Add('END:VEVENT');
      PostDataSet.Next;
    end;
    tSL.Add('END:VCALENDAR');
  finally
    tSL.SaveToFile(FScheduleICal);
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// TCustomCalendar                                                            //
////////////////////////////////////////////////////////////////////////////////

//Create
constructor TCustomCalendar.Create(AOwner: TComponent);
begin
  inherited;
  FCalType := ctMonth;
  FMonthCols := 1;
  FTrailJump := True;
  FTrailColor := clSilver;
  FTrailMask := tmSolid;
  FShowTodayRect := True;
  FShowDayName := True;
  FShowCursor := True;
  FAutoRowCount := False;
end;

function TCustomCalendar.GetTopLeftMonth: Word;
begin
  //̌߂
  Result := 1;
  if (FCalType = ctHalfYear)and(CurrentMonth > 6) then Result := 7;
end;

function TCustomCalendar.GetTopLeftDate(const AMonth: Word): LongInt;
var
  Start: LongInt;
  Y, M, D: Word;
begin
  //e̍̓t߂
  DecodeJulianDay(JulianDate, Y, M, D);
  if (AMonth >= 1)and(AMonth <= 12) then
    M := AMonth
  else if AMonth > 12 then
  begin
    M := 1;
    Inc(Y);
  end
  else if AMonth < 1 then
  begin
    M := 12;
    Dec(Y);
  end;
  Start := EncodeJulianDay(Y, M, 1);
  Result := StartOfTheWeekJ(Start, ConvFirstDayOfWeek);
  if Result = Start then Dec(Result, 7);
end;

function TCustomCalendar.GetRowCount(const AMonth: Word): Integer;
var
  nDayCnt: Integer;
  Y, M, D: Word;
begin
  //e̍s߂
  if AutoRowCount then
  begin
    DecodeJulianDay(JulianDate, Y, M, D);
    if (AMonth >= 1)and(AMonth <= 12) then
      M := AMonth
    else if AMonth > 12 then
    begin
      M := 1;
      Inc(Y);
    end
    else if AMonth < 1 then
    begin
      M := 12;
      Dec(Y);
    end;
    nDayCnt := EncodeJulianDay(Y, M, DaysInAMonth(Y, M)) - GetTopLeftDate(AMonth);
    Result := nDayCnt div 7 + 2;
    if (nDayCnt + 1) mod 7 = 0 then Inc(Result);
  end
  else
    Result := 7;
  if not FShowDayName then Dec(Result);
end;

function TCustomCalendar.GetMousePointDate(X, Y: Integer; out NewValue: LongInt): Boolean;
var
  CM, CX, CY: Integer;
  TgtDT: LongInt;
  YY, MM, DD: Word;
begin
  Result := False;
  if Y <= GetTitleHeight then Exit;
  case FCalType of
  ctDay:
    begin
      NewValue := JulianDate;
      Result := True;
    end;
  ctWeek:
    begin
      MouseToBox(Y, CY);
      if CY < 0 then Exit;
      NewValue := StartOfTheWeekJ(JulianDate, ConvFirstDayOfWeek) + CY;
      Result := True;
    end;
  ctMonth,ctTrailMonth,ctHalfYear,ctYear:
    begin
      if FCalType = ctMonth then
      begin
        MouseToBox(X, Y, CX, CY);
        CM := CurrentMonth;
      end
      else
        MouseToBox(X, Y, CM, CX, CY);
      if CY <= 0 then Exit;
      TgtDT := GetTopLeftDate(CM) + CX + (CY - 1) * 7;
      DecodeJulianDay(TgtDT, YY, MM, DD);
      if (TrailJump)or(MM = CM) then
      begin
        NewValue := TgtDT;
        Result := True;
      end;
    end;
  end;
end;

procedure TCustomCalendar.MouseToBox(X, Y: Integer; var Mon, Col, Row: Integer);
var
  MonCol, MonRow: Integer;
  DaysWidth, DaysHeight, TitleHeight: Integer;
begin
  TitleHeight := GetTitleHeight;
  DaysWidth := ClientWidth;
  if ShowTitle then
  begin
    DaysHeight := ClientHeight - TitleHeight;
    Y := Y - TitleHeight;
  end
  else
    DaysHeight := ClientHeight;

  if FCalType <> ctTrailMonth then
  begin
    MonCol := 0;
    if DaysWidth > 0 then MonCol := X * MonthCols div DaysWidth;

    MonRow := 0;
    if DaysHeight > 0 then MonRow := Y * MonthRows div DaysHeight;

    Mon := MonRow * MonthCols + MonCol + GetTopLeftMonth;

    DaysWidth := DaysWidth div MonthCols;
    X := X - MonCol * DaysWidth;

    DaysHeight := DaysHeight div MonthRows;
    Y := Y - MonRow * DaysHeight;
  end
  else
  begin
    Mon := CurrentMonth;

    DaysWidth := DaysWidth div 3;
    if X < DaysWidth then
    begin
      DaysHeight := DaysHeight div 2;
      if Y < DaysHeight then
      begin
        Dec(Mon);
      end
      else
      begin
        Y := Y - DaysHeight;
        Inc(Mon);
      end;
    end
    else
    begin
      X := X - DaysWidth;
      DaysWidth := DaysWidth * 2;
    end;
  end;

  Col := 0;
  if DaysWidth > 0 then Col := Trunc(X * 7 / DaysWidth);

  Row := -1;
  DaysHeight := DaysHeight - TitleHeight;
  Y := Y - TitleHeight;
  if DaysHeight > 0 then
  begin
    Row := Trunc(Y * GetRowCount(Mon) / DaysHeight);
    if not FShowDayName then Inc(Row);
  end;
end;

procedure TCustomCalendar.MouseToBox(X, Y: Integer; var Col, Row: Integer);
var
  DaysHeight, TitleHeight: Integer;
begin
  Col := 0;
  if ClientWidth > 0 then Col := Trunc(X * 7 / ClientWidth);
  Row := -1;
  DaysHeight := ClientHeight;
  if ShowTitle then
  begin
    TitleHeight := GetTitleHeight;
    DaysHeight := DaysHeight - TitleHeight;
    Y := Y - TitleHeight;
  end;
  if DaysHeight > 0 then
  begin
    Row := Trunc(Y * GetRowCount(CurrentMonth) / DaysHeight);
    if not FShowDayName then Inc(Row);
  end;
end;

procedure TCustomCalendar.MouseToBox(Y: Integer; var Row: Integer);
var
  DaysHeight, TitleHeight: Integer;
begin
  Row := -1;
  DaysHeight := ClientHeight;
  if ShowTitle then
  begin
    TitleHeight := GetTitleHeight;
    DaysHeight := DaysHeight - TitleHeight;
    Y := Y - TitleHeight;
  end;
  if (Y > 0)and(DaysHeight > 0) then Row := Trunc(Y * 7 / DaysHeight);
end;

procedure TCustomCalendar.CalcMonthRowCol(FixNum: Byte; out Temp1, Temp2: Byte);
begin
  case FCalType of
  ctHalfYear:
    case FixNum of
    0,1: begin Temp1 := 1; Temp2 := 6; end;
    2:   begin Temp1 := 2; Temp2 := 3; end;
    3:   begin Temp1 := 3; Temp2 := 2; end;
    else begin Temp1 := 6; Temp2 := 1; end;
    end;
  ctYear:
    case FixNum of
    0,1: begin Temp1 := 1; Temp2 :=12; end;
    2:   begin Temp1 := 2; Temp2 := 6; end;
    3:   begin Temp1 := 3; Temp2 := 4; end;
    4:   begin Temp1 := 4; Temp2 := 3; end;
    5,6: begin Temp1 := 6; Temp2 := 2; end;
    else begin Temp1 :=12; Temp2 := 1; end;
    end;
  else
    Temp1 := 1;
    Temp2 := 1;
  end;
end;

function TCustomCalendar.GetMonthRows: Byte;
begin
  case FCalType of
  ctHalfYear:
    Result := 6 div FMonthCols;
  ctYear:
    Result := 12 div FMonthCols;
  else
    Result := 1;
  end;
end;

function TCustomCalendar.GetMonthCols: Byte;
begin
  Result := FMonthCols;
end;

procedure TCustomCalendar.JumpToNextButton;
begin
  case FCalType of
  ctDay     : JumpToNextDay;
  ctWeek    : JumpToNextWeek;
  ctMonth,ctTrailMonth: JumpToNextMonth;
  ctHalfYear: JumpToIncMonth(6);
  ctYear    : JumpToNextYear;
  end;
end;

procedure TCustomCalendar.JumpToPrevButton;
begin
  case FCalType of
  ctDay     : JumpToPrevDay;
  ctWeek    : JumpToPrevWeek;
  ctMonth,ctTrailMonth: JumpToPrevMonth;
  ctHalfYear: JumpToDecMonth(6);
  ctYear    : JumpToPrevYear;
  end;
end;

procedure TCustomCalendar.JumpToWheelDown(AShift: Boolean);
begin
  case FCalType of
  ctDay     : if AShift then JumpToNextWeek else JumpToNextDay;
  ctWeek    : if AShift then JumpToNextWeek else JumpToNextDay;
  ctMonth,ctTrailMonth: if AShift then JumpToNextMonth else JumpToNextWeek;
  ctHalfYear: if AShift then JumpToIncMonth(FMonthCols) else JumpToNextWeek;
  ctYear    : if AShift then JumpToIncMonth(FMonthCols) else JumpToNextWeek;
  end;
end;

procedure TCustomCalendar.JumpToWheelUp(AShift: Boolean);
begin
  case FCalType of
  ctDay     : if AShift then JumpToPrevWeek else JumpToPrevDay;
  ctWeek    : if AShift then JumpToPrevWeek else JumpToPrevDay;
  ctMonth,ctTrailMonth: if AShift then JumpToPrevMonth else JumpToPrevWeek;
  ctHalfYear: if AShift then JumpToDecMonth(FMonthCols) else JumpToPrevWeek;
  ctYear    : if AShift then JumpToDecMonth(FMonthCols) else JumpToPrevWeek;
  end;
end;

procedure TCustomCalendar.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  case Key of
  VK_LEFT :
    case FCalType of
    ctDay     : JumpToPrevDay;
    ctWeek    : JumpToPrevWeek;
    ctMonth,ctTrailMonth: if ssCtrl in Shift then JumpToPrevMonth else JumpToPrevDay;
    ctHalfYear: if ssCtrl in Shift then JumpToPrevMonth else JumpToPrevDay;
    ctYear    : if ssCtrl in Shift then JumpToPrevMonth else JumpToPrevDay;
    end;
  VK_RIGHT:
    case FCalType of
    ctDay     : JumpToNextDay;
    ctWeek    : JumpToNextWeek;
    ctMonth,ctTrailMonth: if ssCtrl in Shift then JumpToNextMonth else JumpToNextDay;
    ctHalfYear: if ssCtrl in Shift then JumpToNextMonth else JumpToNextDay;
    ctYear    : if ssCtrl in Shift then JumpToNextMonth else JumpToNextDay;
    end;
  VK_UP   :
    JumpToWheelUp(ssCtrl in Shift);
  VK_DOWN :
    JumpToWheelDown(ssCtrl in Shift);
  VK_PRIOR:
    JumpToPrevButton;
  VK_NEXT :
    JumpToNextButton;
  VK_HOME :
    case FCalType of
    ctWeek    : JumpToStartOfWeek;
    ctMonth,ctTrailMonth: JumpToStartOfMonth;
    ctHalfYear: JumpToStartOfHalf;
    ctYear    : JumpToStartOfYear;
    end;
  VK_END  :
    case FCalType of
    ctWeek    : JumpToEndOfWeek;
    ctMonth,ctTrailMonth: JumpToEndOfMonth;
    ctHalfYear: JumpToEndOfHalf;
    ctYear    : JumpToEndOfYear;
    end;
  VK_SPACE: JumpToToday;
  VK_RETURN, VK_ESCAPE: DoDateSelect;
  end;
end;

function TCustomCalendar.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelDown(Shift, MousePos);
  if Result then Exit;
  JumpToWheelDown(ssCtrl in Shift);
  Result := True;
end;

function TCustomCalendar.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelUp(Shift, MousePos);
  if Result then Exit;
  JumpToWheelUp(ssCtrl in Shift);
  Result := True;
end;

procedure TCustomCalendar.DoNextBtnClick;
begin
  inherited;
  JumpToNextButton;
end;

procedure TCustomCalendar.DoPrevBtnClick;
begin
  inherited;
  JumpToPrevButton;
end;

procedure TCustomCalendar.SetCalendarType(const Value: TCalendarType);
var
  TempC, TempR: Byte;
begin
  if FCalType = Value then Exit;
  if (FCalType = ctHalfYear)or(FCalType = ctYear) then
    TempC := FMonthCols
  else
    TempC := 3;
  FCalType := Value;
  CalcMonthRowCol(TempC, TempC, TempR);
  FMonthCols := TempC;
  Repaint;
end;

procedure TCustomCalendar.SetMonthRows(const Value: Byte);
var
  TempR, TempC: Byte;
begin
  CalcMonthRowCol(Value, TempR, TempC);
  if (MonthRows <> TempR)or(MonthCols <> TempC) then
  begin
    FMonthCols := TempC;
    Repaint;
  end;
end;

procedure TCustomCalendar.SetMonthCols(const Value: Byte);
var
  TempC, TempR: Byte;
begin
  CalcMonthRowCol(Value, TempC, TempR);
  if (MonthCols <> TempC)or(MonthRows <> TempR) then
  begin
    FMonthCols := TempC;
    Repaint;
  end;
end;

procedure TCustomCalendar.SetFormatTitle(const Value: String);
begin
  if FFormatTitle = Value then Exit;
  FFormatTitle := Value;
  if ShowTitle then Repaint;
end;

procedure TCustomCalendar.SetFormatMonth(const Value: String);
begin
  if FFormatMonth = Value then Exit;
  FFormatMonth := Value;
  Repaint;
end;

procedure TCustomCalendar.SetFormatDayName(const Value: String);
begin
  if FFormatDayName = Value then Exit;
  FFormatDayName := Value;
  Repaint;
end;

procedure TCustomCalendar.SetFormatDate(const Value: String);
begin
  if FFormatDate = Value then Exit;
  FFormatDate := Value;
  Repaint;
end;

procedure TCustomCalendar.SetTrailJump(const Value: Boolean);
begin
  FTrailJump := Value;
end;

procedure TCustomCalendar.SetTrailColor(const Value: TColor);
begin
  if FTrailColor = Value then Exit;
  FTrailColor := Value;
  if FTrailMask <> tmHidden then Repaint;
end;

procedure TCustomCalendar.SetTrailMask(const Value: TTrailMask);
begin
  if FTrailMask = Value then Exit;
  FTrailMask := Value;
  Repaint;
end;

procedure TCustomCalendar.SetShowCursor(const Value: Boolean);
begin
  if FShowCursor = Value then Exit;
  FShowCursor := Value;
  Repaint;
end;

procedure TCustomCalendar.SetShowDayName(const Value: Boolean);
begin
  if FShowDayName = Value then Exit;
  FShowDayName := Value;
  Repaint;
end;

procedure TCustomCalendar.SetShowTodayRect(const Value: Boolean);
begin
  if FShowTodayRect = Value then Exit;
  FShowTodayRect := Value;
  Repaint;
end;

procedure TCustomCalendar.SetAutoRowCount(const Value: Boolean);
begin
  if FAutoRowCount = Value then Exit;
  FAutoRowCount := Value;
  Repaint;
end;

procedure TCustomCalendar.DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect);
var
  DispText: String;
  Y2: Integer;
  Rct: TRect;

  function GetFormatTitleDef: String;
  begin
    if FFormatTitle = '' then
    begin
      case FCalType of
      ctWeek,ctTrailMonth,ctHalfYear,ctYear:
        Result := YEAR_TITLE_FORMAT;
      else//ctDay,ctMonth:
        Result := MONTH_TITLE_FORMAT;
      end;
    end
    else
      Result := FFormatTitle;
  end;
begin
  inherited;

  Y2 := ARect.Top;
  if ShowTitle then
  begin
    Y2 := Y2 + GetTitleHeight;
    Rct := Rect(ARect.Left, ARect.Top, ARect.Right, Y2);
    DispText := GetFormatTitleDef;
    JulianDayToString(DispText, DispText, JulianDate);
    DrawTitle(DispText, ACanvas, Rct);
  end;
  Rct := Rect(ARect.Left, Y2, ARect.Right, ARect.Bottom);

  case FCalType of
  ctDay:
    DrawDate(ACanvas, Rct);
  ctWeek:
    DrawWeek(ACanvas, Rct);
  ctMonth:
    DrawMonth(CurrentMonth, ACanvas, Rct);
  ctTrailMonth:
    DrawTrailMonth(ACanvas, Rct);
  ctHalfYear,ctYear:
    DrawYear(ACanvas, Rct);
  end;
end;

procedure TCustomCalendar.DrawYear(ACanvas: TCanvas; ARect: TRect);
var
  Col, Row, XM1, YM1, XM2, YM2, HMonth, WMonth, HBorder, WBorder: Integer;
  MonthNum, YearNum, TopLeft: Word;
  MonRct: TRect;
  DispText: String;
begin
  YearNum := CurrentYear;
  TopLeft := GetTopLeftMonth;
  HMonth := (ARect.Bottom - ARect.Top) div MonthRows - 1;
  WMonth := (ARect.Right - ARect.Left) div MonthCols - 1;
  HBorder := (ARect.Bottom - ARect.Top) mod MonthRows;
  WBorder := (ARect.Right - ARect.Left) mod MonthCols;
  HBorder := ARect.Top + HBorder div 2 + 1;
  WBorder := ARect.Left + WBorder - WBorder div 2;

  YM2 := HBorder;
  for Row := 0 to MonthRows - 1 do
  begin
    YM1 := YM2;
    if Row > 0 then Inc(YM1);
    YM2 := YM1 + HMonth;
    XM2 := WBorder;
    for Col := 0 to MonthCols - 1 do
    begin
      XM1 := XM2;
      if Col > 0 then Inc(XM1);
      XM2 := XM1 + WMonth;
      MonRct := Rect(XM1, YM1, XM2, YM1 + GetTitleHeight);
      MonthNum := TopLeft + Row * MonthCols + Col;

      if FFormatMonth <> '' then
        JulianDayToString(DispText, FFormatMonth, EncodeJulianDay(YearNum, MonthNum, 1))
      else
        DispText := IntToStr(MonthNum);
      DrawTitle(DispText, ACanvas, MonRct);

      MonRct := Rect(XM1, YM1 + GetTitleHeight, XM2, YM2);
      DrawMonth(MonthNum, ACanvas, MonRct);
    end;
  end;
end;


procedure TCustomCalendar.DrawTrailMonth(ACanvas: TCanvas; ARect: TRect);
var
  XM1, YM1, XM2, YM2, HMonth, WMonth, HBorder, WBorder: Integer;
  Y, M, D, MonthNum, YearNum: Word;
  MonRct: TRect;
  DispText: String;
begin
  DecodeJulianDay(JulianDate, Y, M, D);

  HMonth := (ARect.Bottom - ARect.Top) div 2 - 1;
  WMonth := (ARect.Right - ARect.Left) div 3 - 1;
  HBorder := (ARect.Bottom - ARect.Top) mod 2;
  WBorder := (ARect.Right - ARect.Left) mod 3;
  HBorder := ARect.Top + HBorder div 2 + 1;
  WBorder := ARect.Left + WBorder - WBorder div 2;

  XM1 := WBorder;
  XM2 := XM1 + WMonth;

  //O
  YM1 := HBorder;
  YM2 := YM1 + HMonth;

  MonRct := Rect(XM1, YM1, XM2, YM1 + GetTitleHeight);
  if M > 1 then
  begin
    YearNum := Y;
    MonthNum := M - 1;
  end
  else
  begin
    YearNum := Y - 1;
    MonthNum := 12;
  end;
  if FFormatMonth <> '' then
    JulianDayToString(DispText, FFormatMonth, StartOfAMonthJ(YearNum, MonthNum))
  else
    DispText := IntToStr(MonthNum);
  DrawTitle(DispText, ACanvas, MonRct);

  MonRct := Rect(XM1, YM1 + GetTitleHeight, XM2, YM2);
  DrawMonth(M - 1, ACanvas, MonRct);

  //
  YM1 := YM2 + 1;
  YM2 := YM1 + HMonth;

  MonRct := Rect(XM1, YM1, XM2, YM1 + GetTitleHeight);
  if M < 12 then
  begin
    YearNum := Y;
    MonthNum := M + 1;
  end
  else
  begin
    YearNum := Y + 1;
    MonthNum := 1;
  end;
  if FFormatMonth <> '' then
    JulianDayToString(DispText, FFormatMonth, StartOfAMonthJ(YearNum, MonthNum))
  else
    DispText := IntToStr(MonthNum);
  DrawTitle(DispText, ACanvas, MonRct);

  MonRct := Rect(XM1, YM1 + GetTitleHeight, XM2, YM2);
  DrawMonth(M + 1, ACanvas, MonRct);

  //
  XM1 := XM2 + 1;
  XM2 := ARect.Right - WBorder;
  YM1 := HBorder;

  MonRct := Rect(XM1, YM1, XM2, YM1 + GetTitleHeight);
  if FFormatMonth <> '' then
    JulianDayToString(DispText, FFormatMonth, StartOfAMonthJ(Y, M))
  else
    DispText := IntToStr(M);
  DrawTitle(DispText, ACanvas, MonRct);

  MonRct := Rect(XM1, YM1 + GetTitleHeight, XM2, YM2);
  DrawMonth(M, ACanvas, MonRct);
end;

procedure TCustomCalendar.DrawMonth(AMonth: Integer; ACanvas: TCanvas; ARect: TRect);
var
  i, j, X1, Y1, X2, Y2, H, W, RowCnt: Integer;
  TopLeft: LongInt;
  Rct: TRect;
begin
  TopLeft := GetTopLeftDate(AMonth);
  RowCnt := GetRowCount(AMonth);
  H := Trunc((ARect.Bottom - ARect.Top) / RowCnt + 0.5);
  W := Trunc((ARect.Right - ARect.Left) / 7);
  Y2 := ARect.Top;
  Dec(RowCnt);
  for j := 0 to RowCnt do
  begin
    Y1 := Y2;
    if j = 0 then
      Y2 := ARect.Bottom - H * RowCnt - 1
    else
      Y2 := Y1 + H;

    X2 := ARect.Left;
    for i := 0 to 6 do
    begin
      X1 := X2;
      if i = 6 then
        X2 := ARect.Right
      else if i = 0 then
        X2 := (ARect.Right + X1 - W * 5) div 2
      else
        X2 := X1 + W;
      Rct := Rect(X1, Y1, X2, Y2);

      if not FShowDayName then
        DrawMonthDate(TopLeft + j * 7 + i, AMonth, ACanvas, Rct)
      else if j > 0 then
        DrawMonthDate(TopLeft + (j - 1) * 7 + i, AMonth, ACanvas, Rct)
      else
        DrawDayName(TopLeft + i, ACanvas, Rct);
    end;

    if (FShowDayName)and(j = 0)and(CalendarFonts.TitleBack <> clDefault) then
    begin
      ACanvas.Pen.Style := psSolid;
      ACanvas.Pen.Color := CalendarFonts.TitleBack;
      ACanvas.MoveTo(ARect.Left + 1, Y2);
      ACanvas.LineTo(ARect.Right - 1, Y2);
      Inc(Y2);
    end;
  end;
end;

procedure TCustomCalendar.DrawDayName(JD: Longint; ACanvas: TCanvas; ARect: TRect);
var
  DispText: String;
begin
  if FFormatDayName <> '' then
    JulianDayToString(DispText, FFormatDayName, JD)
  else if FShowDayName then
    DispText := ShortDayNames[DayOfWeekJ(JD)]
  else
    Exit;
  ACanvas.Brush.Style := bsClear;
  ACanvas.Font.Assign(CalendarFonts.DaysText);
  ACanvas.Font.Color := GetFontOfWeek(DayOfTheWeekJ(JD));
  DrawText(ACanvas.Handle, PChar(DispText), -1, ARect,
           DT_NOCLIP or DT_SINGLELINE or DT_VCENTER or DT_CENTER);
end;

procedure TCustomCalendar.DrawMonthDate(JD: Longint; AMonth: Integer; ACanvas: TCanvas; ARect: TRect);
var
  DispText: String;
  Y, M, D: Word;
  bTrail: Boolean;
begin
  DecodeJulianDay(JD, Y, M, D);
  ACanvas.Font.Assign(CalendarFonts.DaysText);
  ACanvas.Font.Color := GetFontOfDate(JD);

  if AMonth > 12 then
    bTrail := (M <> 1)or(Y <> CurrentYear + 1)
  else if AMonth < 1 then
    bTrail := (M <> 12)or(Y <> CurrentYear - 1)
  else
    bTrail := (M <> AMonth)or(Y <> CurrentYear);

  if bTrail then
  begin
    case TrailMask of
    tmHidden:  Exit;
    tmSolid:   ACanvas.Font.Color := ColorToRGB(FTrailColor);
    tmMaskOr:  ACanvas.Font.Color := ColorToRGB(ACanvas.Font.Color) or ColorToRGB(FTrailColor);
    tmMaskAnd: ACanvas.Font.Color := ColorToRGB(ACanvas.Font.Color) and ColorToRGB(FTrailColor);
    {tmNormal: Ȃ}
    end;
  end
  else
  begin
    if (ShowCursor)and(JD = JulianDate) then
    begin
      ACanvas.Brush.Style := bsSolid;
      ACanvas.Brush.Color := ACanvas.Font.Color;
      ACanvas.FillRect(ARect);
      ACanvas.Font.Color := Color;
    end;
    if (ShowTodayRect)and(JD = DateToJulianDay(Today)) then
    begin
      ACanvas.Brush.Style := bsClear;
      ACanvas.Pen.Style := psSolid;
      ACanvas.Pen.Color := clRed;
      ACanvas.Rectangle(ARect);
    end;
  end;

  ACanvas.Brush.Style := bsClear;
  if FFormatDate = '' then
    DispText := IntToStr(D)
  else
    JulianDayToString(DispText, FFormatDate, JD);
  DrawText(ACanvas.Handle, PChar(DispText), -1, ARect,
           DT_NOCLIP or DT_SINGLELINE or DT_VCENTER or DT_CENTER);
end;

procedure TCustomCalendar.DrawWeek(ACanvas: TCanvas; ARect: TRect);
var
  i, j, X, Y1, Y2, H: Integer;
  Rct: TRect;
begin
  i := StartOfTheWeekJ(JulianDate, ConvFirstDayOfWeek);
  H := Trunc((ARect.Bottom - ARect.Top) / 7 + 0.5);
  if FShowDayName then
    X := ARect.Left + GetTitleHeight + 3
  else
    X := ARect.Left;
  Y2 := ARect.Top;
  for j := 0 to 6 do
  begin
    Y1 := Y2;
    if j = 6 then
      Y2 := ARect.Bottom
    else if j = 0 then
      Y2 := (ARect.Bottom + Y1 - H * 5) div 2
    else
      Y2 := Y1 + H;

    if FShowDayName then
    begin
      Rct := Rect(ARect.Left, Y1, X, Y2);
      DrawDayName(i + j, ACanvas, Rct);

      ACanvas.Pen.Style := psSolid;
      ACanvas.Pen.Color := CalendarFonts.TitleBack;
      ACanvas.MoveTo(X - 1, Y1 + 1);
      ACanvas.LineTo(X - 1, Y2 - 1);
    end;

    Rct := Rect(X, Y1, ARect.Right, Y2);
    DrawWeekDate(i + j, ACanvas, Rct);

    if (j < 6)and(CalendarFonts.TitleBack <> clDefault) then
    begin
      ACanvas.Pen.Style := psSolid;
      ACanvas.Pen.Color := CalendarFonts.TitleBack;
      ACanvas.MoveTo(ARect.Left + 1, Y2);
      ACanvas.LineTo(ARect.Right - 1, Y2);
    end;
  end;
end;

procedure TCustomCalendar.DrawWeekDate(JD: Longint; ACanvas: TCanvas; ARect: TRect);
var
  DispText: String;
  X: Integer;
  Rct: TRect;
  bMulti: Boolean;
begin
  ACanvas.Font.Assign(CalendarFonts.DaysText);
  ACanvas.Font.Color := GetFontOfDate(JD);

  if (ShowCursor)and(JD = JulianDate) then
  begin
    ACanvas.Brush.Style := bsSolid;
    ACanvas.Brush.Color := ACanvas.Font.Color;
    ACanvas.FillRect(ARect);
    ACanvas.Font.Color := Self.Color;
  end;
  ACanvas.Brush.Style := bsClear;
  if (ShowTodayRect)and(JD = DateToJulianDay(Today)) then
  begin
    ACanvas.Pen.Style := psSolid;
    ACanvas.Pen.Color := clRed;
    ACanvas.Rectangle(ARect);
  end;

  X := Abs(ACanvas.Font.Height) - 1;
  if FFormatDate = '' then
    JulianDayToString(DispText, WEEKLY_DATE_FORMAT, JD)
  else
    JulianDayToString(DispText, FFormatDate, JD);
  Rct := Rect(ARect.Left + 2, ARect.Top, ARect.Left + X * 3, ARect.Bottom);
  DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, DT_NOCLIP or DT_SINGLELINE or DT_VCENTER);

  bMulti := (ARect.Bottom - ARect.Top > X * 2);
  DispText := GetTextOfDate(JD, bMulti);
  Rct := Rect(ARect.Left + X * 4, ARect.Top, ARect.Right, ARect.Bottom);
  if bMulti then
    DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, DT_NOCLIP)
  else
    DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, DT_NOCLIP or DT_SINGLELINE or DT_VCENTER);
end;

procedure TCustomCalendar.DrawDate(ACanvas: TCanvas; ARect: TRect);
var
  DispText: String;
  Y1, Y2, Y3, H: Integer;
  Rct: TRect;
  nFlags: Longint;
begin
  nFlags := DT_NOCLIP or DT_CENTER;
  ACanvas.Font.Assign(CalendarFonts.DaysText);

  ACanvas.Brush.Style := bsClear;
  if (ShowTodayRect)and(JulianDate = DateToJulianDay(Today)) then
  begin
    ACanvas.Pen.Style := psSolid;
    ACanvas.Pen.Color := clRed;
    ACanvas.Rectangle(ARect);
  end;

  H := Trunc((ARect.Bottom - ARect.Top) / 7);
  Y1 := ARect.Top + H;
  if FFormatMonth <> '' then
  begin
    JulianDayToString(DispText, FFormatMonth, JulianDate);
    Rct := Rect(ARect.Left, ARect.Top, ARect.Right, Y1);
    DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, nFlags);
  end;

  Y2 := ARect.Bottom - H;
  DispText := GetTextOfDate(JulianDate, True);
  if DispText <> '' then
  begin
    Rct := Rect(ARect.Left, Y2, ARect.Right, ARect.Bottom);
    DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, nFlags);
  end;

  ACanvas.Font.Color := GetFontOfDate(JulianDate);
  Y3 := Y2 - H;
  if FShowDayName then
  begin
    if FFormatDayName <> '' then
      JulianDayToString(DispText, FFormatDayName, JulianDate)
    else
      DispText := LongDayNames[DayOfWeekJ(JulianDate)];
    Rct := Rect(ARect.Left, Y3, ARect.Right, Y2);
    DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, nFlags);
  end;

  ACanvas.Font.Height := H * 4;
  Rct := Rect(ARect.Left, Y1, ARect.Right, Y3);
  if FFormatDate = '' then
    DispText := IntToStr(DayOfJulian(JulianDate))
  else
    JulianDayToString(DispText, FFormatDate, JulianDate);
  DrawText(ACanvas.Handle, PChar(DispText), -1, Rct, nFlags);
end;


////////////////////////////////////////////////////////////////////////////////
// TDateTimePickEx                                                            //
////////////////////////////////////////////////////////////////////////////////

constructor TDateTimePickEx.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCalAlign := dtaLeft;
  FCalendarOnForm := False;
  FDateMode := dmComboBox;
  FAssociate := nil;
end;

destructor TDateTimePickEx.Destroy;
begin
  DroppedDown := False;
  FAssociate := nil;
  inherited Destroy;
end;

procedure TDateTimePickEx.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FAssociate) then
  begin
    FAssociate := nil;
  end;
end;

procedure TDateTimePickEx.CalendarChange(Sender: TObject);
begin
  //tXV
  if Assigned(FAssociate) then DateTime := FAssociate.CurrentDate;
end;

procedure TDateTimePickEx.CalendarSelect(Sender: TObject);
begin
  //IŃJ_[
  DroppedDown := False;
end;

procedure TDateTimePickEx.CalendarLostFocus(Sender: TObject);
begin
  //XgtH[JXŃJ_[
  DroppedDown := False;
end;

procedure TDateTimePickEx.SetAssociate(Value: TCustomCalendar);
var
  objParent: TCustomForm;
begin
  if FAssociate <> Value then
  begin
    //̘A
    if Assigned(FAssociate) then
    begin
      FAssociate := nil;
    end;

    //VK̘Aݒ
    if Assigned(Value) then
    try
      objParent := GetParentForm(Self);
      if Assigned(objParent) and (objParent <> Value.Parent) then
      begin
        Value.ManualDock(objParent);
      end;
      Value.Visible := False;

      FAssociate := Value;
    except
      FAssociate := nil;
    end;
  end;
end;

procedure TDateTimePickEx.SetEnabled(Value: Boolean);
begin
  if Enabled <> Value then
  begin
    inherited SetEnabled(Value);
    //ɃJ_[JĂ
    if DroppedDown then DroppedDown := False;
  end;
end;

procedure TDateTimePickEx.SetKind(Value: TDateTimeKind);
begin
  if Kind <> Value then
  begin
    inherited SetKind(Value);
    //ɃJ_[JĂ
    if DroppedDown then
      DroppedDown := False
    else
      Self.SetBtnRect;
  end;
end;

procedure TDateTimePickEx.SetDateMode(Value: TDTDateMode);
begin
  if FDateMode <> Value then
  begin
    FDateMode := Value;
    //ɃJ_[JĂ
    if DroppedDown then
      DroppedDown := False
    else
      Self.SetBtnRect;
  end;
end;

procedure TDateTimePickEx.SetCalendarOnForm(Value: Boolean);
begin
  if FCalendarOnForm <> Value then
  begin
    //ɃJ_[JĂ
    if DroppedDown then DroppedDown := False;
    FCalendarOnForm := Value;
  end;
end;

procedure TDateTimePickEx.SetDropDown(Value: Boolean);
var
  CalXY, MinXY, MaxXY: TPoint;
  nCalW, nCalH: Integer;
  objParent: TCustomForm;
begin
  if Assigned(FAssociate) and (FDropDown <> Value) then
  begin
    FDropDown := Value;
    objParent := GetParentForm(Self);
    if Value then
    begin
      if Assigned(objParent) and (objParent = FAssociate.Parent) then
      try
        //cso̓tɈړ
        Checked := True;
        FAssociate.CurrentDate := DateTime;

        //Cxgݒ
        FAssociate.OnInternalSelect := CalendarSelect;
        FAssociate.OnInternalChange := CalendarChange;
        FAssociate.OnInternalExit := CalendarLostFocus;

        //e̗Lȗ̈擾
        MinXY := Point(0,0);
        if FCalendarOnForm then
        begin
          MinXY := ParentToClient(MinXY, objParent);
          MaxXY := Point(objParent.ClientWidth, objParent.ClientHeight);
          MaxXY := ParentToClient(MaxXY, objParent);
        end
        else
        begin
          MinXY := ScreenToClient(MinXY);
          MaxXY := Point(Screen.Width, Screen.Height);
          MaxXY := ScreenToClient(MaxXY);
        end;

        //J_[̃TCY擾
        if FCalWidth > 0 then
          nCalW := FCalWidth
        else
          nCalW := FAssociate.Width;
        if FCalHeight > 0 then
          nCalH := FCalHeight
        else
          nCalH := FAssociate.Height;

        //ʒu
        if FCalAlign = dtaLeft then
        begin
          if MinXY.X > 0 then
            CalXY.X := MinXY.X
          else
            CalXY.X := 1;
          if MaxXY.X < nCalW + CalXY.X then
            CalXY.X := MaxXY.X - nCalW;
        end
        else
        begin
          if MaxXY.X < nCalW then
            CalXY.X := MaxXY.X - nCalW - 2
          else
            CalXY.X := Width - nCalW - 3;
          if MinXY.X > CalXY.X then
            CalXY.X := MinXY.X;
        end;

        //cʒu
        if MaxXY.Y < nCalH + Height then
          CalXY.Y := - nCalH - 1
        else
          CalXY.Y := Height - 3;
        if MinXY.Y > CalXY.Y then
          CalXY.Y := MinXY.Y;

        //J_[\
        if FCalendarOnForm then
        begin
          CalXY := ClientToParent(CalXY, objParent);
          FAssociate.SetBounds(CalXY.X, CalXY.Y, nCalW, nCalH);
          FAssociate.SetZOrder(True);
        end
        else
        begin
          CalXY := ClientToScreen(CalXY);
          FAssociate.SetBounds(CalXY.X, CalXY.Y, nCalW, nCalH);
          if FAssociate.ManualFloat(FAssociate.BoundsRect) then
          begin
            if FAssociate.Parent is TCalendarDockForm then
            begin
              (FAssociate.Parent as TCalendarDockForm).OnDeactivate := CalendarSelect;
            end;
          end;
        end;
        FAssociate.Visible := True;
        if FAssociate.CanFocus then FAssociate.SetFocus;
      except
        SetDropDown(False);
      end;
    end
    else
    begin
      //Cxg
      FAssociate.OnInternalSelect := nil;
      FAssociate.OnInternalChange := nil;
      FAssociate.OnInternalExit := nil;

      //J_[\
      FAssociate.Visible := False;

      //eIuWFNgݒ
      if not FCalendarOnForm then
      begin
        if Assigned(objParent) and (objParent <> FAssociate.Parent) then
        begin
          FAssociate.ManualDock(objParent);
        end;
      end;
    end;
    Self.SetBtnRect;
  end;
end;

//{^
procedure TDateTimePickEx.CalcBtnHeight(var BtnTop, BtnHeight: Integer);
begin
  inherited CalcBtnHeight(BtnTop, BtnHeight);
  if (FDateMode <> dmUpDown)and(Kind <> dtkTime) then
  begin
    if not FDropDown then Dec(BtnTop, BtnHeight);
    BtnHeight := BtnHeight * 2;
  end;
end;

procedure TDateTimePickEx.DoUpClick(Sender: TObject);
begin
  if ReadOnly then Exit;
  if CanFocus then SetFocus;
  if (FDateMode = dmUpDown)or(Kind = dtkTime)or(Sender = Self) then
    inherited DoIncrement(1)
  else
    DroppedDown := False;
end;

procedure TDateTimePickEx.DoDownClick(Sender: TObject);
begin
  if ReadOnly then Exit;
  if CanFocus then SetFocus;
  if (FDateMode = dmUpDown)or(Kind = dtkTime)or(Sender = Self) then
    inherited DoIncrement(-1)
  else
    DroppedDown := True;
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H
