////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// TDigitalClock, TAnalogClock \[Xt@C Ver.2.0                         //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
unit ClockCtrls;

interface

//Of[V̎gpEsgp؂ւRpCXCb`
{$DEFINE USE_GRADIENT}

uses
  Windows, Messages, Classes, Controls, ExtCtrls, Graphics, TexturePanel;

const
  DEF_REFRESHTIME = 250;
  DEF_COLOR_FRAME = clMaroon;
  DEF_COLOR_SHORT = clNavy;
  DEF_COLOR_LONG  = clBlue;
  DEF_COLOR_SWEEP = clGreen;
  DEF_COLOR_STONE = clGray;

type
  //fW^\liEt̂݁Ê݁j
  TDigitStyle = (dsDateTime, dsDateOnly, dsTimeOnly);
  //fW^\ʒuiȂEEOj
  TDigitPosition = (dpNone, dpInner, dpOuter);
  //AiOvgliȂE~E`Epێlp`Ep`j
  TFrameStyle = (fsNone, fsCircle, fsSquare, fsRound, fsPolygon);
  //AiOvjlijE_EEHEj
  THandStyle = (hsNeedle, hsStick, hsSting, hsQuarry, hsArrow);
  //AiOvΗliȂEEEEArAE[}j
  TStoneStyle = (ssNone, ssSmall, ssMidium, ssLarge, ssArabic, ssRoman);

  //fW^v
{$IFDEF USE_GRADIENT}
  TDigitalClock = class(TTextureControl)
{$ELSE}
  TDigitalClock = class(TBitmapControl)
{$ENDIF}
  private
    { Private 錾 }
    FTimeOffset: Integer;
    FDigitStyle: TDigitStyle;
    FDateFormat: String;
    FTimeFormat: String;
    FRefreshTimer: TTimer;
    function GetRefreshTime: Cardinal;
    procedure SetRefreshTime(const Value: Cardinal);
    procedure SetTimeOffset(const Value: Integer);
    procedure SetDigitStyle(const Value: TDigitStyle);
    procedure SetDateFormat(const Value: String);
    procedure SetTimeFormat(const Value: String);
    procedure TimerExpired(Sender: TObject);
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMContextMenu(var Message: TWMContextMenu); message WM_CONTEXTMENU;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure SetEnabled(Value: Boolean); override;
    procedure DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect); override;
    procedure DrawClock(ACanvas: TCanvas; ARect: TRect; ADateTime: TDateTime); dynamic;
    procedure DrawDate(ACanvas: TCanvas; ARect: TRect; ADate: TDateTime); dynamic;
    procedure DrawTime(ACanvas: TCanvas; ARect: TRect; ATime: TDateTime); dynamic;
    procedure DrawString(ACanvas: TCanvas; ARect: TRect; const AString: String);
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property DigitStyle: TDigitStyle read FDigitStyle write SetDigitStyle default dsTimeOnly;
    property DateFormat: String read FDateFormat write SetDateFormat;
    property TimeFormat: String read FTimeFormat write SetTimeFormat;
    property TimeOffset: Integer read FTimeOffset write SetTimeOffset;
    property RefreshTime: Cardinal read GetRefreshTime write SetRefreshTime default DEF_REFRESHTIME;
    property Align;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind;
    property BorderStyle;
    property Color;
    property Constraints;
    property Ctl3D;
    property Cursor;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
  end;

  //AiOv
  TAnalogClock = class(TDigitalClock)
  private
    { Private 錾 }
    FColorClockFrame: TColor;
    FColorShortHand: TColor;
    FColorLongHand: TColor;
    FColorSweepHand: TColor;
    FColorClockStone: TColor;
    FDigitPosition: TDigitPosition;
    FSmoothMove: Boolean;
    FFrameStyle: TFrameStyle;
    FHandStyle: THandStyle;
    FStoneStyle: TStoneStyle;
    FShowSweepHand: Boolean;
    procedure SetColorClockFrame(const Value: TColor);
    procedure SetColorShortHand(const Value: TColor);
    procedure SetColorLongHand(const Value: TColor);
    procedure SetColorSweepHand(const Value: TColor);
    procedure SetColorClockStone(const Value: TColor);
    procedure SetDigitPosition(const Value: TDigitPosition);
    procedure SetShowSweepHand(const Value: Boolean);
    procedure SetSmoothMove(const Value: Boolean);
    procedure SetFrameStyle(const Value: TFrameStyle);
    procedure SetHandStyle(const Value: THandStyle);
    procedure SetStoneStyle(const Value: TStoneStyle);
  protected
    { Protected 錾 }
    procedure DrawClock(ACanvas: TCanvas; ARect: TRect; ADateTime: TDateTime); override;
    procedure DrawAnalog(ACanvas: TCanvas; ARect: TRect; ATime: TDateTime); dynamic;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property ColorClockFrame: TColor read FColorClockFrame write SetColorClockFrame default DEF_COLOR_FRAME;
    property ColorShortHand: TColor read FColorShortHand write SetColorShortHand default DEF_COLOR_SHORT;
    property ColorLongHand: TColor read FColorLongHand write SetColorLongHand default DEF_COLOR_LONG;
    property ColorSweepHand: TColor read FColorSweepHand write SetColorSweepHand default DEF_COLOR_SWEEP;
    property ColorClockStone: TColor read FColorClockStone write SetColorClockStone default DEF_COLOR_STONE;
    property DigitPosition: TDigitPosition read FDigitPosition write SetDigitPosition default dpInner;
    property ShowSweepHand: Boolean read FShowSweepHand write SetShowSweepHand default True;
    property SmoothMove: Boolean read FSmoothMove write SetSmoothMove default True;
    property FrameStyle: TFrameStyle read FFrameStyle write SetFrameStyle default fsSquare;
    property HandStyle: THandStyle read FHandStyle write SetHandStyle default hsNeedle;
    property StoneStyle: TStoneStyle read FStoneStyle write SetStoneStyle default ssMidium;
  end;

implementation

uses SysUtils, Math, DateUtils, DateUtilsEx;


////////////////////////////////////////////////////////////////////////////////
// TDigitalClock                                                              //
////////////////////////////////////////////////////////////////////////////////

//Create
constructor TDigitalClock.Create(AOwner: TComponent);
begin
  inherited;
  TabStop := True;
  FDigitStyle := dsTimeOnly;
  FDateFormat := '';
  FTimeFormat := '';
  FTimeOffset := 0;
  FRefreshTimer := TTimer.Create(Self);
  FRefreshTimer.Interval := DEF_REFRESHTIME;
  FRefreshTimer.Enabled := Self.Enabled;
  FRefreshTimer.OnTimer := TimerExpired;
end;

//Destroy
destructor TDigitalClock.Destroy;
begin
  if Assigned(FRefreshTimer) then FreeAndNil(FRefreshTimer);
  inherited;
end;

//^C}[
procedure TDigitalClock.TimerExpired(Sender: TObject);
begin
  if csDesigning in ComponentState then Exit;
  Repaint;
end;

//CreateParams
procedure TDigitalClock.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.Style := Params.Style or WS_TABSTOP;
end;

//WMLButtonDown
procedure TDigitalClock.WMLButtonDown(var Message: TWMLButtonDown);
begin
  if CanFocus then SetFocus;
  inherited;
end;

//WMContextMenu
procedure TDigitalClock.WMContextMenu(var Message: TWMContextMenu);
begin
  if CanFocus then SetFocus;
  inherited;
end;

//XV擾
function TDigitalClock.GetRefreshTime: Cardinal;
begin
  if Assigned(FRefreshTimer) then
    Result := FRefreshTimer.Interval
  else
    Result := DEF_REFRESHTIME;
end;

//XVݒ
procedure TDigitalClock.SetRefreshTime(const Value: Cardinal);
begin
  if Assigned(FRefreshTimer) then
  begin
    if FRefreshTimer.Interval = Value then Exit;
    FRefreshTimer.Interval := Value;
  end;
end;

//ݒ
procedure TDigitalClock.SetTimeOffset(const Value: Integer);
begin
  if FTimeOffset = Value then Exit;
  FTimeOffset := Value;
  Repaint;
end;

//fW^\
procedure TDigitalClock.SetDigitStyle(const Value: TDigitStyle);
begin
  if FDigitStyle = Value then Exit;
  FDigitStyle := Value;
  Repaint;
end;

//t\tH[}bg
procedure TDigitalClock.SetDateFormat(const Value: String);
begin
  if FDateFormat = Value then Exit;
  FDateFormat := Value;
  Repaint;
end;

//\tH[}bg
procedure TDigitalClock.SetTimeFormat(const Value: String);
begin
  if FTimeFormat = Value then Exit;
  FTimeFormat := Value;
  Repaint;
end;

//L
procedure TDigitalClock.SetEnabled(Value: Boolean);
begin
  inherited;
  if Assigned(FRefreshTimer) then FRefreshTimer.Enabled := Value;
end;

//`s
procedure TDigitalClock.DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect);
begin
  inherited;

  //v`
  DrawClock(ACanvas, ARect, IncMinute(Now, FTimeOffset));
end;

//v`
procedure TDigitalClock.DrawClock(ACanvas: TCanvas; ARect: TRect; ADateTime: TDateTime);
var
  Y: Integer;
begin
  //fW^`
  case FDigitStyle of
  dsDateTime:
    begin
      Y := (ARect.Top + ARect.Bottom) div 2;
      DrawDate(ACanvas, Rect(ARect.TopLeft, Point(ARect.Right, Y)), ADateTime);
      DrawTime(ACanvas, Rect(Point(ARect.Left, Y), ARect.BottomRight), ADateTime);
    end;
  dsDateOnly:
    begin
      DrawDate(ACanvas, ARect, ADateTime);
    end;
  dsTimeOnly:
    begin
      DrawTime(ACanvas, ARect, ADateTime);
    end;
  end;
end;

//fW^t`
procedure TDigitalClock.DrawDate(ACanvas: TCanvas; ARect: TRect; ADate: TDateTime);
var
  sDate: String;
begin
  if FDateFormat <> '' then
    sDate := FormatDateTimeEx(FDateFormat, ADate)
  else
    sDate := DateToStr(ADate);

  if sDate <> '' then
  begin
    ACanvas.Brush.Style := bsClear;
    ACanvas.Font.Assign(Self.Font);
    DrawString(ACanvas, ARect, sDate);
  end;
end;

//fW^`
procedure TDigitalClock.DrawTime(ACanvas: TCanvas; ARect: TRect; ATime: TDateTime);
var
  sTime: String;
begin
  if FTimeFormat <> '' then
    sTime := FormatDateTimeEx(FTimeFormat, ATime)
  else
    sTime := TimeToStr(ATime);

  if sTime <> '' then
  begin
    ACanvas.Brush.Style := bsClear;
    ACanvas.Font.Assign(Self.Font);
    DrawString(ACanvas, ARect, sTime);
  end;
end;

//`
procedure TDigitalClock.DrawString(ACanvas: TCanvas; ARect: TRect; const AString: String);
begin
  DrawText(ACanvas.Handle, PChar(AString), -1, ARect,
           DT_NOCLIP or DT_SINGLELINE or DT_VCENTER or DT_CENTER);
end;


////////////////////////////////////////////////////////////////////////////////
// TAnalogClock                                                               //
////////////////////////////////////////////////////////////////////////////////

//Create
constructor TAnalogClock.Create(AOwner: TComponent);
begin
  inherited;
  FColorClockFrame := DEF_COLOR_FRAME;
  FColorShortHand := DEF_COLOR_SHORT;
  FColorLongHand := DEF_COLOR_LONG;
  FColorSweepHand := DEF_COLOR_SWEEP;
  FColorClockStone := DEF_COLOR_STONE;
  FDigitPosition := dpInner;
  FFrameStyle := fsSquare;
  FHandStyle := hsNeedle;
  FStoneStyle := ssMidium;
  FShowSweepHand := True;
  FSmoothMove := True;
  Width := 185;
  Height := 185;
end;

//gF
procedure TAnalogClock.SetColorClockFrame(const Value: TColor);
begin
  if FColorClockFrame = Value then Exit;
  FColorClockFrame := Value;
  Repaint;
end;

//jF
procedure TAnalogClock.SetColorShortHand(const Value: TColor);
begin
  if FColorShortHand = Value then Exit;
  FColorShortHand := Value;
  Repaint;
end;

//jF
procedure TAnalogClock.SetColorLongHand(const Value: TColor);
begin
  if FColorLongHand = Value then Exit;
  FColorLongHand := Value;
  Repaint;
end;

//bjF
procedure TAnalogClock.SetColorSweepHand(const Value: TColor);
begin
  if FColorSweepHand = Value then Exit;
  FColorSweepHand := Value;
  Repaint;
end;

//ΐF
procedure TAnalogClock.SetColorClockStone(const Value: TColor);
begin
  if FColorClockStone = Value then Exit;
  FColorClockStone := Value;
  Repaint;
end;

//fW^\ʒu
procedure TAnalogClock.SetDigitPosition(const Value: TDigitPosition);
begin
  if FDigitPosition = Value then Exit;
  FDigitPosition := Value;
  Repaint;
end;

//bj`敪
procedure TAnalogClock.SetShowSweepHand(const Value: Boolean);
begin
  if FShowSweepHand = Value then Exit;
  FShowSweepHand := Value;
  Repaint;
end;

//jړ`敪
procedure TAnalogClock.SetSmoothMove(const Value: Boolean);
begin
  if FSmoothMove = Value then Exit;
  FSmoothMove := Value;
  Repaint;
end;

//g`
procedure TAnalogClock.SetFrameStyle(const Value: TFrameStyle);
begin
  if FFrameStyle = Value then Exit;
  FFrameStyle := Value;
  Repaint;
end;

//j`
procedure TAnalogClock.SetHandStyle(const Value: THandStyle);
begin
  if FHandStyle = Value then Exit;
  FHandStyle := Value;
  Repaint;
end;

//Ό`
procedure TAnalogClock.SetStoneStyle(const Value: TStoneStyle);
begin
  if FStoneStyle = Value then Exit;
  FStoneStyle := Value;
  Repaint;
end;

//v`
procedure TAnalogClock.DrawClock(ACanvas: TCanvas; ARect: TRect; ADateTime: TDateTime);
var
  Y1, Y2: Integer;
begin
  //fW^`
  Y1 := ARect.Top;
  Y2 := ARect.Bottom;
  if FDigitPosition = dpOuter then
  begin
    if FDigitStyle in [dsDateTime, dsDateOnly] then
    begin
      Y1 := Abs(Font.Height) + 4;
      DrawDate(ACanvas, Rect(ARect.TopLeft, Point(ARect.Right, Y1)), ADateTime);
    end;
    if FDigitStyle in [dsDateTime, dsTimeOnly] then
    begin
      Y2 := ARect.Bottom - Abs(Font.Height) - 4;
      DrawTime(ACanvas, Rect(Point(ARect.Left, Y2), ARect.BottomRight), ADateTime);
    end;
  end;

  //AiO`
  DrawAnalog(ACanvas, Rect(ARect.Left, Y1, ARect.Right, Y2), ADateTime);

  //̏ꍇ͌ŕ`悷ijŌȂȂ邽߁j
  if FDigitPosition = dpInner then
  begin
    if FDigitStyle in [dsDateTime, dsDateOnly] then
    begin
      DrawDate(ACanvas, Rect(ARect.Left, Y1 + 8, ARect.Right, (Y1 + Y2) div 2), ADateTime);
    end;
    if FDigitStyle in [dsDateTime, dsTimeOnly] then
    begin
      DrawTime(ACanvas, Rect(ARect.Left, (Y1 + Y2) div 2, ARect.Right, Y2 - 8), ADateTime);
    end;
  end;
end;

//AiOv`
procedure TAnalogClock.DrawAnalog(ACanvas: TCanvas; ARect: TRect; ATime: TDateTime);
const
  ClockStoneArabic : array[1..12] of String =
     ('1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12');
  ClockStoneRoman : array[1..12] of String =
     ('I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X', 'XI', 'XII');
var
  nLen, nSize, nWidth: Integer;
  rCenter, rPoint: TPoint;
  rRct, rStn: TRect;
  fCycle: Extended;
  hhh, nnn, sss, zzz: Word;

  function RoundOff(x: Extended): Integer;
  begin
    if x >= 0 then
      Result := Trunc(x + 0.5)
    else
      Result := Trunc(x - 0.5);
  end;

  function GetPointX(ARadian: Extended; ALen: Integer; ABaseX: Integer): Integer;
  begin
    Result := ABaseX - RoundOff(Sin(-ARadian) * ALen);
  end;

  function GetPointY(ARadian: Extended; ALen: Integer; ABaseY: Integer): Integer;
  begin
    Result := ABaseY - RoundOff(Cos(ARadian) * ALen);
  end;

  function GetPoint(ACycle: Extended; ALen: Integer; ABase: TPoint): TPoint;
  var
    fRadian: Extended;
  begin
    fRadian := CycleToRad(ACycle);
    Result := Point(GetPointX(fRadian, ALen, ABase.X), GetPointY(fRadian, ALen, ABase.Y));
  end;
begin
  //_vZ
  rCenter := Point((ARect.Left + ARect.Right) div 2, (ARect.Top + ARect.Bottom) div 2);
  nLen := Min(ARect.Right - ARect.Left, ARect.Bottom - ARect.Top) div 2 - 1;
  rRct := Rect(rCenter.X - nLen, rCenter.Y - nLen, rCenter.X + nLen, rCenter.Y + nLen);
  nWidth := nLen div 50;

  //g`
  if FFrameStyle <> fsNone then
  begin
    ACanvas.Brush.Style := bsClear;
    ACanvas.Pen.Color := FColorClockFrame;
    for nSize := nWidth + 3 downto nWidth + 2 do
    begin
      ACanvas.Pen.Width := nSize - 1;
      case FFrameStyle of
      fsCircle:
        ACanvas.Ellipse(rRct);
      fsSquare:
        ACanvas.Rectangle(rRct);
      fsRound:
        begin
          nLen := (rRct.Right - rRct.Left) div 2;
          ACanvas.RoundRect(rRct.Left, rRct.Top, rRct.Right, rRct.Bottom, nLen, nLen);
        end;
      fsPolygon:
        begin
          nLen := (rRct.Right - rRct.Left) div 5 + nWidth;
          ACanvas.Polygon([Point(rCenter.X - nLen, rRct.Top), Point(rCenter.X + nLen, rRct.Top),
                           Point(rRct.Right, rCenter.Y - nLen), Point(rRct.Right, rCenter.Y + nLen),
                           Point(rCenter.X + nLen, rRct.Bottom), Point(rCenter.X - nLen, rRct.Bottom),
                           Point(rRct.Left, rCenter.Y + nLen), Point(rRct.Left, rCenter.Y - nLen)]);
        end;
      end;
      InflateRect(rRct, -nSize, -nSize);
    end;
  end;

  //Ε`
  nSize := nWidth + 2;
  InflateRect(rRct, -nSize, -nSize);
  if FStoneStyle <> ssNone then
  begin
    case FStoneStyle of
    ssSmall, ssMidium, ssLarge:
      begin
        ACanvas.Pen.Color := FColorClockStone;
        ACanvas.Pen.Width := 1;
        ACanvas.Brush.Color := FColorClockStone;
        ACanvas.Brush.Style := bsSolid;
        nLen := (rRct.Bottom - rRct.Top) div 2 - nWidth;
      end;
    ssArabic, ssRoman:
      begin
        nSize := Abs(Self.Font.Height) * 3 div 4;
        ACanvas.Font.Assign(Self.Font);
        ACanvas.Font.Height := nSize;
        ACanvas.Font.Color := FColorClockStone;
        ACanvas.Brush.Style := bsClear;
        nLen := (rRct.Bottom - rRct.Top - nSize) div 2 - 1;
      end;
    end;
    for hhh := 1 to 12 do
    begin
      fCycle := hhh / 12;
      rPoint := GetPoint(fCycle, nLen, rCenter);
      case FStoneStyle of
      ssSmall:
        ACanvas.Polygon([Point(rPoint.X - 1, rPoint.Y), Point(rPoint.X, rPoint.Y - 1),
                         Point(rPoint.X + 1, rPoint.Y), Point(rPoint.X, rPoint.Y + 1)]);
      ssMidium:
        begin
          nSize := nWidth div 2 + 2;
          rStn := Rect(rPoint.X - nSize, rPoint.Y - nSize, rPoint.X + nSize, rPoint.Y + nSize);
          ACanvas.Rectangle(rStn);
        end;
      ssLarge:
        begin
          if hhh mod 3 = 0 then
            nSize := nWidth + 3
          else
            nSize := nWidth + 2;
          rStn := Rect(rPoint.X - nSize, rPoint.Y - nSize, rPoint.X + nSize, rPoint.Y + nSize);
          ACanvas.Ellipse(rStn);
        end;
      ssArabic:
        begin
          rStn := Rect(rPoint.X - nSize, rPoint.Y - nSize, rPoint.X + nSize, rPoint.Y + nSize);
          DrawString(ACanvas, rStn, ClockStoneArabic[hhh]);
        end;
      ssRoman:
        begin
          rStn := Rect(rPoint.X - nSize, rPoint.Y - nSize, rPoint.X + nSize, rPoint.Y + nSize);
          DrawString(ACanvas, rStn, ClockStoneRoman[hhh]);
        end;
      end;
    end;
  end;

  //j`
  nSize := nWidth + 2;
  InflateRect(rRct, -nSize, -nSize);
  ACanvas.Brush.Style := bsSolid;

  //EEb擾
  DecodeTime(ATime, hhh, nnn, sss, zzz);

  //j
  ACanvas.Pen.Color := FColorLongHand;
  ACanvas.Brush.Color := FColorLongHand;
  nLen := (rRct.Bottom - rRct.Top) div 2;
  if FSmoothMove then
    fCycle := nnn / 60 + sss / 3600
  else
    fCycle := nnn / 60;
  rPoint := GetPoint(fCycle, nLen, rCenter);
  case FHandStyle of
  hsSting:
    begin
      nLen := nLen div 12 + nWidth;
      ACanvas.Pen.Width := 1;
      ACanvas.Polygon([rPoint, GetPoint(fCycle + 0.4, nLen, rCenter),
                               GetPoint(fCycle - 0.4, nLen, rCenter)]);
    end;
  hsQuarry:
    begin
      nSize := nLen div 8 + nWidth;
      nLen := nLen div 10 + nWidth;
      ACanvas.Pen.Width := 1;
      ACanvas.Polygon([rPoint, GetPoint(fCycle + 0.25, nLen, rCenter),
                               GetPoint(fCycle + 0.5, nSize, rCenter),
                               GetPoint(fCycle - 0.25, nLen, rCenter)]);
    end;
  hsNeedle:
    begin
      ACanvas.Pen.Width := nWidth div 2 + 2;
      ACanvas.Polyline([rPoint, rCenter]);
    end;
  hsStick:
    begin
      ACanvas.Pen.Width := nWidth * 2 + 3;
      ACanvas.Polyline([rPoint, rCenter]);
    end;
  hsArrow:
    begin
      nLen := nLen * 2 div 3;
      ACanvas.Pen.Width := 1;
      ACanvas.Polygon([rPoint, GetPoint(fCycle + 0.015, nLen, rCenter),
                               GetPoint(fCycle - 0.015, nLen, rCenter)]);
      ACanvas.Pen.Width := nWidth + 2;
      ACanvas.Polyline([GetPoint(fCycle, nLen, rCenter), rCenter]);
    end;
  end;

  //Zj
  ACanvas.Pen.Color := FColorShortHand;
  ACanvas.Brush.Color := FColorShortHand;
  nLen := (rRct.Bottom - rRct.Top) div 3;
  if FSmoothMove then
    fCycle := hhh / 12 + nnn / 720
  else
    fCycle := hhh / 12;
  rPoint := GetPoint(fCycle, nLen, rCenter);
  case FHandStyle of
  hsSting:
    begin
      nLen := nLen div 8 + nWidth;
      ACanvas.Pen.Width := 1;
      ACanvas.Polygon([rPoint, GetPoint(fCycle + 0.35, nLen, rCenter),
                               GetPoint(fCycle - 0.35, nLen, rCenter)]);
    end;
  hsQuarry:
    begin
      nSize := nLen div 7 + nWidth;
      nLen := nLen div 6 + nWidth;
      ACanvas.Pen.Width := 1;
      ACanvas.Polygon([rPoint, GetPoint(fCycle + 0.25, nLen, rCenter),
                               GetPoint(fCycle + 0.5, nSize, rCenter),
                               GetPoint(fCycle - 0.25, nLen, rCenter)]);
    end;
  hsNeedle:
    begin
      ACanvas.Pen.Width := nWidth div 2 + 3;
      ACanvas.Polyline([rPoint, rCenter]);
    end;
  hsStick:
    begin
      ACanvas.Pen.Width := nWidth * 2 + 4;
      ACanvas.Polyline([rPoint, rCenter]);
    end;
  hsArrow:
    begin
      nLen := nLen div 2;
      ACanvas.Pen.Width := 1;
      ACanvas.Polygon([rPoint, GetPoint(fCycle + 0.03, nLen, rCenter),
                               GetPoint(fCycle - 0.03, nLen, rCenter)]);
      ACanvas.Pen.Width := nWidth + 3;
      ACanvas.Polyline([GetPoint(fCycle, nLen, rCenter), rCenter]);
    end;
  end;

  //bj
  if FShowSweepHand then
  begin
    ACanvas.Pen.Color := FColorSweepHand;
    ACanvas.Brush.Color := FColorSweepHand;
    nLen := (rRct.Bottom - rRct.Top) div 2;
    if FSmoothMove then
      fCycle := sss / 60 + zzz / 60000
    else
      fCycle := sss / 60;
    rPoint := GetPoint(fCycle, nLen, rCenter);
    ACanvas.Pen.Width := nWidth div 2 + 1;
    ACanvas.Polyline([rPoint, rCenter]);
  end;

  ACanvas.Pen.Color := FColorClockFrame;
  ACanvas.Pen.Width := nWidth;
  rStn := Rect(rCenter.X - 2, rCenter.Y - 2, rCenter.X + 2, rCenter.Y + 2);
  ACanvas.Ellipse(rStn);
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H
