////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// CsvTables \[Xt@C Ver.2.0                                           //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
{
  TCsvField̓Ȋ֐EvpeB
    IsNull        : tB[h̒lNullȂTrueԂ֐
    CsvDataSet    : eIuWFNgiTCsvDataSetj
    FieldIndex    : tB[hCfbNX
    FieldName     : tB[h
    AsString      : tB[h̒lStringŎ擾܂͐ݒ肷
    AsInteger     : tB[h̒lIntegerŎ擾܂͐ݒ肷
    AsFloat       : tB[h̒lFloatŎ擾܂͐ݒ肷
    AsDateTime    : tB[h̒lDateTimeŎ擾܂͐ݒ肷
    Text          : tB[h̒l𕶎Ŏ擾܂͐ݒ肷
    OnGetText     : tB[h̒l𕶎Ŏ擾ۂɔCxg
    OnSetText     : tB[h̒l𕶎Őݒ肷ۂɔCxg
}
{
  TCsvDataSet̓Ȋ֐EvpeB
    Open          : CSVt@C܂͕񃊃XgJēǂݍ
    Refresh       : CSVt@C܂͕񃊃Xgǂݒ
    Post          : CSVt@C܂͕񃊃Xg֏o
    Close         : CSVt@C܂͕񃊃Xg
    First         : R[h̐擪փJ[\ړ
    Last          : R[h̖փJ[\ړ
    Prior         : ÕR[hփJ[\ړ
    Next          : ̃R[hփJ[\ړ
    Locate        : J[\ړiړȂE擪EEOEj
    AppendRecord  : փR[hǉ
    InsertRecord  : ݃J[\郌R[h̑OɃR[h}
    DeleteRecord  : ݃J[\郌R[h폜
    CheckFieldIndex : tB[hCfbNX݂TrueԂ
    CheckFieldName  : tB[h݂TrueԂ
    GetFieldIndex   : tB[htB[hCfbNX擾
    FieldByIndex    : tB[hCfbNXtB[hiTCsvFieldj擾
    FieldByName     : tB[htB[hiTCsvFieldj擾
    CreateField     : tB[hiTCsvFieldjǉ
    Bof           : ݂̃J[\擪ȂTrue
    Eof           : ݂̃J[\ȂTrue
    ActiveRecord  : ݃J[\郌R[h
    FieldCount    : tB[h擾܂͐ݒ肷
    FieldValue    : tB[hCfbNXw肵ătB[h̒l擾܂͐ݒ肷
    FieldValues   : tB[h̒l̃Xg擾܂͐ݒ肷
    FieldName     : tB[hCfbNXw肵ătB[h擾܂͐ݒ肷
    FieldNames    : tB[h̃Xg擾܂͐ݒ肷
}
{
  TCsvTable̓Ȋ֐EvpeB
    MoveTop       : ݃J[\郌R[h擪֕ёւ
    MoveBottom    : ݃J[\郌R[h𖖔֕ёւ
    MoveUp        : ݃J[\郌R[h֕ёւ
    MoveDown      : ݃J[\郌R[h֕ёւ
    FileName      : ݑΏۂƂĂt@C
    UseHeader     : Xg̈sڂtB[hƂĈۂ
    EncryptByte   : ȈՈÍsꍇ̓L[ƂȂ鐔liBytejw肷
    Selected      : ݃J[\郌R[h̑IԂ擾܂͐ݒ肷
}
unit CsvTables;

interface

uses
  Classes, SysUtils;

type
  TCsvDataSet = class;
  TCsvField = class;

  TLocateMode = (lmNone, lmFirst, lmLast, lmPrior, lmNext);

  TCsvFieldGetTextEvent = procedure(Sender: TCsvField; var Text: String) of object;
  TCsvFieldSetTextEvent = procedure(Sender: TCsvField; const Text: String) of object;

  TCsvField = class
  private
    FCsvDataSet: TCsvDataSet;
    FFieldIndex: Integer;
    FFieldName: String;
    FOnGetText: TCsvFieldGetTextEvent;
    FOnSetText: TCsvFieldSetTextEvent;
  protected
    function GetAsString: String;
    procedure SetAsString(const Value: String);
    function GetAsInteger: Integer;
    procedure SetAsInteger(const Value: Integer);
    function GetAsFloat: Extended;
    procedure SetAsFloat(const Value: Extended);
    function GetAsDateTime: TDateTime;
    procedure SetAsDateTime(const Value: TDateTime);
    function GetAsText: String;
    procedure SetAsText(const Value: String);
  public
    constructor Create(AOwner: TCsvDataSet; AIndex: Integer); overload;
    constructor Create(AOwner: TCsvDataSet; AIndex: Integer; AName: String); overload;
    function IsNull: Boolean;
    property CsvDataSet: TCsvDataSet read FCsvDataSet;
    property FieldIndex: Integer read FFieldIndex;
    property FieldName: String read FFieldName;
    property AsString: String read GetAsString write SetAsString;
    property AsInteger: Integer read GetAsInteger write SetAsInteger;
    property AsFloat: Extended read GetAsFloat write SetAsFloat;
    property AsDateTime: TDateTime read GetAsDateTime write SetAsDateTime;
    property Text: String read GetAsText write SetAsText;
    property OnGetText: TCsvFieldGetTextEvent read FOnGetText write FOnGetText;
    property OnSetText: TCsvFieldSetTextEvent read FOnSetText write FOnSetText;
  end;

  TCsvDataSet = class(TStringList)
  private
    FFields: array of TCsvField;
    FBof: Boolean;
    FEof: Boolean;
    FActiveRecord: Integer;
    function GetFieldCount: Integer;
    procedure SetFieldCount(const Value: Integer);
    function GetFieldValue(Index: Integer): String;
    procedure SetFieldValue(Index: Integer; const Value: String);
    function GetFieldName(Index: Integer): String;
    procedure SetFieldName(Index: Integer; const Value: String);
    function GetFieldValues: String;
    procedure SetFieldValues(const Value: String);
    function GetFieldNames: String;
    procedure SetFieldNames(const Value: String);
  protected
    procedure InitFlag;
    procedure ResetFlag;
    procedure ReadOpenList(FWorkList: TStringList; AHeader: Boolean; AEncrypt: Byte);
    procedure WritePostList(FWorkList: TStringList; AHeader: Boolean; AEncrypt: Byte);
    function OpenFile(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte): Boolean;
    function OpenList(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte): Boolean;
    function PostFile(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte): Boolean;
    function PostList(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte): Boolean;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Open(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    procedure Open(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    procedure Refresh(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    procedure Refresh(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    procedure Post(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    procedure Post(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    procedure Close;
    procedure First;
    procedure Last;
    procedure Prior;
    procedure Next;
    procedure Locate(const AMode: TLocateMode);
    function AppendRecord(const Value: String = ''): Integer;
    function InsertRecord(const Value: String = ''): Integer;
    function DeleteRecord: Integer;
    function CheckFieldIndex(AFieldIndex: Integer): Boolean;
    function CheckFieldName(const AFieldName: String): Boolean;
    function GetFieldIndex(const AFieldName: String): Integer;
    function FieldByIndex(const AFieldIndex: Integer): TCsvField;
    function FieldByName(const AFieldName: String): TCsvField;
    function CreateField(const AFieldName: String): Integer;
    property Bof: Boolean read FBof;
    property Eof: Boolean read FEof;
    property ActiveRecord: Integer read FActiveRecord;
    property FieldCount: Integer read GetFieldCount write SetFieldCount;
    property FieldValue[Index: Integer]: String read GetFieldValue write SetFieldValue;
    property FieldValues: String read GetFieldValues write SetFieldValues;
    property FieldName[Index: Integer]: String read GetFieldName write SetFieldName;
    property FieldNames: String read GetFieldNames write SetFieldNames;
  end;

  TCsvTable = class(TCsvDataSet)
  private
    FFileName: TFileName;
    FUseHeader: Boolean;
    FEncryptByte: Byte;
    function GetSelected: Boolean;
    procedure SetSelected(Value: Boolean);
  public
    constructor Create; overload;
    constructor Create(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte = 0); overload;
    function Open: Boolean;
    function Refresh: Boolean;
    function Post: Boolean;
    procedure MoveTop;
    procedure MoveBottom;
    procedure MoveUp;
    procedure MoveDown;
    property FileName: TFileName read FFileName write FFileName;
    property UseHeader: Boolean read FUseHeader write FUseHeader;
    property EncryptByte: Byte read FEncryptByte write FEncryptByte;
    property Selected: Boolean read GetSelected write SetSelected;
  end;

implementation


{ TCsvField }

(*
 @́FCreate
 ߂lF
 @F
 @@\F
 @lFPublic
*)
constructor TCsvField.Create(AOwner: TCsvDataSet; AIndex: Integer);
begin
  Create(AOwner, AIndex, '');
end;

constructor TCsvField.Create(AOwner: TCsvDataSet; AIndex: Integer; AName: String);
begin
  inherited Create;
  FCsvDataSet := AOwner;
  FFieldIndex := AIndex;
  FFieldName := AName;
end;

(*
 @́FIsNull
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvField.IsNull: Boolean;
begin
  Result := (GetAsString <> '');
end;

(*
 @́FGetAsString
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvField.GetAsString: String;
begin
  Result := '';
  if FCsvDataSet = nil then Exit;
  Result := FCsvDataSet.FieldValue[FFieldIndex];
end;

(*
 @́FSetAsString
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvField.SetAsString(const Value: String);
begin
  if FCsvDataSet = nil then Exit;
  FCsvDataSet.FieldValue[FFieldIndex] := Value;
end;

(*
 @́FGetAsInteger
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvField.GetAsInteger: Integer;
begin
  Result := StrToInt(GetAsString);
end;

(*
 @́FSetAsInteger
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvField.SetAsInteger(const Value: Integer);
begin
  SetAsString(IntToStr(Value));
end;

(*
 @́FGetAsFloat
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvField.GetAsFloat: Extended;
begin
  Result := StrToFloat(GetAsString);
end;

(*
 @́FSetAsFloat
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvField.SetAsFloat(const Value: Extended);
begin
  SetAsString(FloatToStr(Value));
end;

(*
 @́FGetAsDateTime
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvField.GetAsDateTime: TDateTime;
begin
  Result := StrToDateTime(GetAsString);
end;

(*
 @́FSetAsDateTime
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvField.SetAsDateTime(const Value: TDateTime);
begin
  SetAsString(DateTimeToStr(Value));
end;

(*
 @́FGetAsText
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvField.GetAsText: String;
begin
  if Assigned(FOnGetText) then FOnGetText(Self, Result) else Result := GetAsString;
end;

(*
 @́FSetAsText
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvField.SetAsText(const Value: String);
begin
  if Assigned(FOnSetText) then FOnSetText(Self, Value) else SetAsString(Value);
end;


{ TCsvDataSet }

(*
 @́FCreate
 ߂lF
 @F
 @@\F
 @lFPublic
*)
constructor TCsvDataSet.Create;
begin
  inherited Create;

  //tB[hݒ
  SetLength(FFields, 0);

  //tO
  InitFlag;
end;

(*
 @́FDestroy
 ߂lF
 @F
 @@\F
 @lFPublic
*)
destructor TCsvDataSet.Destroy;
var
  nIdx: Integer;
begin
  //tB[hj
  for nIdx := High(FFields) downto Low(FFields) do
  begin
    FreeAndNil(FFields[nIdx]);
  end;
  SetLength(FFields, 0);

  inherited;
end;

(*
 @́FInitFlag
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvDataSet.InitFlag;
begin
  FActiveRecord := -1;
  FBof := True;
  FEof := True;
end;

(*
 @́FResetFlag
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvDataSet.ResetFlag;
begin
  if FActiveRecord >= Self.Count then
    FActiveRecord := Self.Count - 1
  else if FActiveRecord < 0 then
    FActiveRecord := 0;
  FBof := (FActiveRecord = 0);
  FEof := (FActiveRecord = Self.Count - 1);
end;

(*
 @́FReadOpenList
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvDataSet.ReadOpenList(FWorkList: TStringList; AHeader: Boolean; AEncrypt: Byte);
var
  sLine: String;
  nCnt: Integer;
begin
  //Í
  if AEncrypt > 0 then
  begin
    sLine := FWorkList.Text;
    if Copy(sLine, Length(sLine) - 1, 2) = #13#10 then
      sLine := Copy(sLine, 1, Length(sLine) - 2);
    for nCnt := 1 to Length(sLine) do
      sLine[nCnt] := Chr(Ord(sLine[nCnt]) xor AEncrypt);
    FWorkList.Text := sLine;
  end;

  //sڂtB[h擾
  if AHeader then
  begin
    sLine := '';
    if FWorkList.Count > 0 then
    begin
      sLine := FWorkList.Strings[0];
      FWorkList.Delete(0);
    end;
    SetFieldNames(sLine);
  end;

  //ŏIR[hɋsǉ
  FWorkList.Add('');

  //[NXgRs[
  Self.Text := FWorkList.Text;
end;

(*
 @́FWritePostList
 ߂lF
 @F
 @@\F
 @lFProtected
*)
procedure TCsvDataSet.WritePostList(FWorkList: TStringList; AHeader: Boolean; AEncrypt: Byte);
var
  SaveStr: String;
  nCnt: Integer;
begin
  //[NXgփRs[
  FWorkList.Text := Self.Text;

  //ŏIR[h̋s폜
  FWorkList.Delete(FWorkList.Count - 1);

  //sڂɃtB[hǉ
  if AHeader then FWorkList.Insert(0, GetFieldNames);

  //Í
  if AEncrypt > 0 then
  begin
    SaveStr := FWorkList.Text;
    if Copy(SaveStr, Length(SaveStr) - 1, 2) = #13#10 then
      SaveStr := Copy(SaveStr, 1, Length(SaveStr) - 2);
    for nCnt := 1 to Length(SaveStr) do
      SaveStr[nCnt] := Chr(Ord(SaveStr[nCnt]) xor AEncrypt);
    FWorkList.Text := SaveStr;
  end;
end;

(*
 @́FOpenFile
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvDataSet.OpenFile(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte): Boolean;
var
  sWorkList: TStringList;
begin
  //Result := False;

  //[NXg
  sWorkList := TStringList.Create;
  try
    //t@C݂΃[NXgɓǂݍ
    if FileExists(AFileName) then sWorkList.LoadFromFile(AFileName);

    //t@CRs[
    ReadOpenList(sWorkList, AHeader, AEncrypt);

    Result := True;
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FOpenList
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvDataSet.OpenList(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte): Boolean;
var
  sWorkList: TStringList;
begin
  //Result := False;

  //[NXg
  sWorkList := TStringList.Create;
  try
    //񃊃XgnilłȂ΃[NXgɓǂݍ
    if not Assigned(Strings) then sWorkList.Text := Strings.Text;

    //񃊃XgRs[
    ReadOpenList(sWorkList, AHeader, AEncrypt);

    Result := True;
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FPostFile
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvDataSet.PostFile(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte): Boolean;
var
  sWorkList: TStringList;
begin
  Result := False;

  //t@CΏI
  if AFileName = '' then Exit;

  //[NXg
  sWorkList := TStringList.Create;
  try
    //[NXgɃRs[
    WritePostList(sWorkList, AHeader, AEncrypt);

    //t@Cɏo
    sWorkList.SaveToFile(AFileName);

    Result := True;
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FPostList
 ߂lF
 @F
 @@\F
 @lFProtected
*)
function TCsvDataSet.PostList(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte): Boolean;
var
  sWorkList: TStringList;
begin
  Result := False;

  //񃊃XgnilȂΏI
  if not Assigned(Strings) then Exit;

  //[NXg
  sWorkList := TStringList.Create;
  try
    //[NXgɃRs[
    WritePostList(sWorkList, AHeader, AEncrypt);

    //񃊃Xgɏo
    Strings.Text := sWorkList.Text;

    Result := True;
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FOpen
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Open(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte);
begin
  //t@Cǂݍ
  OpenFile(AFileName, AHeader, AEncrypt);

  //J[\ړ
  Locate(lmFirst);
end;

(*
 @́FOpen
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Open(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte);
begin
  //񃊃Xgǂݍ
  OpenList(Strings, AHeader, AEncrypt);

  //J[\ړ
  Locate(lmFirst);
end;

(*
 @́FRefresh
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Refresh(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte);
begin
  //t@Cǂݍ
  OpenFile(AFileName, AHeader, AEncrypt);

  //J[\ړ
  Locate(lmNone);
end;

(*
 @́FRefresh
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Refresh(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte);
begin
  //񃊃Xgǂݍ
  OpenList(Strings, AHeader, AEncrypt);

  //J[\ړ
  Locate(lmNone);
end;

(*
 @́FPost
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Post(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte);
begin
  //t@C֏o
  PostFile(AFileName, AHeader, AEncrypt);
end;

(*
 @́FPost
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Post(Strings: TStrings; AHeader: Boolean; AEncrypt: Byte);
begin
  //񃊃Xg֏o
  PostList(Strings, AHeader, AEncrypt);
end;

(*
 @́FClose
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Close;
begin
  Self.Clear;
  InitFlag;
end;

(*
 @́FFirst
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.First;
begin
  Locate(lmFirst);
end;

(*
 @́FLast
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Last;
begin
  Locate(lmLast);
end;

(*
 @́FPrior
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Prior;
begin
  Locate(lmPrior);
end;

(*
 @́FNext
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Next;
begin
  Locate(lmNext);
end;

(*
 @́FLocate
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvDataSet.Locate(const AMode: TLocateMode);
begin
  if Self.Count <= 0 then
  begin
    InitFlag;
    Exit;
  end;

  case AMode of
  lmFirst: FActiveRecord := 0;
  lmLast: FActiveRecord := Self.Count - 1;
  lmPrior: Dec(FActiveRecord);
  lmNext: Inc(FActiveRecord);
  end;

  ResetFlag;
end;

(*
 @́FAppendRecord
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.AppendRecord(const Value: String): Integer;
begin
  FActiveRecord := Self.Add(Value) - 1;
  ResetFlag;
  Result := FActiveRecord;
end;

(*
 @́FInsertRecord
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.InsertRecord(const Value: String): Integer;
begin
  if FBof and FEof then
    FActiveRecord := Self.Add(Value) - 1
  else
    Self.Insert(FActiveRecord, Value);
  ResetFlag;
  Result := FActiveRecord;
end;

(*
 @́FDeleteRecord
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.DeleteRecord: Integer;
begin
  Result := -1;
  if FBof and FEof then Exit;
  Self.Delete(FActiveRecord);
  Locate(lmNone);
  Result := FActiveRecord;
end;

(*
 @́FCheckFieldIndex
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.CheckFieldIndex(AFieldIndex: Integer): Boolean;
begin
  Result := (AFieldIndex >= Low(FFields))and(AFieldIndex <= High(FFields));
end;

(*
 @́FCheckFieldName
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.CheckFieldName(const AFieldName: String): Boolean;
begin
  Result := (GetFieldIndex(AFieldName) > -1);
end;

(*
 @́FGetFieldIndex
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.GetFieldIndex(const AFieldName: String): Integer;
var
  nIdx: Integer;
begin
  Result := -1;
  for nIdx := Low(FFields) to High(FFields) do
  begin
    if not AnsiSameText(AFieldName, FFields[nIdx].FFieldName) then Continue;
    Result := nIdx;
    Break;
  end;
end;

(*
 @́FFieldByIndex
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.FieldByIndex(const AFieldIndex: Integer): TCsvField;
begin
  Result := nil;
  if CheckFieldIndex(AFieldIndex) then
  begin
    Result := FFields[AFieldIndex];
  end;
end;

(*
 @́FFieldByName
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.FieldByName(const AFieldName: String): TCsvField;
var
  nIdx: Integer;
begin
  Result := nil;
  nIdx := GetFieldIndex(AFieldName);
  if nIdx > -1 then Result := FFields[nIdx];
end;

(*
 @́FCreateField
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvDataSet.CreateField(const AFieldName: String): Integer;
var
  nIdx: Integer;
begin
  nIdx := GetFieldCount;
  SetLength(FFields, nIdx + 1);
  FFields[nIdx] := TCsvField.Create(Self, nIdx, AFieldName);
  Result := nIdx;
end;

(*
 @́FGetFieldCount
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
function TCsvDataSet.GetFieldCount: Integer;
begin
  Result := High(FFields) + 1;
end;

(*
 @́FSetFieldCount
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
procedure TCsvDataSet.SetFieldCount(const Value: Integer);
var
  nOldCnt, nIdx: Integer;
begin
  nOldCnt := GetFieldCount;

  //tB[hĐݒ
  for nIdx := nOldCnt - 1 downto Value do
  begin
    FFields[nIdx].Free;
    FFields[nIdx] := nil;
  end;
  SetLength(FFields, Value);

  //tB[hԍEtB[hݒ
  for nIdx := nOldCnt to Value - 1 do
  begin
    FFields[nIdx] := TCsvField.Create(Self, nIdx);
  end;
end;

(*
 @́FGetFieldValue
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
function TCsvDataSet.GetFieldValue(Index: Integer): String;
var
  sWorkList: TStringList;
begin
  Result := '';
  if FBof and FEof then Exit;

  //[NXg
  sWorkList := TStringList.Create;
  try
    sWorkList.CommaText := GetFieldValues;
    if sWorkList.Count > Index then Result := sWorkList.Strings[Index];
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FSetFieldValue
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
procedure TCsvDataSet.SetFieldValue(Index: Integer; const Value: String);
var
  nCnt: Integer;
  sWorkList: TStringList;
begin
  if FBof and FEof then Exit;

  //[NXg
  sWorkList := TStringList.Create;
  try
    sWorkList.CommaText := GetFieldValues;
    nCnt := GetFieldCount - sWorkList.Count;
    while nCnt > 0 do
    begin
      sWorkList.Add('');
      Dec(nCnt);
    end;
    if GetFieldCount > Index then sWorkList.Strings[Index] := Value;
    SetFieldValues(sWorkList.CommaText);
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FGetFieldName
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
function TCsvDataSet.GetFieldName(Index: Integer): String;
begin
  Result := '';
  if CheckFieldIndex(Index) then
  begin
    Result := FFields[Index].FFieldName;
  end;
end;

(*
 @́FSetFieldName
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
procedure TCsvDataSet.SetFieldName(Index: Integer; const Value: String);
begin
  if CheckFieldIndex(Index) then
  begin
    FFields[Index].FFieldName := Value;
  end;
end;

(*
 @́FGetFieldValues
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
function TCsvDataSet.GetFieldValues: String;
begin
  Result := '';
  if FBof and FEof then Exit;
  Result := Self.Strings[FActiveRecord];
end;

(*
 @́FSetFieldValues
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
procedure TCsvDataSet.SetFieldValues(const Value: String);
begin
  if FBof and FEof then Exit;
  Self.Strings[FActiveRecord] := Value;
end;

(*
 @́FGetFieldNames
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
function TCsvDataSet.GetFieldNames: String;
var
  nCnt: Integer;
  sWorkList: TStringList;
begin
  Result := '';

  //[NXg
  sWorkList := TStringList.Create;
  try
    //tB[h擾
    for nCnt := Low(FFields) to High(FFields) do
    begin
      sWorkList.Add(FFields[nCnt].FieldName);
    end;

    //[NXgtB[hRs[
    Result := sWorkList.CommaText;
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;

(*
 @́FSetFieldNames
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
procedure TCsvDataSet.SetFieldNames(const Value: String);
var
  nCnt: Integer;
  sWorkList: TStringList;
begin
  //[NXg
  sWorkList := TStringList.Create;
  try
    //tB[h[NXgɃRs[
    sWorkList.CommaText := Value;

    //tB[hݒ
    SetFieldCount(sWorkList.Count);

    //tB[hݒ
    for nCnt := Low(FFields) to High(FFields) do
    begin
      FFields[nCnt].FFieldName := sWorkList.Strings[nCnt];
    end;
  finally
    //[NXgj
    FreeAndNil(sWorkList);
  end;
end;


{ TCsvTable }

(*
 @́FCreate
 ߂lF
 @F
 @@\F
 @lFPublic
*)
constructor TCsvTable.Create;
begin
  Create('', False, 0);
end;

constructor TCsvTable.Create(const AFileName: TFileName; AHeader: Boolean; AEncrypt: Byte = 0);
begin
  inherited Create;

  //e[u
  FFileName := AFileName;

  //wb_s̗L
  FUseHeader := AHeader;

  //Í̗L
  FEncryptByte := AEncrypt;
end;

(*
 @́FOpen
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvTable.Open: Boolean;
begin
  //t@Cǂݍ
  Result := OpenFile(FFileName, FUseHeader, FEncryptByte);

  //J[\ړ
  Locate(lmFirst);
end;

(*
 @́FRefresh
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvTable.Refresh: Boolean;
begin
  //t@Cǂݍ
  Result := OpenFile(FFileName, FUseHeader, FEncryptByte);

  //J[\ړ
  Locate(lmNone);
end;

(*
 @́FPost
 ߂lF
 @F
 @@\F
 @lFPublic
*)
function TCsvTable.Post: Boolean;
begin
  //t@C֏o
  Result := PostFile(FFileName, FUseHeader, FEncryptByte);
end;

(*
 @́FMoveTop
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvTable.MoveTop;
begin
  if FActiveRecord < 0 then Exit;
  Self.Move(FActiveRecord, 0);
end;

(*
 @́FMoveBottom
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvTable.MoveBottom;
begin
  if FActiveRecord < 0 then Exit;
  Self.Move(FActiveRecord, Self.Count - 1);
end;

(*
 @́FMoveUp
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvTable.MoveUp;
begin
  if FActiveRecord <= 0 then Exit;
  Self.Exchange(FActiveRecord, FActiveRecord - 1);
end;

(*
 @́FMoveDown
 ߂lF
 @F
 @@\F
 @lFPublic
*)
procedure TCsvTable.MoveDown;
begin
  if (FActiveRecord < 0) or (FActiveRecord >= Self.Count - 1) then Exit;
  Self.Exchange(FActiveRecord, FActiveRecord + 1);
end;

(*
 @́FGetSelected
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
function TCsvTable.GetSelected: Boolean;
begin
  Result := False;
  if FBof and FEof then Exit;
  Result := (Self.Objects[FActiveRecord] <> nil);
end;

(*
 @́FSetSelected
 ߂lF
 @F
 @@\F
 @lFPrivate
*)
procedure TCsvTable.SetSelected(Value: Boolean);
begin
  if FBof and FEof then Exit;
  if Value then
    Self.Objects[FActiveRecord] := TObject(1)
  else
    Self.Objects[FActiveRecord] := nil;
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H
