////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// DateUtilsEx \[Xt@C Ver.2.0ij萔ISO8601Łj                //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
unit DateUtilsEx;

interface

uses
  SysUtils, DateUtils;

////////////////////////////////////////////////////////////////////////////////
//^錾
type
  //Nz
  TEraIndex = 0..5;   //NƂ́A͈̔͂ύXĒ萔zɒǉ

  //t̍ڏ
  TDateOrderEx = (doxLocale, doxMDY, doxDMY, doxYMD);

////////////////////////////////////////////////////////////////////////////////
//tϊ֐Q

//t񍀖ڏ擾
function GetLocaleDateOrder: TDateOrderEx;

//񁨓tϊ
function StrToDateDefEx(const S: String; const Default: TDateTime): TDateTime;
function TryStrToDateEx(const S: String; out Value: TDateTime): Boolean;

//񁨎ϊ
function StrToTimeDefEx(const S: String; const Default: TDateTime): TDateTime;
function TryStrToTimeEx(const S: String; out Value: TDateTime): Boolean;

//񁨃EXϊ
function TryStrToJulianDayEx(const S: String; out Value: Longint): Boolean;
function StrToJulianDayDefEx(const S: String; const Default: Longint): Longint;

////////////////////////////////////////////////////////////////////////////////
//񑀍֐Q

//plSpl
function ChangeWideNum(const S: String; const WideNum: Boolean): String;

//pAt@xbgSpAt@xbg
function ChangeWideChar(const S: String): String;

//Spǉ
function StringOfWideChar(Str: String; Count: Integer): String;

//킹ǉ
function AddNullPlace(const S: String; const Digits: Integer; const BlankChar: Boolean): String;

////////////////////////////////////////////////////////////////////////////////
//aϊ֐Q

//aN擾
function GetJapanYear(AYear: Word; AEraIndex: TEraIndex): Integer;

//\擾
function GetJikkan(AYear: Word; AHira: Boolean): String;

//\x擾
function GetJunishi(AYear: Word; AHira: Boolean): String;

////////////////////////////////////////////////////////////////////////////////
//ϊ֐QivZx͗ǂȂj

//Nb~bϊ
function EncodeMoonAge(const AYear, AMonth, ADay, AHour, AMin, ASec, AMSec: Word): Double;

//ϊ
function DateTimeToMoonAge(const DateTime: TDateTime): Double;

//EXϊ
function JulianDateToMoonAge(const JulianDate: Double): Double;

////////////////////////////////////////////////////////////////////////////////
//tEH擾֐Qi1980N`2099N̂ݗLj

//Nt̓
function GetVernalEquinoxDay(const AYear: Word): Word;
function GetVernalEquinoxDate(const AYear: Word): TDateTime;
function GetVernalEquinoxJulianDay(const AYear: Word): Longint;

//NH̓
function GetAutumnalEquinoxDay(const AYear: Word): Word;
function GetAutumnalEquinoxDate(const AYear: Word): TDateTime;
function GetAutumnalEquinoxJulianDay(const AYear: Word): Longint;

////////////////////////////////////////////////////////////////////////////////
//tH[}bg֐Q

//gDateTimeToString
procedure DateTimeToStringEx(var Result: String; const Format: String; DateTime: TDateTime);

//gFormatDateTime
function FormatDateTimeEx(const Format: String; DateTime: TDateTime): String;

//gDateTimeToStr
function DateTimeToStrEx(DateTime: TDateTime): String;

////////////////////////////////////////////////////////////////////////////////
//EXtH[}bg֐Q

//gEXtH[}bg֐
procedure JulianDayToStringEx(var Result: String; const Format: String; Julian: Longint);

//gEXtH[}bg֐
function FormatJulianDayEx(const Format: String; Julian: Longint): String;

//gEXϊ֐
function JulianDayToStrEx(Julian: Longint): String;

////////////////////////////////////////////////////////////////////////////////
//萔
const
  //NDateTimelij
  EraOffsetDate : array[TEraIndex] of LongInt =
    ( 0, -11435, 4595, 9856, 32516, 43586 );
  //ÑEXʓ
  EraOffsetJulian : array[TEraIndex] of LongInt =
    ( 0, 2403584, 2419614, 2424875, 2447535, 2458605 );
    //1868/09/08
    //吳1912/07/30
    //a1926/12/25
    //1989/01/08
    //ߘa2019/05/01
  //aN|PiN炱ƘaNɂȂj
  EraStartYear : array[TEraIndex] of Word =
    ( 0, 1867, 1911, 1925, 1988, 2018 );

  //E
  JapaneseEraNames : array[TEraIndex] of String =
     ('', '', '吳', 'a', '', 'ߘa');
  //EЂ炪
  HiraganaEraNames : array[TEraIndex] of String =
     ('', '߂', '傤', '傤', 'ւ', 'ꂢ');
  //EAt@xbg
  AlphabetEraNames : array[TEraIndex] of String =
     ('', 'M', 'T', 'S', 'H', 'R');

  //\E
  KanjiJikkanNames : array[0..9] of String =
     ('b', '', '', '', '', '', 'M', 'h', 'p', '');
  //\EЂ炪
  HiraJikkanNames : array[0..4] of String =
     ('', '', '', '', '݂');
  HiraJikkanFoots : array [0..1] of String =
     ('̂', '̂');

  //\xE
  KanjiJunishiNames : array[0..11] of String =
     ('q', 'N', '', 'K', 'C', '', '', '', '\', '', '', '');
  //\xEЂ炪
  HiraJunishiNames : array[0..11] of String =
     ('', '', 'Ƃ', '', '', '', '', 'Ђ', '', 'Ƃ', '', '');

  //]ˎ̎\
  KanjShinkokuNames : array[0..5] of String =
     ('', '', '', 'Z', '', 'l');
  HiraShinkokuNames : array[0..5] of String =
     ('', '', 'Ȃ', '', '', '');
  ShinkokuNameFoot = '';

  //pꌎEAt@xbg
  AlphabetMonthNames : array[1..12] of String =
     ('January', 'February', 'March', 'April', 'May', 'June',
      'July', 'August', 'September', 'October', 'November', 'December');
  //pꌎEJ^Ji
  KatakanaMonthNames : array [1..12] of String =
     ('WjA[', 'tFu[', '}[`', 'GCv', 'C', 'W[',
      'WC', 'I[KXg', 'Zveo[', 'INg[o[', 'mFo[', 'fBZo[');

  //{ꌎE
  JapaneseMonthNames : array[1..12] of String =
     ('r', '@', '퐶', 'K', 'H', '',
      '', 't', '', '_', '', 't');
  //{ꌎEЂ炪
  HiraganaMonthNames : array[1..12] of String =
     ('ނ', '炬', '悢', 'Â', '', '݂ȂÂ',
      'ӂ݂', '͂Â', 'Ȃ', 'ȂÂ', '', '킷');

  //pjEAt@xbg
  AlphabetDayNames : array[DayMonday..DaySunday] of String =
     ('Mon', 'Tues', 'Wednes', 'Thurs', 'Fri', 'Satur', 'Sun');
  AlphabetWeekFoot = 'day';

  //pjEJ^Ji
  KatakanaDayNames : array [DayMonday..DaySunday] of String =
     ('}', '`[Y', 'EFY', 'T[Y', 'tC', 'T^', 'T');
  KatakanaWeekFook = 'f[';

  //{jE
  JapaneseDayNames : array [DayMonday..DaySunday] of String =
     ('', '', '', '', '', 'y', '');
  JapaneseWeekFoot = 'j';

  //{jEЂ炪
  HiraganaDayNames : array [DayMonday..DaySunday] of String =
     ('', '', '', '', '', '', 'ɂ');
  HiraganaWeekFoot = '悤';

  //Spϊpz
  WideNumChars : array [Boolean] of array [0..9] of String =
    (('Z', '', '', 'O', 'l', '', 'Z', '', '', ''),
     ('O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X'));
  WideLowerChars : array ['a'..'z'] of String =
    ('', '', '', '', '', '', '', '', '', '', '', '', '',
     '', '', '', '', '', '', '', '', '', '', '', '', '');
  WideUpperChars : array ['A'..'Z'] of String =
    ('`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',
     'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y');

  //SpXy[XipXy[XɂƂ͂ςj
  WideSpaceChar = '@';

////////////////////////////////////////////////////////////////////////////////
//O[oϐ
var
  //t񍀖ڏ
  DateOrderEx: TDateOrderEx = doxYMD;

////////////////////////////////////////////////////////////////////////////////

implementation

uses
  StrUtils, JulianUtils;

////////////////////////////////////////////////////////////////////////////////
//tϊ֐Q

//t񍀖ڏ
function GetLocaleDateOrder: TDateOrderEx;
var
  I: Integer;
begin
  case DateOrderEx of
  doxMDY,doxDMY,doxYMD:
    Result := DateOrderEx;
  else{doxLocale}
    Result := doxYMD;
    I := 1;
    while I <= Length(ShortDateFormat) do
    begin
      case Chr(Ord(ShortDateFormat[I]) and $DF) of
      'Y': Result := doxYMD;
      'M': Result := doxMDY;
      'D': Result := doxDMY;
      else
        Inc(I);
        Continue;
      end;
      Exit;
    end;
  end;
end;

//t񍀖ڕ
function ChangeDateTimeString(const S: String; const Separate: Char): String;
var
  pChr: PChar;
  nIdx, nLen, nCnt: Integer;
  sComp, sConv: String;
  bPrevNum: Boolean;
begin
  bPrevNum := False;
  pChr := PChar(S);
  nLen := Length(S);
  nIdx := 0;
  Result := '';
  repeat
    sConv := '';
    if StrBytetype(pChr, 0) = mbLeadByte then
    begin
      sComp := pChr^ + (pChr + 1)^;
      for nCnt := 0 to 9 do
      begin
        if WideNumChars[False, nCnt] = sComp then
        begin
          sConv := IntToStr(nCnt);
          Break;
        end
        else if WideNumChars[True, nCnt] = sComp then
        begin
          sConv := IntToStr(nCnt);
          Break;
        end;
      end;
      Inc(pChr);
      Inc(nIdx);
    end
    else
    begin
      sComp := pChr^;
      for nCnt := 0 to 9 do
      begin
        if IntToStr(nCnt) = sComp then
        begin
          sConv := sComp;
          Break;
        end;
      end;
    end;
    if sConv <> '' then
    begin
      Result := Result + sConv;
      bPrevNum := True;
    end
    else if bPrevNum then
    begin
      Result := Result + Separate;
      bPrevNum := False;
    end;
    Inc(pChr);
    Inc(nIdx);
  until nIdx > nLen;
end;

function StrToDecodeDate(const S: String; out Year, Month, Day: Word): Boolean;
var
  SYear, SMonth, SDay, Dt: String;
  SepPos: Integer;
  BaseYear: Word;
begin
  Result := False;

  if S = '' then Exit;
  Dt := ChangeDateTimeString(S, DateSeparator);

  //񕪉
  SepPos := Pos(DateSeparator, Dt);
  if SepPos > 0 then
  begin
    SYear := LeftStr(Dt, SepPos - 1);
    Dt := RightStr(Dt, Length(Dt) - SepPos);
    SepPos := Pos(DateSeparator, Dt);
    if SepPos > 0 then
    begin
      SMonth := LeftStr(Dt, SepPos - 1);
      SDay := RightStr(Dt, Length(Dt) - SepPos);
      SepPos := Pos(DateSeparator, SDay);
      if SepPos > 0 then
        SDay := LeftStr(SDay, SepPos - 1);
    end
    else
    begin
      SDay := Dt;
      SMonth := SYear;
      SYear := '';
    end;
  end
  else
  begin
    SDay := Dt;
    SMonth := '';
    SYear := '';
  end;
  SepPos := Pos(' ', SDay);
  if SepPos > 0 then
    SDay := LeftStr(SDay, SepPos - 1);

  //NёւidoxMDY,doxDMY̏ꍇj
  case GetLocaleDateOrder of
  doxMDY:
    begin
      if SYear = '' then
      begin
        SYear := SMonth;
        SMonth := SDay;
        SDay := '';
      end;
      Dt := SMonth;
      SMonth := SYear;
      SYear  := SDay;
      SDay   := Dt;
    end;
  doxDMY:
    begin
      if SYear = '' then
      begin
        if SMonth = '' then
        begin
          SYear := SDay;
        end
        else
        begin
          SYear := SMonth;
          SMonth := SDay;
        end;
        SDay := '';
      end;
      Dt := SDay;
      SDay   := SYear;
      SYear  := Dt;
    end;
  end;

  Year := StrToIntDef(SYear, 0);
  if Year < 100 then
  begin
    BaseYear := YearOf(Today) - TwoDigitYearCenturyWindow;
    Inc(Year, (BaseYear div 100) * 100);
    if (TwoDigitYearCenturyWindow > 0) and (Year < BaseYear) then Inc(Year, 100);
  end;
  Month := StrToIntDef(SMonth, 0);
  Day := StrToIntDef(SDay, 0);

  Result := True;
end;

function TryStrToDecodeDate(const S: String; out Year, Month, Day: Word): Boolean;
begin
  try
    Result := StrToDecodeDate(S, Year, Month, Day);
  except
    Result := False;
  end;
end;

function StrToDecodeTime(const S: String; out Hour, Min, Sec, MSec: Word): Boolean;
var
  SHour, SMin, SSec, Tm: String;
  SepPos: Integer;
  BaseHour: Word;
begin
  Result := False;

  if S = '' then Exit;
  Tm := ChangeDateTimeString(S, TimeSeparator);

  //AM/PM`FbN
  if (Pos(Tm, TimeAMString) > 0) or (Pos(Tm, 'AM') > 0) then
    BaseHour := 0
  else if (Pos(Tm, TimePMString) > 0) or (Pos(Tm, 'PM') > 0) then
    BaseHour := 12
  else
    BaseHour := 0;

  //񕪉
  SMin := '';
  SSec := '';
  SepPos := Pos(TimeSeparator, Tm);
  if SepPos > 0 then
  begin
    SHour := LeftStr(Tm, SepPos - 1);
    Tm := RightStr(Tm, Length(Tm) - SepPos);
    SepPos := Pos(TimeSeparator, Tm);
    if SepPos > 0 then
    begin
      SMin := LeftStr(Tm, SepPos - 1);
      Tm := RightStr(Tm, Length(Tm) - SepPos);
      SepPos := Pos(TimeSeparator, Tm);
      if SepPos > 0 then
      begin
        SSec := LeftStr(Tm, SepPos - 1);
        Tm := RightStr(Tm, Length(Tm) - SepPos);
        SepPos := Pos(TimeSeparator, Tm);
        if SepPos > 0 then
          SSec := LeftStr(Tm, SepPos - 1);
      end
      else
      begin
        SSec := Tm;
        Tm := '';
      end;
    end
    else
    begin
      SMin := Tm;
      Tm := '';
    end;
  end
  else
  begin
    SHour := Tm;
    Tm := '';
  end;

  Hour := StrToIntDef(SHour, 0) + BaseHour;
  if Hour > 24 then Hour := Hour mod 24;
  Min := StrToIntDef(SMin, 0);
  Sec := StrToIntDef(SSec, 0);
  MSec := StrToIntDef(Tm, 0);

  Result := True;
end;

function TryStrToDecodeTime(const S: String; out Hour, Min, Sec, MSec: Word): Boolean;
begin
  try
    Result := StrToDecodeTime(S, Hour, Min, Sec, MSec);
  except
    Result := False;
  end;
end;

//񁨓tϊ
function StrToDateDefEx(const S: String; const Default: TDateTime): TDateTime;
begin
  if not TryStrToDateEx(S, Result) then Result := Default;
end;

function TryStrToDateEx(const S: String; out Value: TDateTime): Boolean;
var
  Year, Month, Day: Word;
begin
  Result := False;
  //𐔒lɕ
  if TryStrToDecodeDate(S, Year, Month, Day) then
  begin
    //Nt^ɕϊ
    Result := TryEncodeDate(Year, Month, Day, Value);
  end;
end;

//񁨎ϊ
function StrToTimeDefEx(const S: String; const Default: TDateTime): TDateTime;
begin
  if not TryStrToTimeEx(S, Result) then Result := Default;
end;

function TryStrToTimeEx(const S: String; out Value: TDateTime): Boolean;
var
  Hour, Min, Sec, MSec: Word;
begin
  Result := False;
  //𐔒lɕ
  if TryStrToDecodeTime(S, Hour, Min, Sec, MSec) then
  begin
    //b玞^ɕϊ
    Result := TryEncodeTime(Hour, Min, Sec, MSec, Value);
  end;
end;

function TryStrToJulianDayEx(const S: String; out Value: Longint): Boolean;
var
  Year, Month, Day: Word;
begin
  Result := False;
  //𐔒lɕ
  if TryStrToDecodeDate(S, Year, Month, Day) then
  begin
    //Nt^ɕϊ
    Result := TryEncodeJulianDay(Year, Month, Day, Value);
  end;
end;

function StrToJulianDayDefEx(const S: String; const Default: Longint): Longint;
begin
  if not TryStrToJulianDayEx(S, Result) then Result := Default;
end;

////////////////////////////////////////////////////////////////////////////////
//񑀍֐Q

//plSpl
function ChangeWideNum(const S: String; const WideNum: Boolean): String;
var
  Len: Integer;
begin
  Result := '';
  for Len := Length(S) downto 1 do
  begin
    case S[Len] of
    '0'..'9': Result := WideNumChars[WideNum, StrToInt(S[Len])] + Result;
    ' ':      Result := WideSpaceChar + Result;
    end;
  end;
end;

//pAt@xbgSpAt@xbg
function ChangeWideChar(const S: String): String;
var
  Len: Integer;
begin
  Result := '';
  for Len := Length(S) downto 1 do
  begin
    case S[Len] of
    'a'..'z': Result := WideLowerChars[S[Len]] + Result;
    'A'..'Z': Result := WideUpperChars[S[Len]] + Result;
    end;
  end;
end;

//Spǉ
function StringOfWideChar(Str: String; Count: Integer): String;
begin
  Result := '';
  Count := Count div 2;
  while Count > 0 do
  begin
    Result := Result + Str;
    Dec(Count);
  end;
end;

//킹ǉ
function AddNullPlace(const S: String; const Digits: Integer; const BlankChar: Boolean): String;
const
  NullPlaceChar : array [Boolean] of Char = ('0', ' ');
var
  Len: Integer;
begin
  Result := S;
  Len := Length(S);
  if Digits > Len then
  begin
    Result := StringOfChar(NullPlaceChar[BlankChar], Digits - Len) + Result;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//aϊ֐Q

//aN擾
function GetJapanYear(AYear: Word; AEraIndex: TEraIndex): Integer;
begin
  Result := AYear - EraStartYear[AEraIndex];
end;

//\擾
function GetJikkan(AYear: Word; AHira: Boolean): String;
begin
  AYear := (AYear + 6) mod 10;
  if AHira then
    Result := HiraJikkanNames[AYear div 2] + HiraJikkanFoots[AYear mod 2]
  else
    Result := KanjiJikkanNames[AYear];
end;

//\x擾
function GetJunishi(AYear: Word; AHira: Boolean): String;
begin
  AYear := (AYear + 8) mod 12;
  if AHira then
    Result := HiraJunishiNames[AYear]
  else
    Result := KanjiJunishiNames[AYear];
end;

////////////////////////////////////////////////////////////////////////////////
//ϊ֐QivZx͗ǂȂj

//Nϊ
function EncodeMoonAge(const AYear, AMonth, ADay, AHour, AMin, ASec, AMSec: Word): Double;
begin
  Result := JulianDateToMoonAge(EncodeJulianDay(AYear, AMonth, ADay) +
                                EncodeTime(AHour, AMin, ASec, AMSec) - 0.5);
end;

//ϊ
function DateTimeToMoonAge(const DateTime: TDateTime): Double;
begin
  Result := JulianDateToMoonAge(DateTimeToJulianDate(DateTime));
end;

//EXϊ
function JulianDateToMoonAge(const JulianDate: Double): Double;
var
  dBase, dTemp: Double;
const
  MoonCycle  = 29.530589;   //P]̕ϓ
  ConvRadian = PI / 180.0;  //xEWAϊ
begin
  //EX猳Zo
  dBase := JulianDate - 2451550.4727;

  //]̎ZoiO̍̓߂̂Őɐ؂艺j
  dTemp := dBase / MoonCycle;
  if Frac(dTemp) < 0 then dTemp := dTemp - 1;
  dTemp := Int(dTemp);

  //O̍񂩂̌oߓ{ۓ␳iȂȗj
  Result := dBase - dTemp * MoonCycle
          + Sin((385.82 * dTemp + 201.56) * ConvRadian) * 0.407
          - Sin(( 29.11 * dTemp +   2.55) * ConvRadian) * 0.172;

  //͈̓`FbNix̂ŗ]Tj
  if Result >= 29.65 then
    Result := Result - MoonCycle
  else if Result < -0.05 then
    Result := Result + MoonCycle;
end;

////////////////////////////////////////////////////////////////////////////////
//tEH擾֐Qi1980N`2099N̂ݗLj

//Nt̓
function GetVernalEquinoxDay(const AYear: Word): Word;
begin
  if (AYear >= 1980) and (AYear <= 2099) then
    Result := Trunc(20.8431 + (AYear - 1980) * 0.24219 - Trunc((AYear - 1980) * 0.25))
  else
    Result := 21;
end;

function GetVernalEquinoxDate(const AYear: Word): TDateTime;
begin
  Result := EncodeDate(AYear, 3, GetVernalEquinoxDay(AYear));
end;

function GetVernalEquinoxJulianDay(const AYear: Word): Longint;
begin
  Result := EncodeJulianDay(AYear, 3, GetVernalEquinoxDay(AYear));
end;

//NH̓
function GetAutumnalEquinoxDay(const AYear: Word): Word;
begin
  if (AYear >= 1980) and (AYear <= 2099) then
    Result := Trunc(23.2488 + (AYear - 1980) * 0.24219 - Trunc((AYear - 1980) * 0.25))
  else
    Result := 23;
end;

function GetAutumnalEquinoxDate(const AYear: Word): TDateTime;
begin
  Result := EncodeDate(AYear, 9, GetAutumnalEquinoxDay(AYear));
end;

function GetAutumnalEquinoxJulianDay(const AYear: Word): Longint;
begin
  Result := EncodeJulianDay(AYear, 9, GetAutumnalEquinoxDay(AYear));
end;

////////////////////////////////////////////////////////////////////////////////

//gpDateTimeToString֐
procedure InternalDateTimeToString(var Result: String; const Format: String;
    llll: Boolean; gggg: TEraIndex; yyyy, mmmm, dddd, wwww, hhhh, nnnn, ssss, zzzz: Word);
var
  Buffer: array[0..511] of Char;
  BufPos: Integer;
  nLevel: Byte;
  bWidChar, bJpnChar: Boolean;

  procedure AppendChar(P: PChar);
  begin
    if SizeOf(Buffer) > BufPos then
    begin
      Move(P[0], Buffer[BufPos], 1);
      Inc(BufPos);
    end;
  end;

  procedure AppendChars(P: PChar; Count: Integer);
  var
    N: Integer;
  begin
    N := SizeOf(Buffer) - BufPos;
    if N > Count then N := Count;
    if N <> 0 then
    begin
      Move(P[0], Buffer[BufPos], N);
      Inc(BufPos, N);
    end;
  end;

  procedure AppendStrAll(const S: String);
  begin
    AppendChars(Pointer(S), Length(S));
  end;

  procedure AppendHalfStr(S: String; MaxLen: Integer);
  var
    L: Integer;
  begin
    L := Length(S);
    if MaxLen > L then
      S := S + StringOfChar(' ', MaxLen - L);
    AppendChars(Pointer(S), MaxLen);
  end;

  procedure AppendWideStr(S: String; MaxLen: Integer);
  var
    L: Integer;
  begin
    L := Length(S);
    if MaxLen > L then
      S := S + StringOfWideChar(WideSpaceChar, MaxLen - L);
    AppendChars(Pointer(S), MaxLen);
  end;

  procedure AppendNumber(Number, Digits: Integer; BlankChar: Boolean);
  var
    Num: String;
  begin
    Num := IntToStr(Number);
    if Digits > 1 then Num := AddNullPlace(Num, Digits, BlankChar);
    if bWidChar or bJpnChar then Num := ChangeWideNum(Num, bWidChar);
    AppendChars(Pointer(Num), Length(Num));
  end;

  procedure AppendMoonAge(AYear, AMonth, ADay, AHour, AMin, ASec, AMSec: Word; ACount: Integer; ALarge: Boolean);
  var
    dMoon: Double;
    nMoon, nTemp: Integer;
  begin
    //Zo
    dMoon := EncodeMoonAge(AYear, AMonth, ADay, AHour, AMin, ASec, AMSec);

    //\pϊiľܓj
    case ACount of
    1,2:
      begin
        nMoon := Trunc(dMoon + 0.5);
        AppendNumber(nMoon, ACount, ALarge);
      end;
    else
      nMoon := Trunc(dMoon * 10 + 0.5);
      nTemp := nMoon mod 10;
      nMoon := nMoon div 10;
      if ACount = 3 then
        AppendNumber(nMoon, 1, ALarge)
      else
        AppendNumber(nMoon, 2, ALarge);
      if bWidChar or bJpnChar then
        AppendStrAll('E')
      else
        AppendChar('.');
      AppendNumber(nTemp, 1, False);
    end;
  end;

  function GetJpnAmPmStr(const AChar: Char): String;
  begin
    Result := '';
    case AChar of
    'a': Result := 'O';
    'p': Result := '';
    'm': Result := '';
    'M','P': Result := '';
    'A': Result := '';
    end;
  end;

  function GetEngAmPmStr(const AChar: Char): String;
  begin
    Result := '';
    case AChar of
    'a','m','p': Result := WideLowerChars[AChar];
    'A','M','P': Result := WideUpperChars[AChar];
    end;
  end;

  procedure AppendFormat(Format: PChar);
  var
    Starter, Token, LastToken: Char;
    P: PChar;
    Count, nTemp: Integer;
    sTemp: String;
    bLargeChar: Boolean;

    procedure GetCount;
    begin
      P := Format;
      while Format^ = Starter do Inc(Format);
      Count := Format - P + 1;
    end;

  begin
    if (Format <> nil) and (nLevel < 2) then
    begin
      Inc(nLevel);
      LastToken := ' ';
      while Format^ <> #0 do
      begin
        Starter := Format^;
        if Starter in LeadBytes then
        begin
          AppendChars(Format, StrCharLength(Format));
          Format := StrNextChar(Format);
          Continue;
        end;
        Format := StrNextChar(Format);

        Token := Starter;
        if Token in ['a'..'z'] then
        begin
          Dec(Token, 32);
          bLargeChar := False;
        end
        else
          bLargeChar := True;
        if Token in ['A'..'Z'] then
        begin
          if (Token = 'M') and (LastToken = 'H') then Token := 'N'
          else if (Token = 'E') and (gggg = 0) then Token := 'Y';
          LastToken := Token;
        end;

        case Token of
        '%':
          begin
            GetCount;
            if Count > 1 then
              AppendStrAll(StringOfChar('%', Count - 1))
            else
              bWidChar := not bWidChar;
          end;
        '\':
          begin
            GetCount;
            if Count > 1 then
              AppendStrAll(StringOfChar('\', Count - 1))
            else
              bJpnChar := not bJpnChar;
          end;
        'Y':
          begin
            GetCount;
            case Count of
            1, 2: AppendNumber(yyyy mod 100, Count, bLargeChar);
            3:    AppendNumber(yyyy, 1, bLargeChar);
            else  AppendNumber(yyyy, 4, bLargeChar);
            end;
          end;
        'G':
          begin
            GetCount;
            if Count = 1 then
            begin
              sTemp := AlphabetEraNames[gggg];
              if bWidChar or bJpnChar then
              begin
                sTemp := ChangeWideChar(sTemp);
                if bLargeChar then
                  AppendWideStr(sTemp, 2)
                else
                  AppendStrAll(sTemp);
              end
              else
              begin
                if bLargeChar then
                  AppendHalfStr(sTemp, 1)
                else
                  AppendStrAll(sTemp);
              end;
            end
            else
            begin
              if bLargeChar then
                sTemp := HiraganaEraNames[gggg]
              else
                sTemp := JapaneseEraNames[gggg];
              if Count = 2 then
                AppendWideStr(sTemp, 2)
              else if Count = 3 then
                AppendStrAll(sTemp)
              else if bLargeChar then
                AppendWideStr(sTemp, 10)
              else
                AppendWideStr(sTemp, 4);
            end;
          end;
        'E':
          begin
            GetCount;
            if Count > 2 then Count := 2;
            AppendNumber(GetJapanYear(yyyy, gggg), Count, bLargeChar);
          end;
        'J':
          begin
            GetCount;
            if Count > 1 then
            begin
              nTemp := 0;
              case Count of
              2,3:
                begin
                  sTemp := GetJikkan(yyyy, bLargeChar);
                  nTemp := 0;
                  if bLargeChar and (Count > 2) then nTemp := 8;
                end;
              4,5:
                begin
                  sTemp := GetJunishi(yyyy, bLargeChar);
                  if bLargeChar and (Count > 4) then nTemp := 6;
                end;
              else
                begin
                  sTemp := GetJikkan(yyyy, bLargeChar) + GetJunishi(yyyy, bLargeChar);
                  if bLargeChar and (Count > 6) then nTemp := 14;
                end;
              end;
              if nTemp > 0 then
                AppendWideStr(sTemp, nTemp)
              else
                AppendStrAll(sTemp);
            end
            else
              AppendChar(@Starter);
          end;
        'L':
          begin
            GetCount;
            if llll then
            begin
              AppendStrAll('[');
            end
            else if Count > 1 then
            begin
              if bLargeChar then
                AppendStrAll(WideSpaceChar)
              else
                AppendStrAll('');
            end;
          end;
        'M':
          begin
            GetCount;
            case Count of
            1, 2: AppendNumber(mmmm, Count, bLargeChar);
            else
              case Count of
              3, 6:
                sTemp := Copy(AlphabetMonthNames[mmmm], 1, 3);
              else
                sTemp := AlphabetMonthNames[mmmm];
              end;
              if bLargeChar then sTemp := UpperCase(sTemp);
              if Count >= 6 then sTemp := ChangeWideChar(sTemp);
              if Count <= 4 then
                AppendStrAll(sTemp)
              else if Count >= 6 then
                AppendHalfStr(sTemp, 9)
              else if Count <= 7 then
                AppendStrAll(sTemp)
              else
                AppendWideStr(sTemp, 18);
            end;
          end;
        'K':
          begin
            GetCount;
            if Count > 5 then
            begin
              sTemp := KatakanaMonthNames[mmmm];
              if Count = 6 then
                AppendStrAll(sTemp)
              else
                AppendWideStr(sTemp, 14);
            end
            else if Count > 1 then
            begin
              if bLargeChar then
              begin
                sTemp := HiraganaMonthNames[mmmm];
                case Count of
                2:    AppendWideStr(sTemp, 4);
                3:    AppendWideStr(sTemp, 6);
                4:    AppendStrAll(sTemp);
                else  AppendWideStr(sTemp, 10);
                end
              end
              else
              begin
                sTemp := JapaneseMonthNames[mmmm];
                case Count of
                2:    AppendWideStr(sTemp, 2);
                3:    AppendWideStr(sTemp, 4);
                4:    AppendStrAll(sTemp);
                else  AppendWideStr(sTemp, 6);
                end;
              end;
            end
            else
              AppendChar(@Starter);
          end;
        'D':
          begin
            GetCount;
            case Count of
            1, 2: AppendNumber(dddd, Count, bLargeChar);
            else
              case Count of
              3, 6:
                sTemp := Copy(AlphabetDayNames[wwww], 1, 3);
              else
                sTemp := AlphabetDayNames[wwww] + AlphabetWeekFoot;
              end;
              if bLargeChar then sTemp := UpperCase(sTemp);
              if Count >= 6 then sTemp := ChangeWideChar(sTemp);
              if Count <= 4 then
                AppendStrAll(sTemp)
              else if Count >= 6 then
                AppendHalfStr(sTemp, 9)
              else if Count <= 7 then
                AppendStrAll(sTemp)
              else
                AppendWideStr(sTemp, 18);
            end;
          end;
        'P':
          begin
            GetCount;
            if Count > 1 then Count := 2;
            AppendNumber(MonthDays[llll, mmmm] - dddd, Count, bLargeChar);
          end;
        'U':
          begin
            GetCount;
            if hhhh >= 12 then
              AppendNumber(EncodeJulianDay(yyyy, mmmm, dddd) + 1, Count, bLargeChar)
            else
              AppendNumber(EncodeJulianDay(yyyy, mmmm, dddd), Count, bLargeChar);
          end;
        'W':
          begin
            GetCount;
            if Count = 1 then
              AppendNumber((dddd - 1) div 7 + 1, 1, bLargeChar)
            else if bLargeChar then
              AppendFormat(Pointer(StringOfChar('A', Count)))
            else
              AppendFormat(Pointer(StringOfChar('a', Count)));
          end;
        'H':
          begin
            GetCount;
            case Count of
            1, 2: AppendNumber(hhhh, Count, bLargeChar);
            else
              nTemp := (hhhh + 1) div 2;
              if nTemp = 12 then nTemp := 0;
              if bLargeChar then
              begin
                sTemp := HiraJunishiNames[nTemp];
                if Count = 3 then
                  AppendStrAll(sTemp)
                else
                  AppendWideStr(sTemp, 6);
              end
              else
              begin
                AppendStrAll(KanjiJunishiNames[nTemp]);
              end;
            end;
          end;
        'F':
          begin
            GetCount;
            nTemp := hhhh mod 12;
            case Count of
            1, 2: AppendNumber(nTemp, Count, bLargeChar);
            else
              nTemp := nTemp div 2;
              if bLargeChar then
              begin
                sTemp := HiraShinkokuNames[nTemp] + ShinkokuNameFoot;
                if Count = 3 then
                  AppendStrAll(sTemp)
                else
                  AppendWideStr(sTemp, 8);
              end
              else
              begin
                sTemp := KanjShinkokuNames[nTemp];
                if Count > 3 then sTemp := sTemp + ShinkokuNameFoot;
                AppendStrAll(sTemp);
              end;
            end;
          end;
        'N':
          begin
            GetCount;
            case Count of
            1, 2: AppendNumber(nnnn, Count, bLargeChar);
            else
              if Count = 3 then
                nTemp := 0
              else
                nTemp := 4;
              AppendNumber(hhhh * 60 + nnnn, nTemp, bLargeChar);
            end;
          end;
        'S':
          begin
            GetCount;
            case Count of
            1, 2: AppendNumber(ssss, Count, bLargeChar);
            else
              if Count = 3 then
                nTemp := 0
              else
                nTemp := 5;
              AppendNumber((hhhh * 60 + nnnn) * 60 + ssss, nTemp, bLargeChar);
            end;
          end;
        'Z':
          begin
            GetCount;
            if Count > 1 then Count := 3;
            AppendNumber(zzzz, Count, bLargeChar);
          end;
        'A':
          begin
            GetCount;
            if Count > 5 then
            begin
              sTemp := KatakanaDayNames[wwww] + KatakanaWeekFook;
              if Count = 6 then
                AppendStrAll(sTemp)
              else
                AppendWideStr(sTemp, 12);
            end
            else if Count > 1 then
            begin
              if bLargeChar then
              begin
                sTemp := HiraganaDayNames[wwww];
                if Count >= 4 then sTemp := sTemp + HiraganaWeekFoot;
                case Count of
                2,4: AppendStrAll(sTemp);
                3:   AppendWideStr(sTemp, 4);
                else AppendWideStr(sTemp, 10);
                end;
              end
              else
              begin
                sTemp := JapaneseDayNames[wwww];
                if Count >= 4 then sTemp := sTemp + JapaneseWeekFoot;
                AppendStrAll(sTemp);
              end;
            end
            else
            begin
              P := Format - 1;
              if StrLIComp(P, 'AMPM', 4) = 0 then
              begin
                if hhhh < 12 then
                  AppendStrAll(TimeAMString)
                else
                  AppendStrAll(TimePMString);
                Inc(Format, 3);
              end
              else
              begin
                nTemp := 0;
                if StrLIComp(P, 'A.M.', 4) = 0 then
                begin
                  if StrLIComp(P + 5, 'P.M.', 4) = 0 then nTemp := 4;
                end
                else
                if StrLIComp(P, 'AM', 2) = 0 then
                begin
                  if StrLIComp(P + 3, 'PM', 2) = 0 then nTemp := 2;
                end
                else
                begin
                  if StrLIComp(P + 2, 'P', 1) = 0 then nTemp := 1;
                end;
                if nTemp > 0 then
                begin
                  Token := (P + nTemp)^;
                  if hhhh >= 12 then Inc(P, nTemp + 1);
                  case Token of
                  '/':
                    begin
                      AppendChars(P, nTemp);
                      Inc(Format, nTemp * 2)
                    end;
                  '%':
                    begin
                      sTemp := GetEngAmPmStr(P^);
                      if nTemp = 2 then
                      begin
                        Inc(P);
                        sTemp := sTemp + GetEngAmPmStr(P^);
                      end
                      else if nTemp > 2 then
                      begin
                        Inc(P, 2);
                        sTemp := sTemp + 'D' + GetEngAmPmStr(P^) + 'D';
                      end;
                      AppendStrAll(sTemp);
                      Inc(Format, nTemp * 2)
                    end;
                  '\':
                    begin
                      sTemp := GetJpnAmPmStr(P^);
                      if nTemp = 2 then
                      begin
                        Inc(P);
                        sTemp := GetJpnAmPmStr(P^) + sTemp;
                      end
                      else if nTemp > 2 then
                      begin
                        Token := P^;
                        Inc(P, 2);
                        sTemp := GetJpnAmPmStr(P^) + sTemp;
                        if Token = 'P' then sTemp := sTemp + WideSpaceChar;
                      end;
                      AppendStrAll(sTemp);
                      Inc(Format, nTemp * 2)
                    end;
                  else
                    AppendChar(@Starter);
                  end;
                end
                else
                  AppendChar(@Starter);
              end;
            end;
          end;
        'R':
          begin
            GetCount;
            AppendMoonAge(yyyy, mmmm, dddd, hhhh, nnnn, ssss, zzzz, Count, bLargeChar);
          end;
        'V':
          begin
            GetCount;
            if Count = 1 then
              AppendFormat(Pointer(ShortDateFormat))
            else
              AppendFormat(Pointer(LongDateFormat));
          end;
        'T':
          begin
            GetCount;
            if Count = 1 then
              AppendFormat(Pointer(ShortTimeFormat))
            else
              AppendFormat(Pointer(LongTimeFormat));
          end;
        'C':
          begin
            GetCount;
            AppendFormat(Pointer(ShortDateFormat));
            if (hhhh <> 0) or (nnnn <> 0) or (ssss <> 0) then
            begin
              AppendChar(' ');
              AppendFormat(Pointer(LongTimeFormat));
            end;
          end;
        '/':
          if DateSeparator <> #0 then
            AppendChar(@DateSeparator);
        ':':
          if TimeSeparator <> #0 then
            AppendChar(@TimeSeparator);
        '''', '"':
          begin
            P := Format;
            while (Format^ <> #0) and (Format^ <> Starter) do
            begin
              if Format^ in LeadBytes then
                Format := StrNextChar(Format)
              else
                Inc(Format);
            end;
            AppendChars(P, Format - P);
            if Format^ <> #0 then Inc(Format);
          end;
        else
          AppendChar(@Starter);
        end;
      end;
      Dec(nLevel);
    end;
  end;

begin
  BufPos := 0;
  nLevel := 0;
  bWidChar := False;
  bJpnChar := False;

  if Format <> '' then
    AppendFormat(Pointer(Format))
  else
    AppendFormat(Pointer('C'));
  SetString(Result, Buffer, BufPos);
end;

////////////////////////////////////////////////////////////////////////////////
//tH[}bg֐Q

//gDateTimeToString
procedure DateTimeToStringEx(var Result: String; const Format: String; DateTime: TDateTime);
var
  lll: Boolean;   //邤NiTrue/Falsej
  ggg: TEraIndex; //
  yyy: Word;      //N
  mmm: Word;      //
  ddd: Word;      //
  www: Word;      //j
  hhh: Word;      //
  nnn: Word;      //
  sss: Word;      //b
  zzz: Word;      //~b
begin
  //N()EEEjE[N擾
  lll := DecodeDateFully(DateTime, yyy, mmm, ddd, www);
  www := (www + 5) mod 7 + 1; //ISO8601

  //EEbE~b擾
  DecodeTime(DateTime, hhh, nnn, sss, zzz);

  //擾
  ggg := High(TEraIndex);
  repeat
    if DateTime >= EraOffsetDate[ggg] then Break;
    Dec(ggg);
  until ggg <= Low(TEraIndex);

  //tH[}bgϊs
  InternalDateTimeToString(Result, Format, lll, ggg, yyy, mmm, ddd, www, hhh, nnn, sss, zzz);
end;

//gFormatDateTime
function FormatDateTimeEx(const Format: String; DateTime: TDateTime): String;
begin
  DateTimeToStringEx(Result, Format, DateTime);
end;

//gDateTimeToStr
function DateTimeToStrEx(DateTime: TDateTime): String;
begin
  DateTimeToStringEx(Result, '', DateTime);
end;

////////////////////////////////////////////////////////////////////////////////
//EXtH[}bg֐Q

//gEXtH[}bg֐
procedure JulianDayToStringEx(var Result: String; const Format: String; Julian: Longint);
var
  lll: Boolean;   //邤NiTrue/Falsej
  ggg: TEraIndex; //
  yyy: Word;      //N
  mmm: Word;      //
  ddd: Word;      //
  www: Word;      //j
begin
  //N()EEEjE[N擾
  lll := DecodeJulianDayFully(Julian, yyy, mmm, ddd, www);

  //擾
  ggg := High(TEraIndex);
  repeat
    if Julian >= EraOffsetJulian[ggg] then Break;
    Dec(ggg);
  until ggg <= Low(TEraIndex);

  //tH[}bgϊs
  InternalDateTimeToString(Result, Format, lll, ggg, yyy, mmm, ddd, www, 12, 0, 0, 0);
end;

//gEXtH[}bg֐
function FormatJulianDayEx(const Format: String; Julian: Longint): String;
begin
  JulianDayToStringEx(Result, Format, Julian);
end;

//gEXϊ֐
function JulianDayToStrEx(Julian: Longint): String;
begin
  JulianDayToStringEx(Result, ShortDateFormat, Julian);
end;

end.
///////////////////////////////////////////////////////// (C)2003-2019 L H
