////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// EXϊ֐\[Xt@C Ver.2.0                                   //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
unit JulianUtils;

interface

uses
  SysUtils, DateUtils;

////////////////////////////////////////////////////////////////////////////////
//EXϊ֐Q
////////////////////////////////////////////////////////////////////////////////

//񁨃EXZo
function StrToJulianDay(const S: String): LongInt;
function TryStrToJulianDay(const S: String; out Value: Longint): Boolean;
function StrToJulianDayDef(const S: String; const Default: Longint): Longint;

//EXZo
procedure JulianDayToString(var Result: String; const Format: String; Julian: Longint);
function FormatJulianDay(const Format: String; Julian: Longint): String;
function JulianDayToStr(Julian: Longint): String;

//NEXZo
function EncodeJulianDay(Year, Month, Day: Word): Longint;
function TryEncodeJulianDay(Year, Month, Day: Word; out Julian: Longint): Boolean;
function EncodeJulianDayDef(Year, Month, Day: Word; const Default: Longint): Longint;

//EXNZo
procedure DecodeJulianDay(const AValue: Longint; var Year, Month, Day: Word);
function DecodeJulianDayFully(const AValue: Longint; var Year, Month, Day, DOW: Word): Boolean;

//NTjEXZo
function EncodeJulianDayWeek(const AYear, AWeekOfYear: Word; const ADayOfWeek: Word = 1): Longint;
function TryEncodeJulianDayWeek(const AYear, AWeekOfYear: Word; out AValue: Longint; const ADayOfWeek: Word = 1): Boolean;
function EncodeJulianDayWeekDef(const AYear, AWeekOfYear: Word; const Default: Longint; const ADayOfWeek: Word = 1): Longint;

//EXNTjZo
procedure DecodeJulianDayWeek(const AValue: Longint; out AYear, AWeekOfYear, ADayOfWeek: Word);

//EXNTjZo
procedure DecodeJulianDayMonthWeek(const AValue: Longint; out AYear, AMonth, AWeekOfMonth, ADayOfWeek: Word);

//TDateTime(TDate)EXZ
function DateToJulianDay(const AValue: TDateTime): Longint;
function TryDateToJulianDay(const AValue: TDateTime; out AJulian: Longint): Boolean;
function DateToJulianDayDef(const AValue: TDateTime; const ADefault: Longint): Longint;

//EXTDateTime(TDate)Z
function JulianDayToDate(const AValue: Longint): TDateTime;
function TryJulianDayToDate(const AValue: Longint; out ADateTime: TDateTime): Boolean;
function JulianDayToDateDef(const AValue: Longint; const ADefault: TDateTime): TDateTime;

//EXjɊZi1:j`7:jj
function DayOfTheWeekJ(const AValue: Longint): Word;

//EXjɊZi1:j`7:yjjISO񏀋
function DayOfWeekJ(const AValue: Longint): Word;

//T擾
function StartOfTheWeekJ(const AValue: Longint; const ADayOfWeek: Word = 1): Longint;
function StartOfAWeekJ(const AYear, AWeekOfYear: Word; const ADayOfWeek: Word = 1): Longint;

//T擾
function EndOfTheWeekJ(const AValue: Longint; const ADayOfWeek: Word = 7): Longint;
function EndOfAWeekJ(const AYear, AWeekOfYear: Word; const ADayOfWeek: Word = 7): Longint;

//擾
function StartOfTheMonthJ(const AValue: Longint): Longint;
function StartOfAMonthJ(const AYear, AMonth: Word): Longint;

//擾
function EndOfTheMonthJ(const AValue: Longint): Longint;
function EndOfAMonthJ(const AYear, AMonth: Word): Longint;

//N擾
function StartOfTheHalfJ(const AValue: Longint): Longint;
function StartOfAHalfJ(const AYear, AMonth: Word): Longint;

//N擾
function EndOfTheHalfJ(const AValue: Longint): Longint;
function EndOfAHalfJ(const AYear, AMonth: Word): Longint;

//N擾
function StartOfTheYearJ(const AValue: Longint): Longint;
function StartOfAYearJ(const AYear: Word): Longint;

//N擾
function EndOfTheYearJ(const AValue: Longint): Longint;
function EndOfAYearJ(const AYear: Word): Longint;

//擾
function DayOfJulian(const AValue: Longint): Word;
function DayOfTheMonthJ(const AValue: Longint): Word;
function DayOfTheYearJ(const AValue: Longint): Word;

//T擾
function WeekOfJulian(const AValue: Longint): Word;
function WeekOfTheYearJ(const AValue: Longint): Word;
function WeekOfTheMonthJ(const AValue: Longint): Word; overload;
function WeekOfTheMonthJ(const AValue: Longint; var AYear, AMonth: Word): Word; overload;

//擾
function MonthOfJulian(const AValue: Longint): Word;
function MonthOfTheYearJ(const AValue: Longint): Word;

//N擾
function YearOfJulian(const AValue: Longint): Word;

//
function IncMonthJ(const AValue: Longint; NumberOfMonths: Integer = 1): Longint;

////////////////////////////////////////////////////////////////////////////////
//萔
////////////////////////////////////////////////////////////////////////////////
const
  MinJulianDay = 2361239; //1752/10/01  {܂́A1721426; //0001/01/01}
  MaxJulianDay = 5373484; //9999/12/31

////////////////////////////////////////////////////////////////////////////////

implementation

////////////////////////////////////////////////////////////////////////////////
//EXϊ֐Q

//񁨃EXZo
function StrToJulianDay(const S: String): LongInt;
begin
  Result := DateToJulianDay(StrToDate(S));
end;

function TryStrToJulianDay(const S: String; out Value: Longint): Boolean;
var
  D: TDateTime;
begin
  Result := False;
  if not TryStrToDate(S, D) then Exit;
  if not TryDateToJulianDay(D, Value) then Exit;
  Result := True;
end;

function StrToJulianDayDef(const S: String; const Default: Longint): Longint;
begin
  if not TryStrToJulianDay(S, Result) then Result := Default;
end;

//EXZo
procedure JulianDayToString(var Result: String; const Format: String; Julian: Longint);
begin
  DateTimeToString(Result, Format, JulianDayToDate(Julian));
end;

function FormatJulianDay(const Format: String; Julian: Longint): String;
begin
  DateTimeToString(Result, Format, JulianDayToDate(Julian));
end;

function JulianDayToStr(Julian: Longint): String;
begin
  DateTimeToString(Result, ShortDateFormat, JulianDayToDate(Julian));
end;

//NEXZo
function EncodeJulianDay(Year, Month, Day: Word): Longint;
begin
  if Month < 3 then
    Result := ((Year + 4799) * 1461) div 4 + ((Month + 10) * 367) div 12 - (((Year + 4899) div 100) * 3) div 4
  else
    Result := ((Year + 4800) * 1461) div 4 + ((Month -  2) * 367) div 12 - (((Year + 4900) div 100) * 3) div 4;
  Result := Result + Day - 32075;
end;

function TryEncodeJulianDay(Year, Month, Day: Word; out Julian: Longint): Boolean;
begin
  Result := False;
  if not IsValidDate(Year, Month, Day) then Exit;
  Julian := EncodeJulianDay(Year, Month, Day);
  Result := True;
end;

function EncodeJulianDayDef(Year, Month, Day: Word; const Default: Longint): Longint;
begin
  if not TryEncodeJulianDay(Year, Month, Day, Result) then Result := Default;
end;

//EXNZo
procedure DecodeJulianDay(const AValue: Longint; var Year, Month, Day: Word);
var
  L, N: Integer;
begin
  L := AValue + 68569;
  N := 4 * L div 146097;
  L := L - (146097 * N + 3) div 4;
  Year := 4000 * (L + 1) div 1461001;
  L := L - 1461 * Year div 4 + 31;
  Month := 80 * L div 2447;
  Day := L - 2447 * Month div 80;
  L := Month div 11;
  Month := Month + 2 - 12 * L;
  Year := 100 * (N - 49) + Year + L;
end;

function DecodeJulianDayFully(const AValue: Longint; var Year, Month, Day, DOW: Word): Boolean;
begin
  DecodeJulianDay(AValue, Year, Month, Day);
  DOW := DayOfTheWeekJ(AValue);
  //DOW := DayOfWeekJ(Julian);
  Result := IsLeapYear(Year);
end;

procedure DecodeJulianDayMonthWeek(const AValue: Longint; out AYear, AMonth, AWeekOfMonth, ADayOfWeek: Word);
const
  CDayMap: array [1..7] of Word = (7, 1, 2, 3, 4, 5, 6);
var
  LDay, LDaysInMonth: Word;
  LDayOfMonth: Integer;
  LStart: Longint;
  LStartDayOfWeek, LEndOfMonthDayOfWeek: Word;
begin
  DecodeJulianDayFully(AValue, AYear, AMonth, LDay, ADayOfWeek);
  ADayOfWeek := CDayMap[ADayOfWeek];
  LStart := EncodeJulianDay(AYear, AMonth, 1);
  LStartDayOfWeek := DayOfTheWeekJ(LStart);
  LDayOfMonth := LDay;
  if LStartDayOfWeek in [DayFriday, DaySaturday, DaySunday] then
    Dec(LDayOfMonth, 8 - LStartDayOfWeek)
  else
    Inc(LDayOfMonth, LStartDayOfWeek - 1);
  if LDayOfMonth <= 0 then
    DecodeJulianDayMonthWeek(LStart - 1, AYear, AMonth, AWeekOfMonth, LDay)
  else
  begin
    AWeekOfMonth := LDayOfMonth div 7;
    if LDayOfMonth mod 7 <> 0 then
      Inc(AWeekOfMonth);
    LDaysInMonth := DaysInAMonth(AYear, AMonth);
    LEndOfMonthDayOfWeek := DayOfTheWeek(EncodeJulianDay(AYear, AMonth, LDaysInMonth));
    if (LEndOfMonthDayOfWeek in [DayMonday, DayTuesday, DayWednesday]) and
       (LDaysInMonth - LDay < LEndOfMonthDayOfWeek) then
    begin
      Inc(AMonth);
      if AMonth = 13 then
      begin
        AMonth := 1;
        Inc(AYear);
      end;
      AWeekOfMonth := 1;
    end;
  end;
end;

//NTjEXZo
function EncodeJulianDayWeek(const AYear, AWeekOfYear, ADayOfWeek: Word): Longint;
var
  LDayOfYear: Integer;
  LStartDayOfWeek: Word;
begin
  Result := EncodeJulianDay(AYear, 1, 1);
  LStartDayOfWeek := DayOfTheWeekJ(Result);
  LDayOfYear := (AWeekOfYear - 1) * 7 + ADayOfWeek - 1;
  if LStartDayOfWeek in [DayFriday, DaySaturday, DaySunday] then
    Inc(LDayOfYear, 8 - LStartDayOfWeek)
  else
    Dec(LDayOfYear, LStartDayOfWeek - 1);
  Result := Result + LDayOfYear;
end;

function TryEncodeJulianDayWeek(const AYear, AWeekOfYear: Word; out AValue: Longint; const ADayOfWeek: Word): Boolean;
begin
  Result := False;
  if not IsValidDateWeek(AYear, AWeekOfYear, ADayOfWeek) then Exit;
  AValue := EncodeJulianDayWeek(AYear, AWeekOfYear, ADayOfWeek);
  Result := True;
end;

function EncodeJulianDayWeekDef(const AYear, AWeekOfYear: Word; const Default: Longint; const ADayOfWeek: Word): Longint;
begin
  if not TryEncodeJulianDayWeek(AYear, AWeekOfYear, Result, ADayOfWeek) then Result := Default;
end;

//EXNTjZo
procedure DecodeJulianDayWeek(const AValue: Longint; out AYear, AWeekOfYear, ADayOfWeek: Word);
var
  LDayOfYear: Integer;
  LMonth, LDay: Word;
  LStart: Longint;
  LStartDayOfWeek, LEndDayOfWeek: Word;
  LLeap: Boolean;
begin
  LLeap := DecodeJulianDayFully(AValue, AYear, LMonth, LDay, ADayOfWeek);
  LStart := EncodeJulianDay(AYear, 1, 1);
  LDayOfYear := Trunc(AValue - LStart + 1);
  LStartDayOfWeek := DayOfTheWeekJ(LStart);
  if LStartDayOfWeek in [DayFriday, DaySaturday, DaySunday] then
    Dec(LDayOfYear, 8 - LStartDayOfWeek)
  else
    Inc(LDayOfYear, LStartDayOfWeek - 1);
  if LDayOfYear <= 0 then
    DecodeJulianDayWeek(LStart - 1, AYear, AWeekOfYear, LDay)
  else
  begin
    AWeekOfYear := LDayOfYear div 7;
    if LDayOfYear mod 7 <> 0 then
      Inc(AWeekOfYear);
    if AWeekOfYear > 52 then
    begin
      LEndDayOfWeek := LStartDayOfWeek;
      if LLeap then
      begin
        if LEndDayOfWeek = DaySunday then
          LEndDayOfWeek := DayMonday
        else
          Inc(LEndDayOfWeek);
      end;
      if LEndDayOfWeek in [DayMonday, DayTuesday, DayWednesday] then
      begin
        Inc(AYear);
        AWeekOfYear := 1;
      end;
    end;
  end;
end;

//TDateTime(TDate)EXZ
function DateToJulianDay(const AValue: TDateTime): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeDate(AValue, LYear, LMonth, LDay);
  Result := EncodeJulianDay(LYear, LMonth, LDay);
end;

function TryDateToJulianDay(const AValue: TDateTime; out AJulian: Longint): Boolean;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeDate(AValue, LYear, LMonth, LDay);
  Result := TryEncodeJulianDay(LYear, LMonth, LDay, AJulian);
end;

function DateToJulianDayDef(const AValue: TDateTime; const ADefault: Longint): Longint;
begin
  if not TryDateToJulianDay(AValue, Result) then Result := ADefault;
end;

//EXTDateTime(TDate)Z
function JulianDayToDate(const AValue: Longint): TDateTime;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := EncodeDate(LYear, LMonth, LDay);
end;

function TryJulianDayToDate(const AValue: Longint; out ADateTime: TDateTime): Boolean;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := TryEncodeDate(LYear, LMonth, LDay, ADateTime);
end;

function JulianDayToDateDef(const AValue: Longint; const ADefault: TDateTime): TDateTime;
begin
  if not TryJulianDayToDate(AValue, Result) then Result := ADefault;
end;

//EXjɊZi1:j`7:jj
function DayOfTheWeekJ(const AValue: Longint): Word;
begin
  Result := AValue mod 7 + 1;
end;

//EXjɊZi1:j`7:yjjISO񏀋
function DayOfWeekJ(const AValue: Longint): Word;
begin
  Result := (AValue + 1) mod 7 + 1;
end;

//T擾
function StartOfTheWeekJ(const AValue: Longint; const ADayOfWeek: Word): Longint;
begin
  Result := AValue - (DayOfTheWeekJ(AValue) - ADayOfWeek + 7) mod 7;
end;

function StartOfAWeekJ(const AYear, AWeekOfYear: Word; const ADayOfWeek: Word): Longint;
begin
  Result := EncodeJulianDayWeek(AYear, AWeekOfYear, ADayOfWeek);
end;

//T擾
function EndOfTheWeekJ(const AValue: Longint; const ADayOfWeek: Word): Longint;
begin
  Result := AValue + (ADayOfWeek - DayOfTheWeekJ(AValue) + 6) mod 7;
end;

function EndOfAWeekJ(const AYear, AWeekOfYear: Word; const ADayOfWeek: Word): Longint;
begin
  Result := EncodeJulianDayWeek(AYear, AWeekOfYear, ADayOfWeek);
end;

//擾
function StartOfTheMonthJ(const AValue: Longint): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := EncodeJulianDay(LYear, LMonth, 1);
end;

function StartOfAMonthJ(const AYear, AMonth: Word): Longint;
begin
  Result := EncodeJulianDay(AYear, AMonth, 1);
end;

//擾
function EndOfTheMonthJ(const AValue: Longint): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := EncodeJulianDay(LYear, LMonth, DaysInAMonth(LYear, LMonth));
end;

function EndOfAMonthJ(const AYear, AMonth: Word): Longint;
begin
  Result := EncodeJulianDay(AYear, AMonth, DaysInAMonth(AYear, AMonth));
end;

//N擾
function StartOfTheHalfJ(const AValue: Longint): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := StartOfAHalfJ(LYear, LYear);
end;

function StartOfAHalfJ(const AYear, AMonth: Word): Longint;
begin
  if AMonth < 7 then
    Result := EncodeJulianDay(AYear, 1, 1)
  else
    Result := EncodeJulianDay(AYear, 7, 1);
end;

//N擾
function EndOfTheHalfJ(const AValue: Longint): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := EndOfAHalfJ(LYear, LMonth);
end;

function EndOfAHalfJ(const AYear, AMonth: Word): Longint;
begin
  if AMonth > 6 then
    Result := EncodeJulianDay(AYear, 12, 31)
  else
    Result := EncodeJulianDay(AYear, 6, 30);
end;

//N擾
function StartOfTheYearJ(const AValue: Longint): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := EncodeJulianDay(LYear, 1, 1);
end;

function StartOfAYearJ(const AYear: Word): Longint;
begin
  Result := EncodeJulianDay(AYear, 1, 1);
end;

//N擾
function EndOfTheYearJ(const AValue: Longint): Longint;
var
  LYear, LMonth, LDay: Word;
begin
  DecodeJulianDay(AValue, LYear, LMonth, LDay);
  Result := EncodeJulianDay(LYear, 12, 31);
end;

function EndOfAYearJ(const AYear: Word): Longint;
begin
  Result := EncodeJulianDay(AYear, 12, 31);
end;

//擾
function DayOfJulian(const AValue: Longint): Word;
var
  Year, Month: Word;
begin
  DecodeJulianDay(AValue, Year, Month, Result);
end;

function DayOfTheMonthJ(const AValue: Longint): Word;
begin
  Result := DayOfJulian(AValue);
end;

function DayOfTheYearJ(const AValue: Longint): Word;
begin
  Result := AValue - StartOfTheYearJ(AValue) + 1;
end;

//T擾
function WeekOfJulian(const AValue: Longint): Word;
var
  LYear, LDOW: Word;
begin
  DecodeJulianDayWeek(AValue, LYear, Result, LDOW);
end;

function WeekOfTheYearJ(const AValue: Longint): Word;
begin
  Result := WeekOfJulian(AValue);
end;

function WeekOfTheMonthJ(const AValue: Longint): Word; overload;
var
  LYear, LMonth, LDayOfWeek: Word;
begin
  DecodeJulianDayMonthWeek(AValue, LYear, LMonth, Result, LDayOfWeek);
end;

function WeekOfTheMonthJ(const AValue: Longint; var AYear, AMonth: Word): Word; overload;
var
  LDayOfWeek: Word;
begin
  DecodeJulianDayMonthWeek(AValue, AYear, AMonth, Result, LDayOfWeek);
end;

//擾
function MonthOfJulian(const AValue: Longint): Word;
var
  Year, Day: Word;
begin
  DecodeJulianDay(AValue, Year, Result, Day);
end;

function MonthOfTheYearJ(const AValue: Longint): Word;
begin
  Result := MonthOfJulian(AValue);
end;

//N擾
function YearOfJulian(const AValue: Longint): Word;
var
  Month, Day: Word;
begin
  DecodeJulianDay(AValue, Result, Month, Day);
end;

//
function IncMonthJ(const AValue: Longint; NumberOfMonths: Integer): Longint;
var
  Year, Month, Day: Word;
begin
  DecodeJulianDay(AValue, Year, Month, Day);
  IncAMonth(Year, Month, Day, NumberOfMonths);
  Result := EncodeJulianDay(Year, Month, Day);
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H
