////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// TIntegerEdit, TDecimalEdit, TDateTimeEdit \[Xt@C Ver.2.0           //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
{
  TDisableEdit̓ȃvpeB
    Alignment     : eLXgzuiEEEj
    DisableColor  : GfB^̐F
    EnableColor   : GfB^L̐F
    EditorEnabled : GfB^̗LE
}
{
  TIntegerEdit̓ȃvpeB
    MaxValue      : ͉\ȍőlij
    MinValue      : ͉\ȍŏlij
    ShowPlus      : ̂Ƃ\邩ۂ
    Thousands     : ؂L\邩ۂ
    Value         : ͂Ălij
    ZeroFill      : ő̌܂0Ŗ߂邩ۂ
    ZeroBlank     : l0̂ƂeLXg邩ۂ
}
{
  TDecimalEdit̓ȃvpeB
    DecimalLength : ̍ő包
    IntegerLength : ̍ő包
    MaxValue      : ͉\ȍőlij
    MinValue      : ͉\ȍŏlij
    ShowPlus      : ̂Ƃ\邩ۂ
    Thousands     : ؂L\邩ۂ
    Value         : ͂Ălij
    ZeroFill      : ő̌܂0Ŗ߂邩ۂ
    ZeroBlank     : l0̂ƂeLXg邩ۂ
    ZeroFixed     : ̌Œ肷邩ۂ
}
{
  TDateTimeEdit̓ȃvpeB
    Checked       : 󔒂ۂi`FbN{bNXł͂ȂA͂ȂFalsej
    Kind          : ͎ʁitEj
    Date          : Kind = dtkDate ̂ƂA͂Ăt̒l
    Time          : Kind = dtkTime ̂ƂA͂Ă鎞̒l
    MaxValue      : ͉\ȍőlij
    MinValue      : ͉\ȍŏlij
    EditFormat    : ҏW̕\`iDateTimeToStringExQƁj
    TextFormat    : ҏW̕\`iDateTimeToStringExQƁj
}
unit NumericEdit;

interface

uses
  Messages, Windows, SysUtils, Graphics, Classes, Controls, StdCtrls, ComCtrls;

type
  TDisableEdit = class(TCustomEdit)
  private
    { Private 錾 }
    FAlignment: TAlignment;
    FDisableColor: TColor;
    FEnableColor: TColor;
    FEditorEnabled: Boolean;
    function IsKeyEnable: Boolean;
    procedure SetAlignment(Value: TAlignment);
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure WMCut(var Message: TWMCut); message WM_CUT;
    procedure WMPaste(var Message: TWMPaste); message WM_PASTE;
    procedure WMClear(var Message: TWMClear); message WM_CLEAR;
    procedure WMUndo(var Message: TWMUndo); message WM_UNDO;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure SetEnabled(Value: Boolean); override;
    procedure SetDisableColor(Value: TColor);
    procedure SetEnableColor(Value: TColor);
    procedure SetEditorEnabled(Value: Boolean);
    procedure ResetValue; virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    function GetControlsAlignment: TAlignment; override;
  published
    { Published 錾 }
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color stored False;
    property Constraints;
    property Ctl3D;
    property DisableColor: TColor read FDisableColor write SetDisableColor default clBtnFace;
    property DragCursor;
    property DragKind;
    property DragMode;
    property EditorEnabled: Boolean read FEditorEnabled write SetEditorEnabled default True;
    property EnableColor: TColor read FEnableColor write SetEnableColor default clWindow;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    //property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  TNumericEdit = class(TDisableEdit)
  private
    { Private 錾 }
  protected
    { Protected 錾 }
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    function IsValidChar(Key: Char): Boolean; virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    function UseRightToLeftAlignment: Boolean; override;
  published
    { Published 錾 }
    property Alignment default taRightJustify;
    property ImeMode default imDisable;
  end;

  TIntegerEdit = class(TNumericEdit)
  private
    { Private 錾 }
    FMinValue: LongInt;
    FMaxValue: LongInt;
    FThousands: Boolean;
    FShowPlus: Boolean;
    FZeroFill: Boolean;
    FZeroBlank: Boolean;
    function GetValue: LongInt;
    procedure SetValue(NewValue: LongInt);
    procedure SetShowPlus(Value: Boolean);
    procedure SetZeroFill(Value: Boolean);
    procedure SetZeroBlank(Value: Boolean);
    procedure SetThousands(Value: Boolean);
  protected
    { Protected 錾 }
    procedure ResetValue; override;
    function CheckValue(NewValue: LongInt): LongInt;
    function FormatValue(NewValue: LongInt): String;
    function IsValidChar(Key: Char): Boolean; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property MaxValue: LongInt read FMaxValue write FMaxValue default 0;
    property MinValue: LongInt read FMinValue write FMinValue default 0;
    property ShowPlus: Boolean read FShowPlus write SetShowPlus default False;
    property Text stored False;
    property Thousands: Boolean read FThousands write SetThousands default False;
    property Value: LongInt read GetValue write SetValue default 0;
    property ZeroFill: Boolean read FZeroFill write SetZeroFill default False;
    property ZeroBlank: Boolean read FZeroBlank write SetZeroBlank default False;
  end;

  TDecimalEdit = class(TNumericEdit)
  private
    { Private 錾 }
    FMinValue: Extended;
    FMaxValue: Extended;
    FIntegerLength: Byte;
    FDecimalLength: Byte;
    FThousands: Boolean;
    FShowPlus: Boolean;
    FZeroFixed: Boolean;
    FZeroFill: Boolean;
    FZeroBlank: Boolean;
    function FloatToDigits(Value: Extended): String;
    function DigitsToFloat(const S: String): Extended;
    function GetValue: Extended;
    procedure SetValue(NewValue: Extended);
    procedure SetShowPlus(Value: Boolean);
    procedure SetZeroFixed(Value: Boolean);
    procedure SetZeroFill(Value: Boolean);
    procedure SetZeroBlank(Value: Boolean);
    procedure SetThousands(Value: Boolean);
    procedure SetDecimalLength(Value: Byte);
    procedure SetIntegerLength(Value: Byte);
  protected
    { Protected 錾 }
    procedure ResetValue; override;
    function CheckValue(NewValue: Extended): Extended;
    function FormatValue(NewValue: String): String;
    function IsValidChar(Key: Char): Boolean; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property DecimalLength: Byte read FDecimalLength write SetDecimalLength default 2;
    property IntegerLength: Byte read FIntegerLength write SetIntegerLength default 0;
    property MaxValue: Extended read FMaxValue write FMaxValue;
    property MinValue: Extended read FMinValue write FMinValue;
    property ShowPlus: Boolean read FShowPlus write SetShowPlus default False;
    property Thousands: Boolean read FThousands write SetThousands default False;
    property Value: Extended read GetValue write SetValue stored False;
    property ZeroBlank: Boolean read FZeroBlank write SetZeroBlank default False;
    property ZeroFill: Boolean read FZeroFill write SetZeroFill default False;
    property ZeroFixed: Boolean read FZeroFixed write SetZeroFixed default False;
  end;

  TDateTimeEdit = class(TDisableEdit)
  private
    { Private 錾 }
    FChecked: Boolean;
    FKind: TDateTimeKind;
    FDateTime: TDateTime;
    FMinValue: TDateTime;
    FMaxValue: TDateTime;
    FEditFormat: String;
    FTextFormat: String;
    function IsStoreDate: Boolean;
    function IsStoreTime: Boolean;
    function GetDate: TDate;
    function GetTime: TTime;
    procedure SetChecked(Value: Boolean);
    procedure SetDate(Value: TDate);
    procedure SetTime(Value: TTime);
    procedure SetEditFormat(Value: String);
    procedure SetTextFormat(Value: String);
    procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected
    { Protected 錾 }
    function GetDateTime: TDateTime; virtual;
    function GetMaxValue: String; virtual;
    function GetMinValue: String; virtual;
    procedure SetDateTime(Value: TDateTime); virtual;
    procedure SetMaxValue(Value: String); virtual;
    procedure SetMinValue(Value: String); virtual;

    procedure SetKind(Value: TDateTimeKind); virtual;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    function IsValidChar(Key: Char): Boolean; virtual;
    procedure SetValue;
    procedure ResetValue; override;
    function CheckValue(Value: TDateTime): TDateTime;
    function FormatValue(AFormat: String): String;
    function UnformatValue(AText: String): TDateTime;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    property DateTime: TDateTime read GetDateTime write SetDateTime;
  published
    { Published 錾 }
    property ImeMode default imDisable;
    property Checked: Boolean read FChecked write SetChecked default False;
    property Kind: TDateTimeKind read FKind write SetKind default dtkDate;
    property Date: TDate read GetDate write SetDate stored IsStoreDate;
    property Time: TTime read GetTime write SetTime stored IsStoreTime;
    property MaxValue: String read GetMaxValue write SetMaxValue;
    property MinValue: String read GetMinValue write SetMinValue;
    property EditFormat: String read FEditFormat write SetEditFormat;
    property TextFormat: String read FTextFormat write SetTextFormat;
    property Text stored False;
  end;

implementation

uses
  DateUtilsEx;

////////////////////////////////////////////////////////////////////////////////
// TDisableEdit                                                               //
////////////////////////////////////////////////////////////////////////////////

constructor TDisableEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle - [csSetCaption];
  FAlignment := taLeftJustify;
  FEditorEnabled := True;
  FEnableColor := clWindow;
  FDisableColor := clBtnFace;
end;

procedure TDisableEdit.CreateParams(var Params: TCreateParams);
const
  Alignments: array[Boolean, TAlignment] of DWORD =
    ((ES_LEFT, ES_RIGHT, ES_CENTER),(ES_RIGHT, ES_LEFT, ES_CENTER));
begin
  inherited CreateParams(Params);
  with Params do
    Style := Style or Alignments[UseRightToLeftAlignment, FAlignment];
end;

procedure TDisableEdit.CMColorChanged(var Message: TMessage);
begin
  inherited;
  if IsKeyEnable then
    FEnableColor := Color
  else
    FDisableColor := Color;
end;

procedure TDisableEdit.CMEnter(var Message: TCMGotFocus);
begin
  if AutoSelect and not (csLButtonDown in ControlState) then SelectAll;
  inherited;
end;

procedure TDisableEdit.CMExit(var Message: TCMExit);
begin
  inherited;
  ResetValue;
end;

procedure TDisableEdit.WMCut(var Message: TWMPaste);
begin
  if (not FEditorEnabled) or ReadOnly then Exit;
  inherited;
  ResetValue;
end;

procedure TDisableEdit.WMPaste(var Message: TWMPaste);
begin
  if (not FEditorEnabled) or ReadOnly then Exit;
  inherited;
  ResetValue;
end;

procedure TDisableEdit.WMClear(var Message: TWMClear);
begin
  if (not FEditorEnabled) or ReadOnly then Exit;
  inherited;
  ResetValue;
end;

procedure TDisableEdit.WMUndo(var Message: TWMUndo);
begin
  if (not FEditorEnabled) or ReadOnly then Exit;
  inherited;
  ResetValue;
end;

function TDisableEdit.GetControlsAlignment: TAlignment;
begin
  Result := FAlignment;
end;

procedure TDisableEdit.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    RecreateWnd;
  end;
end;

procedure TDisableEdit.SetEditorEnabled(Value: Boolean);
begin
  if FEditorEnabled <> Value then
  begin
    FEditorEnabled := Value;
    if IsKeyEnable then
      Color := FEnableColor
    else
      Color := FDisableColor;
  end;
end;

procedure TDisableEdit.SetEnabled(Value: Boolean);
begin
  if Enabled <> Value then
  begin
    inherited SetEnabled(Value);
    if IsKeyEnable then
      Color := FEnableColor
    else
      Color := FDisableColor;
  end;
end;

procedure TDisableEdit.SetEnableColor(Value: TColor);
begin
  if (Color <> Value)and(IsKeyEnable) then Color := Value;
  if FEnableColor <> Value then FEnableColor := Value;
end;

procedure TDisableEdit.SetDisableColor(Value: TColor);
begin
  if (Color <> Value)and(not IsKeyEnable) then Color := Value;
  if FDisableColor <> Value then FDisableColor := Value;
end;

function TDisableEdit.IsKeyEnable: Boolean;
begin
  Result := (Enabled and FEditorEnabled);
end;

procedure TDisableEdit.ResetValue;
begin
//_~[
end;


////////////////////////////////////////////////////////////////////////////////
// TNumericEdit                                                               //
////////////////////////////////////////////////////////////////////////////////

constructor TNumericEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAlignment := taRightJustify;
  ImeMode := imDisable;
end;

function TNumericEdit.UseRightToLeftAlignment: Boolean;
begin
  Result := False;
end;

procedure TNumericEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (not FEditorEnabled) and (Key = VK_DELETE) then
  begin
    MessageBeep(0);
    Key := 0;
  end;
  if Key <> 0 then inherited KeyDown(Key, Shift);
end;

procedure TNumericEdit.KeyPress(var Key: Char);
begin
  if not IsValidChar(Key) then Key := #0;
  if Key <> #0 then inherited KeyPress(Key);
end;

function TNumericEdit.IsValidChar(Key: Char): Boolean;
begin
  Result := False;
  if (Key in [DecimalSeparator, ThousandSeparator, '+', '-', '0'..'9']) or (Key < #32) then
  begin
    if (not FEditorEnabled) and ((Key >= #32) or
      (Key = Chr(VK_ESCAPE)) or (Key = Chr(VK_RETURN)) or (Key = Char(VK_BACK))) then
    begin
      MessageBeep(0);
    end
    else if (Key = Chr(VK_ESCAPE)) or (Key = Chr(VK_RETURN)) then
    begin
      ResetValue;
    end
    else
    begin
      Result := True;
    end;
  end
  else
  begin
    MessageBeep(0);
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// TIntegerEdit                                                               //
////////////////////////////////////////////////////////////////////////////////

constructor TIntegerEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FShowPlus := False;
  FZeroFill := False;
  FZeroBlank := False;
  FThousands := False;
  FMaxValue := 0;
  FMinValue := 0;
  Value := 0;
end;

function TIntegerEdit.IsValidChar(Key: Char): Boolean;
begin
  Result := inherited IsValidChar(Key);
  if Result then
  begin
    if ((Key = ThousandSeparator)and(not FThousands))or
        (Key = DecimalSeparator) then
    begin
      MessageBeep(0);
      Result := False;
    end
    else if Key = '+' then
    begin
      if (FMaxValue >= 0)and(Value < 0) then Value := - Value;
      Result := False;
    end
    else if Key = '-' then
    begin
      if (FMinValue <= 0)and(FMaxValue >= 0)and(Value <> 0) then Value := - Value;
      Result := False;
    end;
  end;
end;

procedure TIntegerEdit.SetShowPlus(Value: Boolean);
begin
  if FShowPlus <> Value then
  begin
    FShowPlus := Value;
    ResetValue;
  end;
end;

procedure TIntegerEdit.SetZeroFill(Value: Boolean);
begin
  if FZeroFill <> Value then
  begin
    FZeroFill := Value;
    if FThousands and Value then FThousands := False;
    ResetValue;
  end;
end;

procedure TIntegerEdit.SetZeroBlank(Value: Boolean);
begin
  if FZeroBlank <> Value then
  begin
    FZeroBlank := Value;
    ResetValue;
  end;
end;

procedure TIntegerEdit.SetThousands(Value: Boolean);
begin
  if FThousands <> Value then
  begin
    FThousands := Value;
    if FZeroFill and Value then FZeroFill := False;
    ResetValue;
  end;
end;

function TIntegerEdit.GetValue: LongInt;
begin
  Result := CheckValue(StrToIntDef(StringReplace(Text, ThousandSeparator, '', [rfReplaceAll, rfIgnoreCase]), 0));
end;

procedure TIntegerEdit.SetValue(NewValue: LongInt);
begin
  Text := FormatValue(CheckValue(NewValue));
end;

procedure TIntegerEdit.ResetValue;
begin
  Text := FormatValue(Value);
end;

function TIntegerEdit.CheckValue(NewValue: LongInt): LongInt;
begin
  if (FMaxValue > FMinValue) then
  begin
    if NewValue < FMinValue then
      NewValue := FMinValue
    else if NewValue > FMaxValue then
      NewValue := FMaxValue;
  end;
  Result := NewValue;
end;

function TIntegerEdit.FormatValue(NewValue: LongInt): String;
var
  ValStr, TmpStr: String;
  nLen, nPos: Integer;
  bBreak: Boolean;
begin
  ValStr := '';
  if (not FZeroBlank)or(NewValue <> 0) then
  begin
    if FZeroFill then
    begin
      if (FShowPlus)and(NewValue > 0) then
        ValStr := '+' + Format('%.*d', [MaxLength - 1, NewValue])
      else if NewValue < 0 then
        ValStr := Format('%.*d', [MaxLength - 1, NewValue])
      else
        ValStr := Format('%.*d', [MaxLength, NewValue]);
    end
    else
    begin
      TmpStr := IntToStr(Abs(NewValue));
      nLen := 0;
      nPos := Length(TmpStr);
      bBreak := False;
      while (nPos > 0)and(not bBreak) do
      begin
        if FThousands then
        begin
          if nLen mod 4 = 3 then
          begin
            if MaxLength > 0 then
            begin
              if ((FShowPlus)and(NewValue > 0))or(NewValue < 0) then
                bBreak := (nLen + 2 >= MaxLength)
              else
                bBreak := (nLen + 1 >= MaxLength);
            end;
            if not bBreak then
            begin
              ValStr := ThousandSeparator + ValStr;
              Inc(nLen);
            end;
          end;
        end;
        if not bBreak then
        begin
          ValStr := TmpStr[nPos] + ValStr;
          Inc(nLen);
          Dec(nPos);
          if MaxLength > 0 then
          begin
            if ((FShowPlus)and(NewValue > 0))or(NewValue < 0) then
              bBreak := (nLen + 1 >= MaxLength)
            else
              bBreak := (nLen >= MaxLength);
          end;
        end;
      end;
      if (FShowPlus)and(NewValue > 0) then
        ValStr := '+' + ValStr
      else if NewValue < 0 then
        ValStr := '-' + ValStr;
    end;
  end;
  Result := ValStr;
end;


////////////////////////////////////////////////////////////////////////////////
// TDecimalEdit                                                               //
////////////////////////////////////////////////////////////////////////////////

constructor TDecimalEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FShowPlus := False;
  FZeroFixed := False;
  FZeroFill := False;
  FZeroBlank := False;
  FThousands := False;
  FDecimalLength := 2;
  FIntegerLength := 0;
  FMaxValue := 0.0;
  FMinValue := 0.0;
  Text := '0';
  ImeMode := imDisable;
end;

function TDecimalEdit.IsValidChar(Key: Char): Boolean;
begin
  Result := inherited IsValidChar(Key);
  if Result then
  begin
    if ((Key = ThousandSeparator)and(not FThousands))or
       ((Key = DecimalSeparator)and(FZeroFixed)and(FDecimalLength = 0)) then
    begin
      MessageBeep(0);
      Result := False;
    end
    else if Key = '+' then
    begin
      if (FMaxValue >= 0.0)and(Value < 0.0) then Value := - Value;
      Result := False;
    end
    else if Key = '-' then
    begin
      if (FMinValue <= 0.0)and(FMaxValue >= 0.0)and(Value <> 0.0) then Value := - Value;
      Result := False;
    end;
  end;
end;

procedure TDecimalEdit.SetShowPlus(Value: Boolean);
begin
  if FShowPlus <> Value then
  begin
    FShowPlus := Value;
    ResetValue;
  end;
end;

procedure TDecimalEdit.SetZeroFill(Value: Boolean);
begin
  if FZeroFill <> Value then
  begin
    FZeroFill := Value;
    if FThousands and Value then FThousands := False;
    ResetValue;
  end;
end;

procedure TDecimalEdit.SetZeroBlank(Value: Boolean);
begin
  if FZeroBlank <> Value then
  begin
    FZeroBlank := Value;
    ResetValue;
  end;
end;

procedure TDecimalEdit.SetThousands(Value: Boolean);
begin
  if FThousands <> Value then
  begin
    FThousands := Value;
    if FZeroFill and Value then FZeroFill := False;
    ResetValue;
  end;
end;

procedure TDecimalEdit.SetZeroFixed(Value: Boolean);
begin
  if FZeroFixed <> Value then
  begin
    FZeroFixed := Value;
    ResetValue;
  end;
end;

procedure TDecimalEdit.SetDecimalLength(Value: Byte);
begin
  if FDecimalLength <> Value then
  begin
    FDecimalLength := Value;
    ResetValue;
  end;
end;

procedure TDecimalEdit.SetIntegerLength(Value: Byte);
begin
  if FIntegerLength <> Value then
  begin
    FIntegerLength := Value;
    ResetValue;
  end;
end;

function TDecimalEdit.GetValue: Extended;
begin
  Result := CheckValue(DigitsToFloat(Text));
end;

procedure TDecimalEdit.SetValue(NewValue: Extended);
begin
  Text := FormatValue(FloatToDigits(CheckValue(NewValue)));
end;

procedure TDecimalEdit.ResetValue;
begin
  Text := FormatValue(FloatToDigits(Value));
end;

function TDecimalEdit.CheckValue(NewValue: Extended): Extended;
begin
  if (FMaxValue > FMinValue) then
  begin
    if NewValue < FMinValue then
      NewValue := FMinValue
    else if NewValue > FMaxValue then
      NewValue := FMaxValue;
  end;
  Result := NewValue;
end;

function TDecimalEdit.FormatValue(NewValue: String): String;
var
  ValStr, ValSign, ValInt, ValDec: String;
  ValLen, DotPos: Integer;
begin
  ValStr := '';
  ValLen := Length(NewValue);
  if ValLen > 0 then
  begin
    case NewValue[1] of
    '-', '+':
      begin
        ValSign := NewValue[1];
        Delete(NewValue, 1, 1);
        ValLen := Length(NewValue);
      end;
    else
      ValSign := '';
    end;
  end;

  if ValLen > 0 then
  begin
    DotPos := Pos(DecimalSeparator, NewValue);
    ValDec := '';
    if DotPos > 0 then
    begin
      ValInt := Copy(NewValue, 1, DotPos - 1);
      ValDec := Copy(NewValue, DotPos + 1, ValLen);
    end
    else
    begin
      ValInt := NewValue;
    end;

    ValLen := Length(ValInt);
    if FIntegerLength > 0 then
    begin
      if (FZeroFill)and(FIntegerLength > ValLen) then
        ValInt := StringOfChar('0', FIntegerLength - ValLen) + ValInt
      else if ValLen > FIntegerLength then
        Delete(ValInt, 1, ValLen - FIntegerLength);
      ValLen := Length(ValInt);
    end;
    if ValLen > 0 then
    begin
      DotPos := 0;
      while ValLen > 0 do
      begin
        if FThousands then
        begin
          if DotPos = 3 then
          begin
            ValStr := ThousandSeparator + ValStr;
            DotPos := 1;
          end
          else
            Inc(DotPos);
        end;
        ValStr := ValInt[ValLen] + ValStr;
        Dec(ValLen);
      end;
    end;

    ValLen := Length(ValDec);
    if (FZeroFixed)and(FDecimalLength > ValLen) then
      ValDec := ValDec + StringOfChar('0', FDecimalLength - ValLen)
    else if ValLen > FDecimalLength then
      Delete(ValDec, FDecimalLength + 1, ValLen);
    if ValDec <> '' then
      ValStr := ValStr + DecimalSeparator + ValDec;

    if (not FZeroBlank)or(DigitsToFloat(ValStr) <> 0.0) then
      ValStr := ValSign + ValStr
    else
      ValStr := '';
  end;

  Result := ValStr;
end;

function TDecimalEdit.FloatToDigits(Value: Extended): String;
var
  ValRec: TFloatRec;
  ValLen, ValPos: Integer;
  TmpStr: String;
begin
  try
    FloatToDecimal(ValRec, Value, fvExtended, 18, FDecimalLength);

    if ValRec.Exponent > 0 then
    begin
      TmpStr := '';
      ValLen := ValRec.Exponent;
    end
    else
    begin
      TmpStr := '0' + DecimalSeparator + StringOfChar('0', - ValRec.Exponent);
      ValLen := ValRec.Exponent - 1;
    end;

    ValPos := 0;
    while ValRec.Digits[ValPos] <> #0 do
    begin
      if ValLen = 0 then TmpStr := TmpStr + DecimalSeparator;
      TmpStr := TmpStr + ValRec.Digits[ValPos];
      Inc(ValPos);
      if ValPos > High(ValRec.Digits) then Break;
      Dec(ValLen);
    end;

    if ValLen > 0 then
      TmpStr := TmpStr + StringOfChar('0', ValLen);

    if ValRec.Negative then
      TmpStr := '-' + TmpStr
    else if FShowPlus then
      TmpStr := '+' + TmpStr;
    Result := TmpStr;
  except
    Result := '';
  end;
end;

function TDecimalEdit.DigitsToFloat(const S: String): Extended;
begin
  try
    Result := StrToFloat(StringReplace(S, ThousandSeparator, '', [rfReplaceAll, rfIgnoreCase]));
  except
    Result := 0.0;
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// TDateTimeEdit                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TDateTimeEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FDateTime := Now;
  FChecked := False;
  FKind := dtkDate;
  FMaxValue := MaxDateTime;
  FMinValue := MinDateTime;
  ImeMode := imDisable;
end;

procedure TDateTimeEdit.CMEnter(var Message: TCMGotFocus);
begin
  Text := FormatValue(FEditFormat);
  inherited;
end;

procedure TDateTimeEdit.CMExit(var Message: TCMExit);
begin
  FDateTime := UnformatValue(Text);
  inherited;
end;

procedure TDateTimeEdit.CMTextChanged(var Message: TMessage);
begin
  inherited;
  if Focused then UnformatValue(Text);
end;

procedure TDateTimeEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (not FEditorEnabled) and (Key = VK_DELETE) then
  begin
    MessageBeep(0);
    Key := 0;
  end;
  if Key <> 0 then inherited KeyDown(Key, Shift);
end;

procedure TDateTimeEdit.KeyPress(var Key: Char);
begin
  if not IsValidChar(Key) then Key := #0;
  if Key <> #0 then inherited KeyPress(Key);
end;

function TDateTimeEdit.IsValidChar(Key: Char): Boolean;
var
  ValidChars: set of Char;
begin
  Result := False;
  ValidChars := ['0'..'9', ' '];
  if FKind = dtkDate then Include(ValidChars, DateSeparator);
  if FKind = dtkTime then Include(ValidChars, TimeSeparator);
  if (Key in ValidChars) or (Key < #32) then
  begin
    if (not FEditorEnabled) and ((Key >= #32) or
      (Key = Chr(VK_ESCAPE)) or (Key = Chr(VK_RETURN)) or (Key = Char(VK_BACK))) then
    begin
      MessageBeep(0);
    end
    else if (Key = Chr(VK_ESCAPE)) or (Key = Chr(VK_RETURN)) then
    begin
      ResetValue;
    end
    else
    begin
      Result := True;
    end;
  end
  else
  begin
    MessageBeep(0);
  end;
end;

function TDateTimeEdit.IsStoreDate: Boolean;
begin
  Result := (FChecked)and(FKind <> dtkTime);
end;

function TDateTimeEdit.IsStoreTime: Boolean;
begin
  Result := (FChecked)and(FKind <> dtkDate);
end;

function TDateTimeEdit.GetDate: TDate;
begin
  if (FChecked)and(FKind <> dtkTime) then
    Result := Trunc(FDateTime)
  else
    Result := 0;
end;

function TDateTimeEdit.GetTime: TTime;
begin
  if (FChecked)and(FKind <> dtkDate) then
    Result := Frac(FDateTime)
  else
    Result := 0;
end;

function TDateTimeEdit.GetDateTime: TDateTime;
begin
  Result := FDateTime;
  case FKind of
  dtkDate: Result := Trunc(Result);
  dtkTime: Result := Frac(Result);
  end;
end;

function TDateTimeEdit.GetMaxValue: String;
begin
  if FMaxValue < MaxDateTime then
    Result := DateTimeToStr(FMaxValue)
  else
    Result := '';
end;

function TDateTimeEdit.GetMinValue: String;
begin
  if FMinValue > MinDateTime then
    Result := DateTimeToStr(FMinValue)
  else
    Result := '';
end;

procedure TDateTimeEdit.SetChecked(Value: Boolean);
begin
  if FChecked <> Value then
  begin
    FChecked := Value;
    SetValue;
  end;
end;

procedure TDateTimeEdit.SetDate(Value: TDate);
begin
  if FKind = dtkDate then
    SetDateTime(Trunc(Value));
end;

procedure TDateTimeEdit.SetTime(Value: TTime);
begin
  if FKind = dtkTime then
    SetDateTime(Frac(Value));
end;

procedure TDateTimeEdit.SetDateTime(Value: TDateTime);
begin
  if (GetDateTime <> Value)or(not FChecked) then
  begin
    FDateTime := CheckValue(Value);
    FChecked := True;
    SetValue;
  end;
end;

procedure TDateTimeEdit.SetMaxValue(Value: String);
begin
  FMaxValue := StrToDateTimeDef(Value, MaxDateTime);
  FDateTime := CheckValue(FDateTime);
  SetValue;
end;

procedure TDateTimeEdit.SetMinValue(Value: String);
begin
  FMinValue := StrToDateTimeDef(Value, MinDateTime);
  FDateTime := CheckValue(FDateTime);
  SetValue;
end;

procedure TDateTimeEdit.SetEditFormat(Value: String);
begin
  if FEditFormat <> Value then
  begin
    FEditFormat := Value;
    if Focused then Text := FormatValue(Value);
  end;
end;

procedure TDateTimeEdit.SetTextFormat(Value: String);
begin
  if FTextFormat <> Value then
  begin
    FTextFormat := Value;
    if not Focused then Text := FormatValue(Value);
  end;
end;

procedure TDateTimeEdit.SetKind(Value: TDateTimeKind);
begin
  if FKind <> Value then
  begin
    FKind := Value;
    FEditFormat := '';
    SetValue;
  end;
end;

procedure TDateTimeEdit.SetValue;
begin
  if Focused then
    Text := FormatValue(FEditFormat)
  else
    Text := FormatValue(FTextFormat);
end;

procedure TDateTimeEdit.ResetValue;
begin
  FChecked := (Text <> '');
  SetValue;
end;

function TDateTimeEdit.CheckValue(Value: TDateTime): TDateTime;
begin
  if FMaxValue > FMinValue then
  begin
    if Value < FMinValue then
      Value := FMinValue
    else if Value > FMaxValue then
      Value := FMaxValue;
  end;
  Result := Value;
end;

function TDateTimeEdit.FormatValue(AFormat: String): String;
begin
  Result := '';
  if FChecked then
  begin
    if AFormat = '' then
    begin
      case FKind of
      dtkDate: AFormat := LowerCase(ShortDateFormat);
      dtkTime: AFormat := LowerCase(LongTimeFormat);
      end;
    end;
    DateTimeToStringEx(Result, AFormat, DateTime);
  end;
end;

function TDateTimeEdit.UnformatValue(AText: String): TDateTime;
var
  TempDT: TDateTime;
begin
  Result := FDateTime;
  if AText <> '' then
  begin
    //ϊłΐV擾iϊłȂΈȑÔ܂܁j
    case FKind of
    dtkDate:
      if TryStrToDateEx(Text, TempDT) then
      begin
        Result := CheckValue(TempDT);
        FChecked := True;
      end;
    dtkTime:
      if TryStrToTimeEx(Text, TempDT) then
      begin
        Result := CheckValue(TempDT);
        FChecked := True;
      end;
    end;
  end
  else
    FChecked := False;
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H

