////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// TTexturePanel \[Xt@C Ver.2.0                                       //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
{
  TPanel̒ǉvpeB
    BorderColor   : pl̋EF
    GradientColor : Of[VɎgpF
    GradientStyle : Of[V̗l
    Picture       : 摜
    PictureLayout : 摜̔zu
    VAlignment    : LvV̏czu
    OnGradientDraw: JX^Of[VCxg
}
unit TexturePanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ExtCtrls, Forms;

type
  //Of[Vl
  TGradientStyle = (gsCustom,       //JX^iOnGradientDrawŎwj

                    gsTopToBottom,  //ォ牺
                    gsLeftToRight,  //E

                    gsEdgeTop,      //
                    gsEdgeBottom,   //
                    gsEdgeLeft,     //
                    gsEdgeRight,    //E
                    gsFourEdges,    //l

                    gsTopLeft,      //_
                    gsTopCenter,    //Ӓ
                    gsTopRight,     //E_
                    gsMiddleLeft,   //Ӓ
                    gsMiddleCenter, //S_
                    gsMiddleRight,  //EӒ
                    gsBottomLeft,   //_
                    gsBottomCenter, //Ӓ
                    gsBottomRight,  //E_
                    gsFourCorners,  //l

                    gsHorizLine,    //
                    gsVertLine,     //
                    gsHorizStripe,  //
                    gsVertStripe,   //

                    gsDiagLineF,    //OΊp
                    gsDiagLineB,    //Ίp
                    gsDiagStripeF,  //OΊp
                    gsDiagStripeB,  //Ίp

                    gsCross,        //\
                    gsDiagCross,    //Ίp\
                    gsDiamond,      //H`
                    gsRectangle,    //`

                    gsCheckerL,     //s͗liej
                    gsCheckerM,     //s͗lij
                    gsCheckerS,     //s͗liׁj
                    gsMosaicL,      //UCNiej
                    gsMosaicM,      //UCNij
                    gsMosaicS,      //UCNiׁj

                    gsClear,        //hԂiColorj
                    gsSolid,        //hԂiGradientColorj
                    gsNone);        //

  //摜zu
  TPictureLayout = (plNormal,       //ʏiTCYύXpl̉Eɔzuj
                    plCenter,       //iTCYύXpl̒ɔzuj
                    plProportional, //䗦ێĊgkiACR͊g傳Ȃj
                    plStretch,      //䗦𖳎ĊgkiACR͊g傳Ȃj
                    plPattern);     //wi̖͗lƂĕ~l߂irbg}bv̂݁j

  //cAlignment
  TVAlignment = (taTopJustify, taBottomJustify, taMiddle);

  //h~Rg[
  TBitmapControl = class(TCustomControl)
  private
    { Private 錾 }
    FBackBmp: TBitmap;
    FBorderStyle: TBorderStyle;
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMBorderChanged(var Message: TMessage); message CM_BORDERCHANGED;
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Paint; override;
    procedure DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect); virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Update; override;
    property Color default clWhite;
    property ParentColor default False;
    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsSingle;
  end;

  TGradientDrawEvent = procedure(Sender: TObject; Canvas: TCanvas; Rect: TRect) of object;

  //eNX`\tRg[
  TTextureControl = class(TBitmapControl)
  private
    { Private 錾 }
    FGradientColor: TColor;
    FGradientStyle: TGradientStyle;
    FPicture: TPicture;
    FPictureLayout: TPictureLayout;
    FOnGradientDraw: TGradientDrawEvent;
    procedure SetGradientColor(const Value: TColor);
    procedure SetGradientStyle(const Value: TGradientStyle);
    procedure SetPicture(const Value: TPicture);
    procedure SetPictureLayout(const Value: TPictureLayout);
    procedure PictureChanged(Sender: TObject);
  protected
    { Protected 錾 }
    procedure DoDrawGradate(ACanvas: TCanvas; ARect: TRect); dynamic;
    procedure DoDrawPicture(ACanvas: TCanvas; ARect: TRect); dynamic;
    procedure DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect); override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property GradientColor: TColor read FGradientColor write SetGradientColor default clSkyBlue;
    property GradientStyle: TGradientStyle read FGradientStyle write SetGradientStyle default gsEdgeBottom;
    property Picture: TPicture read FPicture write SetPicture;
    property PictureLayout: TPictureLayout read FPictureLayout write SetPictureLayout default plCenter;
    property OnGradientDraw: TGradientDrawEvent read FOnGradientDraw write FOnGradientDraw;
  end;

  //eNX`\tpl
  TTexturePanel = class(TTextureControl)
  private
    { Private 錾 }
    FAlignment: TAlignment;
    FAutoSizeDocking: Boolean;
    FBevelInner: TPanelBevel;
    FBevelOuter: TPanelBevel;
    FBevelWidth: TBevelWidth;
    FBorderColor: TColor;
    FBorderWidth: TBorderWidth;
    FFullRepaint: Boolean;
    FLocked: Boolean;
    FVAlignment: TVAlignment;
    procedure SetAlignment(Value: TAlignment);
    procedure SetBevelInner(Value: TPanelBevel);
    procedure SetBevelOuter(Value: TPanelBevel);
    procedure SetBevelWidth(Value: TBevelWidth);
    procedure SetBorderColor(const Value: TColor);
    procedure SetBorderWidth(Value: TBorderWidth);
    procedure SetVAlignment(Value: TVAlignment);
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMIsToolControl(var Message: TMessage); message CM_ISTOOLCONTROL;
    procedure CMDockClient(var Message: TCMDockClient); message CM_DOCKCLIENT;
    procedure WMWindowPosChanged(var Message: TWMWindowPosChanged); message WM_WINDOWPOSCHANGED;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure AdjustClientRect(var Rect: TRect); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect); override;
  public
    { Public 錾 }
    function GetControlsAlignment: TAlignment; override;
    constructor Create(AOwner: TComponent); override;
    property DockManager;
  published
    { Published 錾 }
    property BevelInner: TPanelBevel read FBevelInner write SetBevelInner default bvNone;
    property BevelOuter: TPanelBevel read FBevelOuter write SetBevelOuter default bvRaised;
    property BevelWidth: TBevelWidth read FBevelWidth write SetBevelWidth default 1;
    property BorderColor: TColor read FBorderColor write SetBorderColor default clBtnFace;
    property BorderWidth: TBorderWidth read FBorderWidth write SetBorderWidth default 0;
    property FullRepaint: Boolean read FFullRepaint write FFullRepaint default True;
    property Locked: Boolean read FLocked write FLocked default False;
    property Alignment: TAlignment read FAlignment write SetAlignment default taCenter;
    property VAlignment: TVAlignment read FVAlignment write SetVAlignment default taMiddle;
    property Align;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property BorderStyle default bsNone;
    property Caption;
    property Color;
    property Constraints;
    property Ctl3D;
    property Cursor;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property UseDockManager default True;
    property Visible;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

////////////////////////////////////////////////////////////////////////////////
// NewGradientFill                                                            //
////////////////////////////////////////////////////////////////////////////////

//^錾iWindows.pasTTriVertex ͌j
  PNewTriVertex = ^TNewTriVertex;
  _NEWTRIVERTEX = packed record
    x: Longint;
    y: Longint;
    Red: WORD;
    Green: WORD;
    Blue: WORD;
    Alpha: WORD;
  end;
  TNewTriVertex = _NEWTRIVERTEX;
  NEWTRIVERTEX = _NEWTRIVERTEX;

function NewGradientFill(DC: HDC; var NewVertex: TNewTriVertex; NumVertex: ULONG;
  Mesh: Pointer; NumMesh, Mode: ULONG): BOOL; stdcall; external msimg32 name 'GradientFill';


implementation

////////////////////////////////////////////////////////////////////////////////
// TBitmapControl                                                             //
////////////////////////////////////////////////////////////////////////////////

//Create
constructor TBitmapControl.Create(AOwner: TComponent);
begin
  inherited;
  FBackBmp := TBitmap.Create;
  FBorderStyle := bsSingle;
  ParentColor := False;
  Color := clWhite;
end;

//Destroy
destructor TBitmapControl.Destroy;
begin
  FreeAndNil(FBackBmp);
  inherited;
end;

//CreateParams
procedure TBitmapControl.CreateParams(var Params: TCreateParams);
const
  BorderStyles: array[TBorderStyle] of DWORD = (0, WS_BORDER);
begin
  inherited;
  with Params do
  begin
    Style := Style or BorderStyles[FBorderStyle];
    if NewStyleControls and Ctl3D and (FBorderStyle = bsSingle) then
    begin
      Style := Style and not WS_BORDER;
      ExStyle := ExStyle or WS_EX_CLIENTEDGE;
    end;
  end;
end;

//WMSize
procedure TBitmapControl.WMSize(var Message: TWMSize);
begin
  inherited;
  FBackBmp.Dormant;
  FBackBmp.Width := Message.Width;
  FBackBmp.Height := Message.Height;
  Repaint;
end;

//WMEraseBkgnd
procedure TBitmapControl.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 1;  //Inherited;
end;

//WMGetDlgCode
procedure TBitmapControl.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS or DLGC_WANTCHARS;
end;

//CMBorderChanged
procedure TBitmapControl.CMBorderChanged(var Message: TMessage);
begin
  inherited;
  Repaint;
end;

//CMColorChanged
procedure TBitmapControl.CMColorChanged(var Message: TMessage);
begin
  inherited;
  Repaint;
end;

//CMFontChanged
procedure TBitmapControl.CMFontChanged(var Message: TMessage);
begin
  inherited;
  Repaint;
end;

//CMCtl3DChanged
procedure TBitmapControl.CMCtl3DChanged(var Message: TMessage);
begin
  if NewStyleControls and (FBorderStyle = bsSingle) then RecreateWnd;
  inherited;
end;

//SetBorderStyle
procedure TBitmapControl.SetBorderStyle(Value: TBorderStyle);
begin
  if FBorderStyle = Value then Exit;
  FBorderStyle := Value;
  RecreateWnd;
end;

//Paint
procedure TBitmapControl.Paint;
begin
  //`ς̃rbg}bvRs[邾
  BitBlt(Canvas.Handle,
         ClientRect.Left, ClientRect.Top, ClientWidth, ClientHeight,
         FBackBmp.Canvas.Handle, 0, 0, SRCCOPY);
end;

//Update
procedure TBitmapControl.Update;
begin
  if HandleAllocated then DoDrawBackBmp(FBackBmp.Canvas, ClientRect);
end;

//`s
procedure TBitmapControl.DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect);
begin
  ACanvas.Brush.Assign(Brush);
  ACanvas.FillRect(ARect);
end;


////////////////////////////////////////////////////////////////////////////////
// TTextureControl                                                            //
////////////////////////////////////////////////////////////////////////////////

//Create
constructor TTextureControl.Create(AOwner: TComponent);
begin
  inherited;
  FGradientColor := clSkyBlue;
  FGradientStyle := gsEdgeBottom;
  FPictureLayout := plCenter;
  FPicture := TPicture.Create;
  FPicture.OnChange := PictureChanged;
end;

//Destroy
destructor TTextureControl.Destroy;
begin
  FreeAndNil(FPicture);
  inherited;
end;

//PictureChanged
procedure TTextureControl.PictureChanged(Sender: TObject);
begin
  Repaint;
end;

//SetGradientColor
procedure TTextureControl.SetGradientColor(const Value: TColor);
begin
  if FGradientColor = Value then Exit;
  FGradientColor := Value;
  Repaint;
end;

//SetGradientStyle
procedure TTextureControl.SetGradientStyle(const Value: TGradientStyle);
begin
  if FGradientStyle = Value then Exit;
  FGradientStyle := Value;
  Repaint;
end;

//SetPicture
procedure TTextureControl.SetPicture(const Value: TPicture);
begin
  if FPicture = Value then Exit;
  FPicture.Assign(Value);
  Repaint;
end;

//SetPictureLayout
procedure TTextureControl.SetPictureLayout(const Value: TPictureLayout);
begin
  if FPictureLayout = Value then Exit;
  FPictureLayout := Value;
  Repaint;
end;

//Of[V`s
procedure TTextureControl.DoDrawGradate(ACanvas: TCanvas; ARect: TRect);

  //ԐF擾
  function GetMixedColor(AColor1, AColor2: TColor): TColor;
  var
    cRGB1, cRGB2, cRed, cGrn, cBlu: LongInt;
  begin
    cRGB1 := ColorToRGB(AColor1);
    cRGB2 := ColorToRGB(AColor2);
    cRed := ((cRGB1 and $000000FF) + (cRGB2 and $000000FF)) shr 1;
    cGrn := ((cRGB1 and $0000FF00) + (cRGB2 and $0000FF00)) shr 1;
    cBlu := ((cRGB1 and $00FF0000) + (cRGB2 and $00FF0000)) shr 1;
    Result := (cRed and $000000FF) + (cGrn and $0000FF00) + (cBlu and $00FF0000);
  end;

  //Of[V_ݒ
  function GetVertexValue(AX, AY: LongInt; AColor: TColor): TNewTriVertex;
  var
    cRGB: LongInt;
  begin
    cRGB := ColorToRGB(AColor);
    with Result do
    begin
      x := AX;
      y := AY;
      Red   := (cRGB and $000000FF) shl 8;
      Green := (cRGB and $0000FF00);
      Blue  := (cRGB and $00FF0000) shr 8;
      Alpha := 0;
    end;
  end;

  //Of[V_ݒ
  function GetTriangleValue(AVert1, AVert2, AVert3: ULONG): TGradientTriangle;
  begin
    with Result do
    begin
      Vertex1 := AVert1;
      Vertex2 := AVert2;
      Vertex3 := AVert3;
    end;
  end;

  //Of[V`iEE㉺j
  procedure DrawGradSimple(AColor1, AColor2: TColor; ATopBtm: Boolean);
  var
    tTV: array[0..1] of TNewTriVertex;
    tGR:{array[0..0] of}TGradientRect;
  begin
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor1);
    //E
    tTV[1] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2);
    //
    tGR.UpperLeft  := 0;
    //E
    tGR.LowerRight := 1;
    //s
    if ATopBtm then
      NewGradientFill(ACanvas.Handle, tTV[0], 2, @tGR, 1, GRADIENT_FILL_RECT_V)
    else
      NewGradientFill(ACanvas.Handle, tTV[0], 2, @tGR, 1, GRADIENT_FILL_RECT_H);
  end;

  //Of[V`ilӁj
  procedure DrawGradEdge(AColor1, AColor2: TColor; AAnchor: TAnchorKind);
  var
    tTV: array[0..1] of TNewTriVertex;
    tGR:{array[0..0] of}TGradientRect;
    nCenter: LongInt;
  begin
    ACanvas.Brush.Color := AColor1;
    ACanvas.Brush.Style := bsSolid;
    case AAnchor of
    akTop:    //
      begin
        nCenter := (ARect.Top + ARect.Bottom) div 2;
        //
        tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor2);
        //E
        tTV[1] := GetVertexValue(ARect.Right, nCenter, AColor1);
        //
        ACanvas.FillRect(Rect(ARect.Left, nCenter, ARect.Right, ARect.Bottom));
      end;
    akBottom: //
      begin
        nCenter := (ARect.Top + ARect.Bottom) div 2;
        //
        tTV[0] := GetVertexValue(ARect.Left, nCenter, AColor1);
        //E
        tTV[1] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2);
        //
        ACanvas.FillRect(Rect(ARect.Left, ARect.Top, ARect.Right, nCenter));
      end;
    akLeft:   //
      begin
        nCenter := (ARect.Left + ARect.Right) div 2;
        //
        tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor2);
        //E
        tTV[1] := GetVertexValue(nCenter, ARect.Bottom, AColor1);
        //E
        ACanvas.FillRect(Rect(nCenter, ARect.Top, ARect.Right, ARect.Bottom));
      end;
    akRight:  //E
      begin
        nCenter := (ARect.Left + ARect.Right) div 2;
        //
        tTV[0] := GetVertexValue(nCenter, ARect.Top, AColor1);
        //E
        tTV[1] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2);
        //
        ACanvas.FillRect(Rect(ARect.Left, ARect.Top, nCenter, ARect.Bottom));
      end;
    end;
    //
    tGR.UpperLeft  := 0;
    //E
    tGR.LowerRight := 1;
    //s
    if (AAnchor = akTop)or(AAnchor = akBottom) then
      NewGradientFill(ACanvas.Handle, tTV[0], 2, @tGR, 1, GRADIENT_FILL_RECT_V)
    else
      NewGradientFill(ACanvas.Handle, tTV[0], 2, @tGR, 1, GRADIENT_FILL_RECT_H);
  end;

  //Of[V`ilj
  procedure DrawGradCorner(AColor1, AColor2: TColor; ALeft, ATop: Boolean);
  var
    tTV: array[0..3] of TNewTriVertex;
    tGT: array[0..1] of TGradientTriangle;
  begin
    //
    if (ALeft)and(ATop) then
      tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor2)
    else
      tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor1);
    //E
    if (not ALeft)and(ATop) then
      tTV[1] := GetVertexValue(ARect.Right, ARect.Top, AColor2)
    else
      tTV[1] := GetVertexValue(ARect.Right, ARect.Top, AColor1);
    //
    if (ALeft)and(not ATop) then
      tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, AColor2)
    else
      tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, AColor1);
    //E
    if (not ALeft)and(not ATop) then
      tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2)
    else
      tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor1);
    if ALeft xor ATop then
    begin
      //
      tGT[0] := GetTriangleValue(0, 1, 2);
      //E
      tGT[1] := GetTriangleValue(3, 2, 1);
    end
    else
    begin
      //E
      tGT[0] := GetTriangleValue(0, 1, 3);
      //
      tGT[1] := GetTriangleValue(3, 2, 0);
    end;
    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 4, @tGT, 2, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[V`i_j
  procedure DrawGradMidPoint(AColor1, AColor2: TColor; AAnchor: TAnchorKind);
  var
    tTV: array[0..4] of TNewTriVertex;
    tGT: array[0..2] of TGradientTriangle;
  begin
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor1);
    //E
    tTV[1] := GetVertexValue(ARect.Right, ARect.Top, AColor1);
    //
    tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, AColor1);
    //E
    tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor1);
    //
    case AAnchor of
    akTop:    //
      begin
        tTV[4] := GetVertexValue((ARect.Left + ARect.Right) div 2, ARect.Top, AColor2);
        tGT[0] := GetTriangleValue(2, 3, 4);
        tGT[1] := GetTriangleValue(0, 2, 4);
        tGT[2] := GetTriangleValue(1, 3, 4);
      end;
    akBottom: //
      begin
        tTV[4] := GetVertexValue((ARect.Left + ARect.Right) div 2, ARect.Bottom, AColor2);
        tGT[0] := GetTriangleValue(0, 1, 4);
        tGT[1] := GetTriangleValue(0, 2, 4);
        tGT[2] := GetTriangleValue(1, 3, 4);
      end;
    akLeft:   //
      begin
        tTV[4] := GetVertexValue(ARect.Left, (ARect.Top + ARect.Bottom) div 2, AColor2);
        tGT[0] := GetTriangleValue(0, 1, 4);
        tGT[1] := GetTriangleValue(2, 3, 4);
        tGT[2] := GetTriangleValue(1, 3, 4);
      end;
    akRight:  //E
      begin
        tTV[4] := GetVertexValue(ARect.Right, (ARect.Top + ARect.Bottom) div 2, AColor2);
        tGT[0] := GetTriangleValue(0, 1, 4);
        tGT[1] := GetTriangleValue(2, 3, 4);
        tGT[2] := GetTriangleValue(0, 2, 4);
      end;
    end;

    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 5, @tGT, 3, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[V`icEj
  procedure DrawGradLine(AColor1, AColor2: TColor; AVert: Boolean);
  var
    tTV: array[0..3] of TNewTriVertex;
    tGR: array[0..1] of TGradientRect;
  begin
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor1);
    if AVert then
    begin
      //
      tTV[1] := GetVertexValue((ARect.Left + ARect.Right) div 2, ARect.Bottom, AColor2);
      //
      tTV[2] := GetVertexValue((ARect.Left + ARect.Right) div 2, ARect.Top, AColor2);
    end
    else
    begin
      //E
      tTV[1] := GetVertexValue(ARect.Right, (ARect.Top + ARect.Bottom) div 2, AColor2);
      //
      tTV[2] := GetVertexValue(ARect.Left, (ARect.Top + ARect.Bottom) div 2, AColor2);
    end;
    //E
    tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor1);
    //or
    tGR[0].UpperLeft  := 0;
    tGR[0].LowerRight := 1;
    //Eor
    tGR[1].UpperLeft  := 2;
    tGR[1].LowerRight := 3;
    //s
    if AVert then
      NewGradientFill(ACanvas.Handle, tTV[0], 4, @tGR, 2, GRADIENT_FILL_RECT_H)
    else
      NewGradientFill(ACanvas.Handle, tTV[0], 4, @tGR, 2, GRADIENT_FILL_RECT_V);
  end;

  //Of[V`icȁEȁj
  procedure DrawGradStripe(AColor1, AColor2: TColor; AVert: Boolean);
  var
    tTV: array[0..11] of TNewTriVertex;
    tGR: array[0..5] of TGradientRect;
    nCenter: LongInt;
  begin
    //
    tTV[ 0] := GetVertexValue(ARect.Left, ARect.Top, AColor1);
    if AVert then
    begin
      nCenter := (ARect.Left * 5 + ARect.Right) div 6;
      tTV[ 1] := GetVertexValue(nCenter, ARect.Bottom, AColor2);
      tTV[ 2] := GetVertexValue(nCenter, ARect.Top, AColor2);
      nCenter := (ARect.Left * 4 + ARect.Right * 2) div 6;
      tTV[ 3] := GetVertexValue(nCenter, ARect.Bottom, AColor1);
      tTV[ 4] := GetVertexValue(nCenter, ARect.Top, AColor1);
      nCenter := (ARect.Left + ARect.Right) div 2;
      tTV[ 5] := GetVertexValue(nCenter, ARect.Bottom, AColor2);
      tTV[ 6] := GetVertexValue(nCenter, ARect.Top, AColor2);
      nCenter := (ARect.Left * 2 + ARect.Right * 4) div 6;
      tTV[ 7] := GetVertexValue(nCenter, ARect.Bottom, AColor1);
      tTV[ 8] := GetVertexValue(nCenter, ARect.Top, AColor1);
      nCenter := (ARect.Left + ARect.Right * 5) div 6;
      tTV[ 9] := GetVertexValue(nCenter, ARect.Bottom, AColor2);
      tTV[10] := GetVertexValue(nCenter, ARect.Top, AColor2);
    end
    else
    begin
      nCenter := (ARect.Top * 5 + ARect.Bottom) div 6;
      tTV[ 1] := GetVertexValue(ARect.Right, nCenter, AColor2);
      tTV[ 2] := GetVertexValue(ARect.Left, nCenter, AColor2);
      nCenter := (ARect.Top * 4 + ARect.Bottom * 2) div 6;
      tTV[ 3] := GetVertexValue(ARect.Right, nCenter, AColor1);
      tTV[ 4] := GetVertexValue(ARect.Left, nCenter, AColor1);
      nCenter := (ARect.Top + ARect.Bottom) div 2;
      tTV[ 5] := GetVertexValue(ARect.Right, nCenter, AColor2);
      tTV[ 6] := GetVertexValue(ARect.Left, nCenter, AColor2);
      nCenter := (ARect.Top * 2 + ARect.Bottom * 4) div 6;
      tTV[ 7] := GetVertexValue(ARect.Right, nCenter, AColor1);
      tTV[ 8] := GetVertexValue(ARect.Left, nCenter, AColor1);
      nCenter := (ARect.Top + ARect.Bottom * 5) div 6;
      tTV[ 9] := GetVertexValue(ARect.Right, nCenter, AColor2);
      tTV[10] := GetVertexValue(ARect.Left, nCenter, AColor2);
    end;
    //E
    tTV[11] := GetVertexValue(ARect.Right, ARect.Bottom, AColor1);
    //or
    tGR[0].UpperLeft  := 0;
    tGR[0].LowerRight := 1;
    tGR[1].UpperLeft  := 2;
    tGR[1].LowerRight := 3;
    tGR[2].UpperLeft  := 4;
    tGR[2].LowerRight := 5;
    //Eor
    tGR[3].UpperLeft  := 6;
    tGR[3].LowerRight := 7;
    tGR[4].UpperLeft  := 8;
    tGR[4].LowerRight := 9;
    tGR[5].UpperLeft  := 10;
    tGR[5].LowerRight := 11;
    //s
    if AVert then
      NewGradientFill(ACanvas.Handle, tTV[0], 12, @tGR, 6, GRADIENT_FILL_RECT_H)
    else
      NewGradientFill(ACanvas.Handle, tTV[0], 12, @tGR, 6, GRADIENT_FILL_RECT_V);
  end;

  //Of[V`iΐj
  procedure DrawGradDLine(AColor1, AColor2: TColor; ABack: Boolean);
  var
    tTV: array[0..3] of TNewTriVertex;
    tGT: array[0..1] of TGradientTriangle;
  begin
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor2);
    //E
    tTV[1] := GetVertexValue(ARect.Right, ARect.Top, AColor1);
    //
    tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, AColor1);
    //E
    tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2);
    if ABack then
    begin
      //
      tGT[0] := GetTriangleValue(0, 1, 2);
      //E
      tGT[1] := GetTriangleValue(3, 2, 1);
    end
    else
    begin
      //E
      tGT[0] := GetTriangleValue(0, 1, 3);
      //
      tGT[1] := GetTriangleValue(3, 2, 0);
    end;
    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 4, @tGT, 2, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[V`iΎȁj
  procedure DrawGradDStripe(AColor1, AColor2: TColor; ABack: Boolean);
  var
    tTV: array[0..8] of TNewTriVertex;
    tGT: array[0..7] of TGradientTriangle;
    nHCenter, nVCenter: LongInt;
  begin
    nHCenter := (ARect.Left + ARect.Right) div 2;
    nVCenter := (ARect.Top + ARect.Bottom) div 2;
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor2);
    //E
    tTV[1] := GetVertexValue(ARect.Right, ARect.Top, AColor2);
    //
    tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, AColor2);
    //E
    tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2);
    //
    tTV[4] := GetVertexValue(nHCenter, ARect.Top, AColor1);
    //
    tTV[5] := GetVertexValue(nHCenter, ARect.Bottom, AColor1);
    //
    tTV[6] := GetVertexValue(ARect.Left, nVCenter, AColor1);
    //E
    tTV[7] := GetVertexValue(ARect.Right, nVCenter, AColor1);
    //
    tTV[8] := GetVertexValue(nHCenter, nVCenter, AColor2);
    if ABack then
    begin
      //`E
      tGT[0] := GetTriangleValue(0, 4, 6);
      tGT[1] := GetTriangleValue(8, 4, 6);
      tGT[2] := GetTriangleValue(4, 1, 8);
      tGT[3] := GetTriangleValue(6, 2, 8);
      tGT[4] := GetTriangleValue(7, 1, 8);
      tGT[5] := GetTriangleValue(5, 2, 8);
      tGT[6] := GetTriangleValue(8, 7, 5);
      tGT[7] := GetTriangleValue(3, 7, 5);
    end
    else
    begin
      //E`
      tGT[0] := GetTriangleValue(1, 4, 7);
      tGT[1] := GetTriangleValue(8, 4, 7);
      tGT[2] := GetTriangleValue(4, 0, 8);
      tGT[3] := GetTriangleValue(7, 3, 8);
      tGT[4] := GetTriangleValue(6, 0, 8);
      tGT[5] := GetTriangleValue(5, 3, 8);
      tGT[6] := GetTriangleValue(8, 5, 6);
      tGT[7] := GetTriangleValue(2, 5, 6);
    end;
    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 9, @tGT, 8, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[V`i{E~j
  procedure DrawGradCross(AColor1, AColor2: TColor; ARotate: Boolean);
  var
    tTV: array[0..8] of TNewTriVertex;
    tGT: array[0..7] of TGradientTriangle;
    nHCenter, nVCenter: LongInt;
  begin
    nHCenter := (ARect.Left + ARect.Right) div 2;
    nVCenter := (ARect.Top + ARect.Bottom) div 2;
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, AColor2);
    //E
    tTV[1] := GetVertexValue(ARect.Right, ARect.Top, AColor2);
    //
    tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, AColor2);
    //E
    tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, AColor2);
    //
    tTV[4] := GetVertexValue(nHCenter, ARect.Top, AColor1);
    //
    tTV[5] := GetVertexValue(nHCenter, ARect.Bottom, AColor1);
    //
    tTV[6] := GetVertexValue(ARect.Left, nVCenter, AColor1);
    //E
    tTV[7] := GetVertexValue(ARect.Right, nVCenter, AColor1);
    //
    if ARotate then
      tTV[8] := GetVertexValue(nHCenter, nVCenter, AColor2)
    else
      tTV[8] := GetVertexValue(nHCenter, nVCenter, AColor1);
    //
    tGT[0] := GetTriangleValue(0, 4, 8);
    //E
    tGT[1] := GetTriangleValue(1, 7, 8);
    //
    tGT[2] := GetTriangleValue(2, 6, 8);
    //E
    tGT[3] := GetTriangleValue(3, 5, 8);
    //
    tGT[4] := GetTriangleValue(0, 6, 8);
    //E
    tGT[5] := GetTriangleValue(1, 4, 8);
    //
    tGT[6] := GetTriangleValue(2, 5, 8);
    //E
    tGT[7] := GetTriangleValue(3, 7, 8);
    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 9, @tGT, 8, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[V`iH`j
  procedure DrawGradDiamond(AColor1, AColor2: TColor; AFrame: Boolean);
  var
    tTV: array[0..8] of TNewTriVertex;
    tGT: array[0..7] of TGradientTriangle;
    nHCenter, nVCenter: LongInt;
    clEdge, clCorner, clCenter: TColor;
  begin
    //F擾
    if AFrame then
    begin
      clEdge := AColor2;
      clCorner := AColor1;
      clCenter := AColor1;
    end
    else
    begin
      clEdge := GetMixedColor(AColor1, AColor2);
      clCorner := AColor2;
      clCenter := AColor1;
    end;
    nHCenter := (ARect.Left + ARect.Right) div 2;
    nVCenter := (ARect.Top + ARect.Bottom) div 2;
    //
    tTV[0] := GetVertexValue(ARect.Left, ARect.Top, clCorner);
    //E
    tTV[1] := GetVertexValue(ARect.Right, ARect.Top, clCorner);
    //
    tTV[2] := GetVertexValue(ARect.Left, ARect.Bottom, clCorner);
    //E
    tTV[3] := GetVertexValue(ARect.Right, ARect.Bottom, clCorner);
    //
    tTV[4] := GetVertexValue(nHCenter, ARect.Top, clEdge);
    //
    tTV[5] := GetVertexValue(nHCenter, ARect.Bottom, clEdge);
    //
    tTV[6] := GetVertexValue(ARect.Left, nVCenter, clEdge);
    //E
    tTV[7] := GetVertexValue(ARect.Right, nVCenter, clEdge);
    //
    tTV[8] := GetVertexValue(nHCenter, nVCenter, clCenter);
    //
    tGT[0] := GetTriangleValue(0, 4, 6);
    //E
    tGT[1] := GetTriangleValue(1, 4, 7);
    //
    tGT[2] := GetTriangleValue(2, 5, 6);
    //E
    tGT[3] := GetTriangleValue(3, 5, 7);
    //
    tGT[4] := GetTriangleValue(8, 4, 6);
    //E
    tGT[5] := GetTriangleValue(8, 4, 7);
    //
    tGT[6] := GetTriangleValue(8, 5, 6);
    //E
    tGT[7] := GetTriangleValue(8, 5, 7);
    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 9, @tGT, 8, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[V`i`j
  procedure DrawGradRectangle(AColor1, AColor2: TColor; AFrame: Boolean);
  var
    tTV: array[0..12] of TNewTriVertex;
    tGT: array[0..15] of TGradientTriangle;
    nHCenter, nVCenter: LongInt;
    clInner, clOuter, clCenter: TColor;
  begin
    //F擾
    if AFrame then
    begin
      clInner := AColor2;
      clOuter := AColor1;
      clCenter := AColor1;
    end
    else
    begin
      clInner := GetMixedColor(AColor1, AColor2);
      clOuter := AColor2;
      clCenter := AColor1;
    end;
    nHCenter := (ARect.Left + ARect.Right) div 2;
    nVCenter := (ARect.Top + ARect.Bottom) div 2;
    //
    tTV[ 0] := GetVertexValue(nHCenter, nVCenter, clCenter);
    //
    tTV[ 1] := GetVertexValue(ARect.Left, ARect.Top, clOuter);
    //E
    tTV[ 2] := GetVertexValue(ARect.Right, ARect.Top, clOuter);
    //
    tTV[ 3] := GetVertexValue(ARect.Left, ARect.Bottom, clOuter);
    //E
    tTV[ 4] := GetVertexValue(ARect.Right, ARect.Bottom, clOuter);
    //
    tTV[ 5] := GetVertexValue(nHCenter, ARect.Top, clOuter);
    //
    tTV[ 6] := GetVertexValue(nHCenter, ARect.Bottom, clOuter);
    //
    tTV[ 7] := GetVertexValue(ARect.Left, nVCenter, clOuter);
    //E
    tTV[ 8] := GetVertexValue(ARect.Right, nVCenter, clOuter);
    //
    nHCenter := (ARect.Left * 5 + ARect.Right) div 6;
    nVCenter := (ARect.Top * 5 + ARect.Bottom) div 6;
    tTV[ 9] := GetVertexValue(nHCenter, nVCenter, clInner);
    //E
    nHCenter := (ARect.Left + ARect.Right * 5) div 6;
    nVCenter := (ARect.Top * 5 + ARect.Bottom) div 6;
    tTV[10] := GetVertexValue(nHCenter, nVCenter, clInner);
    //
    nHCenter := (ARect.Left * 5 + ARect.Right) div 6;
    nVCenter := (ARect.Top + ARect.Bottom * 5) div 6;
    tTV[11] := GetVertexValue(nHCenter, nVCenter, clInner);
    //E
    nHCenter := (ARect.Left + ARect.Right * 5) div 6;
    nVCenter := (ARect.Top + ARect.Bottom * 5) div 6;
    tTV[12] := GetVertexValue(nHCenter, nVCenter, clInner);
    //
    tGT[ 0] := GetTriangleValue(1, 5, 9);
    //E
    tGT[ 1] := GetTriangleValue(2, 5,10);
    //
    tGT[ 2] := GetTriangleValue(3, 6,11);
    //E
    tGT[ 3] := GetTriangleValue(4, 6,12);
    //
    tGT[ 4] := GetTriangleValue(1, 9, 7);
    //E
    tGT[ 5] := GetTriangleValue(2,10, 8);
    //
    tGT[ 6] := GetTriangleValue(3,11, 7);
    //E
    tGT[ 7] := GetTriangleValue(4,12, 8);
    //
    tGT[ 8] := GetTriangleValue(5, 9,10);
    //
    tGT[ 9] := GetTriangleValue(6,11,12);
    //
    tGT[10] := GetTriangleValue(7, 9,11);
    //E
    tGT[11] := GetTriangleValue(8,10,12);
    //
    tGT[12] := GetTriangleValue(0, 9,10);
    //
    tGT[13] := GetTriangleValue(0,11,12);
    //
    tGT[14] := GetTriangleValue(0, 9,11);
    //E
    tGT[15] := GetTriangleValue(0,10,12);
    //s
    NewGradientFill(ACanvas.Handle, tTV[0], 13, @tGT, 16, GRADIENT_FILL_TRIANGLE);
  end;

  //Of[Viiqj
  procedure DrawNoGradCheck(AColor1, AColor2: TColor; ASize: Integer; ARand: Boolean);
  var
    i, j, W0, W1, W2, H0, H1, H2: Integer;
    nCols, nRows, nRand: Integer;
    tRct: TRect;
    clMixed: TColor;
  begin
    W0 := ARect.Right - ARect.Left;
    H0 := ARect.Bottom - ARect.Top;
    nCols := W0 div ASize + 1;
    nRows := H0 div ASize + 1;
    W0 := W0 mod ASize;
    H0 := H0 mod ASize;
    if W0 > 0 then
    begin
      Inc(nCols);
      W0 := W0 div 2;
    end;
    if H0 > 0 then
    begin
      Inc(nRows);
      H0 := H0 div 2;
    end;
    nRand := 0;
    clMixed := clNone;
    if ARand then
    begin
      nRand := ASize * nCols * nRows;
      clMixed := GetMixedColor(AColor1, AColor2);
    end;
    ACanvas.Brush.Style := bsSolid;

    W2 := ARect.Left;
    for i := 1 to nCols do
    begin
      //ʒuvZ
      W1 := W2;
      if i = nCols then
        W2 := ARect.Right
      else if i = 1 then
        W2 := W0
      else
        W2 := W2 + ASize;
      if W1 = W2 then Continue;

      H2 := ARect.Top;
      for j := 1 to nRows do
      begin
        //cʒuvZ
        H1 := H2;
        if j = nRows then
          H2 := ARect.Bottom
        else if j = 1 then
          H2 := H0
        else
          H2 := H2 + ASize;
        if H1 = H2 then Continue;

        //``
        tRct := Rect(W1, H1, W2, H2);
        if ARand then
        begin
          nRand := (nRand * i + j) mod 10000;
          case nRand mod 3 of
          1:   ACanvas.Brush.Color := AColor1;
          2:   ACanvas.Brush.Color := AColor2;
          else ACanvas.Brush.Color := clMixed;
          end;
        end
        else
        begin
          if Odd(i + j) then
            ACanvas.Brush.Color := AColor2
          else
            ACanvas.Brush.Color := AColor1;
        end;
        ACanvas.FillRect(tRct);
      end;
    end;
  end;

  //Of[VihԂj
  procedure DrawNoGradBrush(AColor: TColor);
  begin
    ACanvas.Brush.Color := AColor;
    ACanvas.Brush.Style := bsSolid;
    ACanvas.FillRect(ARect);
  end;

begin
  case FGradientStyle of
  gsCustom:       //JX^
    if Assigned(FOnGradientDraw) then FOnGradientDraw(Self, ACanvas, ARect);

  gsTopToBottom:  //ォ牺
    DrawGradSimple(Color, FGradientColor, True);
  gsLeftToRight:  //E
    DrawGradSimple(Color, FGradientColor, False);

  gsTopLeft:      //_
    DrawGradCorner(Color, FGradientColor, True, True);
  gsTopRight:     //E_
    DrawGradCorner(Color, FGradientColor, False, True);
  gsBottomLeft:   //_
    DrawGradCorner(Color, FGradientColor, True, False);
  gsBottomRight:  //E_
    DrawGradCorner(Color, FGradientColor, False, False);

  gsTopCenter:    //Ӓ
    DrawGradMidPoint(Color, FGradientColor, akTop);
  gsBottomCenter: //Ӓ
    DrawGradMidPoint(Color, FGradientColor, akBottom);
  gsMiddleLeft:   //Ӓ
    DrawGradMidPoint(Color, FGradientColor, akLeft);
  gsMiddleRight:  //EӒ
    DrawGradMidPoint(Color, FGradientColor, akRight);

  gsMiddleCenter: //S_
    DrawGradDiamond(FGradientColor, Color, False);
  gsFourCorners:  //l
    DrawGradDiamond(Color, FGradientColor, False);

  gsEdgeTop:      //
    DrawGradEdge(Color, FGradientColor, akTop);
  gsEdgeBottom:   //
    DrawGradEdge(Color, FGradientColor, akBottom);
  gsEdgeLeft:     //
    DrawGradEdge(Color, FGradientColor, akLeft);
  gsEdgeRight:    //E
    DrawGradEdge(Color, FGradientColor, akRight);
  gsFourEdges:    //l
    DrawGradRectangle(Color, FGradientColor, False);

  gsHorizLine:    //
    DrawGradLine(Color, FGradientColor, False);
  gsVertLine:     //
    DrawGradLine(Color, FGradientColor, True);
  gsHorizStripe:  //
    DrawGradStripe(Color, FGradientColor, False);
  gsVertStripe:   //
    DrawGradStripe(Color, FGradientColor, True);
  gsCross:        //\
    DrawGradCross(Color, FGradientColor, False);

  gsDiagLineF:    //OΊp
    DrawGradDLine(Color, FGradientColor, False);
  gsDiagLineB:    //Ίp
    DrawGradDLine(Color, FGradientColor, True);
  gsDiagStripeF:  //OΊp
    DrawGradDStripe(Color, FGradientColor, False);
  gsDiagStripeB:  //Ίp
    DrawGradDStripe(Color, FGradientColor, True);
  gsDiagCross:    //Ίp\
    DrawGradCross(FGradientColor, Color, True);

  gsDiamond:      //H`
    DrawGradDiamond(Color, FGradientColor, True);
  gsRectangle:    //`
    DrawGradRectangle(Color, FGradientColor, True);

  gsCheckerL:     //s͗liej
    DrawNoGradCheck(Color, FGradientColor, 64, False);
  gsCheckerM:     //s͗lij
    DrawNoGradCheck(Color, FGradientColor, 16, False);
  gsCheckerS:     //s͗liׁj
    DrawNoGradCheck(Color, FGradientColor, 4, False);
  gsMosaicL:      //UCNiej
    DrawNoGradCheck(Color, FGradientColor, 64, True);
  gsMosaicM:      //UCNij
    DrawNoGradCheck(Color, FGradientColor, 16, True);
  gsMosaicS:      //UCNiׁj
    DrawNoGradCheck(Color, FGradientColor, 4, True);

  gsClear:        //hԂiColorj
    DrawNoGradBrush(Color);
  gsSolid:        //hԂiGradientColorj
    DrawNoGradBrush(FGradientColor);
  else//gsNone    //
  end;
end;

//摜`s
procedure TTextureControl.DoDrawPicture(ACanvas: TCanvas; ARect: TRect);

  //䗦ێTCY
  function GetProportion(AWidth, AHeight: Integer): TRect;
  var
    nNewWidth, nNewHeight: Integer;
    fWZoom, fHZoom: Single;
  begin
    Result := Rect(0, 0, 0, 0);
    if (AWidth > 0)and(AHeight > 0) then
    begin
      nNewWidth := ARect.Right - ARect.Left;
      nNewHeight := ARect.Bottom - ARect.Top;
      fWZoom := nNewWidth / AWidth;
      fHZoom := nNewHeight / AHeight;
      if fWZoom > fHZoom then
      begin
        fWZoom := AWidth * fHZoom;
        fHZoom := AHeight * fHZoom;
      end
      else
      begin
        fHZoom := AHeight * fWZoom;
        fWZoom := AWidth * fWZoom;
      end;
      if (fWZoom > 0.0)and(fHZoom > 0.0) then
      begin
        nNewWidth := ARect.Left + ARect.Right;
        nNewHeight := ARect.Top + ARect.Bottom;
        Result := Rect(Trunc((nNewWidth - fWZoom) / 2),
                       Trunc((nNewHeight - fHZoom) / 2),
                       Trunc((nNewWidth + fWZoom) / 2),
                       Trunc((nNewHeight + fHZoom) / 2));
      end;
    end;
  end;

begin
  with ACanvas do
  begin
    if FPicture.Graphic <> nil then
    begin
      case FPictureLayout of
      plNormal:       //ʏiEj
        Draw(ARect.Left, ARect.Top, FPicture.Graphic);
      plCenter:       //ʏij
        Draw((ARect.Left + ARect.Right - FPicture.Graphic.Width) div 2,
             (ARect.Top + ARect.Bottom - FPicture.Graphic.Height) div 2,
             FPicture.Graphic);
      plProportional: //c䗦ێ
        StretchDraw(GetProportion(FPicture.Graphic.Width, FPicture.Graphic.Height), FPicture.Graphic);
      plStretch:      //c䗦
        StretchDraw(ARect, FPicture.Graphic);
      plPattern:      //wi~l߁irbg}bvj
        if FPicture.Graphic is TBitmap then
        try
          Brush.Bitmap := FPicture.Bitmap;
          FillRect(ARect);
        finally
          Brush.Bitmap := nil;
        end;
      end;
    end;
  end;
end;

//DoDrawBackBmp
procedure TTextureControl.DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect);
begin
  inherited;

  if (ARect.Right > ARect.Left)and(ARect.Bottom > ARect.Top) then
  begin
    //Of[V`
    DoDrawGradate(ACanvas, ARect);

    //摜`
    DoDrawPicture(ACanvas, ARect);
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// TTexturePanel                                                              //
////////////////////////////////////////////////////////////////////////////////

//Create
constructor TTexturePanel.Create(AOwner: TComponent);
begin
  inherited;
  ControlStyle := [csAcceptsControls, csCaptureMouse, csClickEvents,
    csSetCaption, csOpaque, csDoubleClicks, csReplicatable];
  Width := 185;
  Height := 41;
  FAlignment := taCenter;
  FVAlignment := taMiddle;
  FBevelOuter := bvRaised;
  FBevelWidth := 1;
  FBorderColor := clBtnFace;
  FBorderWidth := 0;
  FBorderStyle := bsNone;
  FFullRepaint := True;
  UseDockManager := True;
end;

//CreateParams
procedure TTexturePanel.CreateParams(var Params: TCreateParams);
begin
  inherited;
  with Params do
  begin
    WindowClass.style := WindowClass.style and not (CS_HREDRAW or CS_VREDRAW);
  end;
end;

//CMTextChanged
procedure TTexturePanel.CMTextChanged(var Message: TMessage);
begin
  Repaint;
end;

//CMIsToolControl
procedure TTexturePanel.CMIsToolControl(var Message: TMessage);
begin
  if not FLocked then Message.Result := 1;
end;

//CMDockClient
procedure TTexturePanel.CMDockClient(var Message: TCMDockClient);
var
  R: TRect;
  Dim: Integer;
begin
  if AutoSize then
  begin
    FAutoSizeDocking := True;
    try
      R := Message.DockSource.DockRect;
      case Align of
        alLeft: if Width = 0 then Width := R.Right - R.Left;
        alRight: if Width = 0 then
          begin
            Dim := R.Right - R.Left;
            SetBounds(Left - Dim, Top, Dim, Height);
          end;
        alTop: if Height = 0 then Height := R.Bottom - R.Top;
        alBottom: if Height = 0 then
          begin
            Dim := R.Bottom - R.Top;
            SetBounds(Left, Top - Dim, Width, Dim);
          end;
      end;
      inherited;
      Exit;
    finally
      FAutoSizeDocking := False;
    end;
  end;
  inherited;
end;

//WMWindowPosChanged
procedure TTexturePanel.WMWindowPosChanged(var Message: TWMWindowPosChanged);
var
  BevelPixels: Integer;
  Rect: TRect;
begin
  if FullRepaint or (Caption <> '') then
    Invalidate
  else
  begin
    BevelPixels := BorderWidth;
    if BevelInner <> bvNone then Inc(BevelPixels, BevelWidth);
    if BevelOuter <> bvNone then Inc(BevelPixels, BevelWidth);
    if BevelPixels > 0 then
    begin
      Rect.Right := Width;
      Rect.Bottom := Height;
      if Message.WindowPos^.cx <> Rect.Right then
      begin
        Rect.Top := 0;
        Rect.Left := Rect.Right - BevelPixels - 1;
        InvalidateRect(Handle, @Rect, True);
      end;
      if Message.WindowPos^.cy <> Rect.Bottom then
      begin
        Rect.Left := 0;
        Rect.Top := Rect.Bottom - BevelPixels - 1;
        InvalidateRect(Handle, @Rect, True);
      end;
    end;
  end;
  inherited;
end;

//DoDrawBackBmp
procedure TTexturePanel.DoDrawBackBmp(ACanvas: TCanvas; ARect: TRect);
const
  Alignments: array[TAlignment] of Longint = (DT_LEFT, DT_RIGHT, DT_CENTER);
var
  cTopColor, cBtmColor: TColor;
  nFontHeight: Integer;
  nFlags: Longint;

  //EFݒ
  procedure AdjustColors(Bevel: TPanelBevel);
  begin
    cTopColor := clBtnHighlight;
    if Bevel = bvLowered then cTopColor := clBtnShadow;
    cBtmColor := clBtnShadow;
    if Bevel = bvLowered then cBtmColor := clBtnHighlight;
  end;
begin
  //Oxx`
  if BevelOuter <> bvNone then
  begin
    AdjustColors(BevelOuter);
    Frame3D(ACanvas, ARect, cTopColor, cBtmColor, Self.BevelWidth);
  end;

  //E`
  Frame3D(ACanvas, ARect, FBorderColor, FBorderColor, Self.BorderWidth);

  //Oxx`
  if BevelInner <> bvNone then
  begin
    AdjustColors(BevelInner);
    Frame3D(ACanvas, ARect, cTopColor, cBtmColor, Self.BevelWidth);
  end;

  with ACanvas do
  begin
    Brush.Color := FBorderColor;
    FillRect(ARect);

    //Of[V`
    DoDrawGradate(ACanvas, ARect);

    //摜`
    DoDrawPicture(ACanvas, ARect);

    //LvV`
    Brush.Style := bsClear;
    Font := Self.Font;
    nFontHeight := TextHeight('W');
    with ARect do
    begin
      case FVAlignment of
      taTopJustify:
        Bottom := Top + nFontHeight;
      taBottomJustify:
        Top := Bottom - nFontHeight;
      else//taMiddle:
        Top := ((Bottom + Top) - nFontHeight) div 2;
        Bottom := Top + nFontHeight;
      end;
    end;
    nFlags := DT_EXPANDTABS or DT_VCENTER or Alignments[Self.Alignment];
    nFlags := DrawTextBiDiModeFlags(nFlags);
    DrawText(Handle, PChar(Caption), -1, ARect, nFlags);
  end;
end;

//SetAlignment
procedure TTexturePanel.SetAlignment(Value: TAlignment);
begin
  if FAlignment = Value then Exit;
  FAlignment := Value;
  Repaint;
end;

//SetVAlignment
procedure TTexturePanel.SetVAlignment(Value: TVAlignment);
begin
  if FVAlignment = Value then Exit;
  FVAlignment := Value;
  Repaint;
end;

//SetBevelInner
procedure TTexturePanel.SetBevelInner(Value: TPanelBevel);
begin
  if FBevelInner = Value then Exit;
  FBevelInner := Value;
  Realign;
  Repaint;
end;

//SetBevelOuter
procedure TTexturePanel.SetBevelOuter(Value: TPanelBevel);
begin
  if FBevelOuter = Value then Exit;
  FBevelOuter := Value;
  Realign;
  Repaint;
end;

//SetBevelWidth
procedure TTexturePanel.SetBevelWidth(Value: TBevelWidth);
begin
  if FBevelWidth = Value then Exit;
  FBevelWidth := Value;
  Realign;
  Repaint;
end;

//SetBorderColor
procedure TTexturePanel.SetBorderColor(const Value: TColor);
begin
  if FBorderColor = Value then Exit;
  FBorderColor := Value;
  Repaint;
end;

//SetBorderWidth
procedure TTexturePanel.SetBorderWidth(Value: TBorderWidth);
begin
  if FBorderWidth = Value then Exit;
  FBorderWidth := Value;
  Realign;
  Repaint;
end;

//GetControlsAlignment
function TTexturePanel.GetControlsAlignment: TAlignment;
begin
  Result := FAlignment;
end;

//AdjustClientRect
procedure TTexturePanel.AdjustClientRect(var Rect: TRect);
var
  BevelSize: Integer;
begin
  inherited;
  InflateRect(Rect, -BorderWidth, -BorderWidth);
  BevelSize := 0;
  if BevelOuter <> bvNone then Inc(BevelSize, BevelWidth);
  if BevelInner <> bvNone then Inc(BevelSize, BevelWidth);
  InflateRect(Rect, -BevelSize, -BevelSize);
end;

//CanAutoSize
function TTexturePanel.CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := (not FAutoSizeDocking) and inherited CanAutoSize(NewWidth, NewHeight);
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H


